// MIT License

// Copyright (c) 2024 Joao Chrisostomo

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

//!DESC ArtCNN C4F16 (Conv2D)
//!HOOK LUMA
//!BIND LUMA
//!SAVE conv2d_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0018689432, -0.012094381, -0.011144273, -0.06938418);
    result += vec4(-0.020989329, -0.16709405, 0.015771111, 0.010347125) * LUMA_texOff(vec2(-1, -1)).x;
    result += vec4(0.033658344, 0.1800454, 0.13569914, 0.1322191) * LUMA_texOff(vec2(0, -1)).x;
    result += vec4(0.0063243555, 0.0840489, -0.12951206, 0.051960927) * LUMA_texOff(vec2(1, -1)).x;
    result += vec4(0.015133863, 0.09906266, 0.03766245, 0.17433742) * LUMA_texOff(vec2(-1, 0)).x;
    result += vec4(-0.033576317, -0.072736226, -0.37578803, 0.3241274) * LUMA_texOff(vec2(0, 0)).x;
    result += vec4(-0.224204, -0.14103064, 0.14789833, 0.11175794) * LUMA_texOff(vec2(1, 0)).x;
    result += vec4(0.002351222, 0.16751051, -0.045227956, 0.09500898) * LUMA_texOff(vec2(-1, 1)).x;
    result += vec4(0.04798399, -0.1497008, 0.24314259, -0.044890083) * LUMA_texOff(vec2(0, 1)).x;
    result += vec4(0.18212885, 0.013893344, -0.032444946, 0.09600085) * LUMA_texOff(vec2(1, 1)).x;
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D)
//!HOOK LUMA
//!BIND LUMA
//!SAVE conv2d_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.03129763, -0.0049467376, 0.00037890198, -0.00013635434);
    result += vec4(0.09592724, -0.10194435, -0.0900127, 0.03374457) * LUMA_texOff(vec2(-1, -1)).x;
    result += vec4(-0.08230421, -0.014539967, 0.013489162, -0.21935785) * LUMA_texOff(vec2(0, -1)).x;
    result += vec4(0.07439707, 0.134547, 0.07296409, 0.17874344) * LUMA_texOff(vec2(1, -1)).x;
    result += vec4(-0.06252981, 0.101940714, 0.07085207, -0.0379011) * LUMA_texOff(vec2(-1, 0)).x;
    result += vec4(0.1163111, -0.20070547, 0.119351804, 0.20376374) * LUMA_texOff(vec2(0, 0)).x;
    result += vec4(-0.13869284, 0.27412337, -0.18156466, -0.15480605) * LUMA_texOff(vec2(1, 0)).x;
    result += vec4(0.06742909, 0.0010298961, 0.025103793, 0.000714324) * LUMA_texOff(vec2(-1, 1)).x;
    result += vec4(0.08326273, -0.26306987, -0.13020906, 0.02377169) * LUMA_texOff(vec2(0, 1)).x;
    result += vec4(-0.09263031, 0.07067653, 0.09775801, -0.028085424) * LUMA_texOff(vec2(1, 1)).x;
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D)
//!HOOK LUMA
//!BIND LUMA
//!SAVE conv2d_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.029776718, -0.0011096202, -0.007366339, 0.0018483452);
    result += vec4(-0.070672095, 0.118226334, -0.16407724, -0.052765083) * LUMA_texOff(vec2(-1, -1)).x;
    result += vec4(0.12421098, -0.02475437, 0.16593158, 0.0076461905) * LUMA_texOff(vec2(0, -1)).x;
    result += vec4(0.08242352, -0.014138544, 0.0057303896, 0.020100795) * LUMA_texOff(vec2(1, -1)).x;
    result += vec4(-0.20809816, 0.3488407, 0.36273316, 0.1306535) * LUMA_texOff(vec2(-1, 0)).x;
    result += vec4(-0.34617552, -0.8206443, -0.32715708, -0.102082044) * LUMA_texOff(vec2(0, 0)).x;
    result += vec4(0.19362049, 0.1689205, -0.05972561, -0.0019502251) * LUMA_texOff(vec2(1, 0)).x;
    result += vec4(0.057871062, 0.10961987, -0.15784252, -0.059899677) * LUMA_texOff(vec2(-1, 1)).x;
    result += vec4(0.27436438, 0.11876813, 0.14584053, 0.1195842) * LUMA_texOff(vec2(0, 1)).x;
    result += vec4(-0.18614744, -0.014668433, 0.029564941, -0.05947655) * LUMA_texOff(vec2(1, 1)).x;
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D)
//!HOOK LUMA
//!BIND LUMA
//!SAVE conv2d_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0003382082, -0.00601378, 0.012577824, -0.05622743);
    result += vec4(0.07923513, -0.124057494, 0.24102478, -0.114168674) * LUMA_texOff(vec2(-1, -1)).x;
    result += vec4(-0.19048533, 0.19942974, 0.42362782, 0.21932925) * LUMA_texOff(vec2(0, -1)).x;
    result += vec4(0.0148091, -0.051743113, 0.0558839, 0.043352813) * LUMA_texOff(vec2(1, -1)).x;
    result += vec4(0.042809583, 0.009303409, 0.047089607, -0.2489604) * LUMA_texOff(vec2(-1, 0)).x;
    result += vec4(0.014582089, -0.14984143, -0.4934937, -0.0067877816) * LUMA_texOff(vec2(0, 0)).x;
    result += vec4(0.037161533, 0.14714734, -0.17489892, 0.23928997) * LUMA_texOff(vec2(1, 0)).x;
    result += vec4(-0.08136748, 0.126604, -0.05542742, -0.10161853) * LUMA_texOff(vec2(-1, 1)).x;
    result += vec4(0.11775075, -0.06662411, -0.16556169, -0.014515711) * LUMA_texOff(vec2(0, 1)).x;
    result += vec4(-0.026951507, -0.088610075, 0.019072657, 0.14854541) * LUMA_texOff(vec2(1, 1)).x;
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D-1-ReLU)
//!HOOK LUMA
//!BIND conv2d_0
//!BIND conv2d_1
//!BIND conv2d_2
//!BIND conv2d_3
//!SAVE conv2d_1_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.0057315477, 0.01220551, 0.11268519, 0.010119512);
    result += mat4(-0.024125284, 0.36053768, -0.030539824, 0.035363108, 0.12882878, 0.08826568, 0.060933016, -0.048655245, -0.3886084, 0.2297383, -0.064356364, -0.10607676, 0.0015154631, -0.074405886, -0.1735875, 0.028058795) * conv2d_0_texOff(vec2(-1, -1));
    result += mat4(-0.3591389, -0.02228957, 0.019103048, 0.030545495, 0.7363539, 0.19943573, -0.027262723, 0.045700975, -0.7715932, -0.71260315, -0.07698792, -0.109657556, -0.468773, 0.14117427, 0.045736052, 0.12886085) * conv2d_0_texOff(vec2(0, -1));
    result += mat4(0.46435255, -0.06340062, 0.13351502, -0.022015005, 0.15575479, -0.19134845, 0.15665053, -0.08261642, -0.40047666, -0.03649157, -0.050916918, 0.07168185, -0.112634145, -0.009801637, -0.11435762, -0.08838922) * conv2d_0_texOff(vec2(1, -1));
    result += mat4(-0.21300979, -0.069170155, -0.02524457, -0.1792958, -0.22457322, 0.01006355, 0.26727438, -0.20305517, 0.28302082, 0.22752848, 0.025560293, 0.05104237, 0.031250015, 0.108551264, -0.01904287, 0.02984452) * conv2d_0_texOff(vec2(-1, 0));
    result += mat4(-0.17580287, -0.14883621, -0.030504456, -0.110506296, -0.5622948, 0.4384959, 0.05334467, -0.06946785, -0.4926711, 0.8758044, -0.024123, -0.44123098, 0.04350575, 0.047474507, 0.14530358, 0.15756041) * conv2d_0_texOff(vec2(0, 0));
    result += mat4(-0.508724, 0.060124543, -0.04563769, -0.08443593, -0.48120773, -0.08363192, -0.08252335, -0.006836714, 0.14194596, 0.22977303, 0.112781405, -0.1589584, -0.06930605, 0.090879895, 0.07769318, 0.043749176) * conv2d_0_texOff(vec2(1, 0));
    result += mat4(0.10299622, 0.065383464, -0.0010502158, 0.31116176, -0.11323491, -0.20453365, -0.027721914, 0.36969325, 0.37734175, -0.28494865, 0.057950113, -0.15477203, -0.06443423, -0.08688062, -0.14106219, -0.026969748) * conv2d_0_texOff(vec2(-1, 1));
    result += mat4(0.0014009404, 0.014462154, 0.012889582, 0.095769934, 0.10253242, 0.038002186, -0.040959027, 0.4664637, 0.3797086, -0.20613511, -0.22395512, 1.0037909, -0.0013836621, -0.061494213, -0.06638549, 0.02878929) * conv2d_0_texOff(vec2(0, 1));
    result += mat4(-0.2756583, -0.021280238, -0.04133801, -0.02203378, 0.21983331, -0.29612616, -0.13481463, -0.15271369, 0.060368173, -0.15818107, 0.11625302, -0.13463797, 0.05316618, -0.09786038, 0.06327927, -0.10335609) * conv2d_0_texOff(vec2(1, 1));
    result += mat4(1.1077415, -0.065767325, -0.01755528, 0.060675096, -0.36396834, 0.071841866, 0.28213823, -0.024151051, -0.9988663, 0.59361684, -0.0705869, -0.03505334, -0.50420004, 0.5739408, -0.05193463, -0.02202797) * conv2d_1_texOff(vec2(-1, -1));
    result += mat4(-0.37710333, 0.19944099, 0.13706273, -0.0294321, 0.6862174, -0.43811744, -0.007293717, -0.30079582, 0.9999391, -0.20132875, -0.010582445, -0.04023016, -0.33132914, -0.092500106, -0.14949891, 0.012947441) * conv2d_1_texOff(vec2(0, -1));
    result += mat4(0.4051968, 0.2762725, -0.0135955345, 0.063499406, 0.18378362, 0.022674192, 0.0566514, 0.03361189, -0.57209355, -0.18554153, 0.08746101, 0.24102001, -0.06631122, -0.10200225, -0.2513701, -0.040302496) * conv2d_1_texOff(vec2(1, -1));
    result += mat4(-0.41693354, -0.14076684, 0.11589063, -0.08162623, -0.16735734, 0.06367048, -0.16926739, 0.016047915, -0.012660883, -0.34816912, -0.06116311, 0.19753619, -0.42275375, 0.44595027, 0.09055507, 0.21647257) * conv2d_1_texOff(vec2(-1, 0));
    result += mat4(0.1959109, -0.40126458, 0.19069786, 0.098184645, -0.120232716, 0.35108244, 0.003952669, 0.08890963, -0.09739605, 0.22175273, 0.27652043, -0.2016377, 0.9154882, -0.9393635, -0.10989167, 0.26551166) * conv2d_1_texOff(vec2(0, 0));
    result += mat4(-0.22338384, 0.1258025, -0.10516795, -0.143951, -0.30218482, -0.084651746, -0.20122004, 0.113071755, -0.017162202, 0.08726622, -0.074338585, -0.26985937, 0.5384228, 0.48544407, -0.019839466, 0.1563062) * conv2d_1_texOff(vec2(1, 0));
    result += mat4(0.07144698, 0.1489373, 0.020278584, 0.15969415, 0.15143564, -0.20653132, -0.016936544, 0.0485964, 0.41017503, 0.052133057, -0.31803653, -0.05361299, -0.036990035, 0.054179795, -0.18697025, 0.33939344) * conv2d_1_texOff(vec2(-1, 1));
    result += mat4(0.14244588, -0.036040064, 0.21871537, -0.24817806, 0.056411527, 0.021156125, -0.062362, 0.22841144, -0.07274309, -0.0068549607, 0.12304488, 0.29829216, -0.12225985, 0.06359026, 0.4262198, -0.93852407) * conv2d_1_texOff(vec2(0, 1));
    result += mat4(-0.17561492, 0.1675631, -0.19665031, 0.01962083, 0.22865003, 0.039168496, -0.06645757, -0.20563303, 0.2972279, -0.34498563, 0.07087315, -0.026137834, -0.09257305, -0.38137805, 0.2249325, -0.19514605) * conv2d_1_texOff(vec2(1, 1));
    result += mat4(0.07291842, -0.16297379, -0.09821364, 0.00984802, -0.19477488, 0.2346158, 0.041234028, -0.12936807, 0.43639454, 0.2169685, 0.08141137, -0.033651084, 1.1044608, 0.09923805, 0.038863584, -0.021070214) * conv2d_2_texOff(vec2(-1, -1));
    result += mat4(-0.70921695, -0.2968588, -0.11130795, 0.085045874, -0.07077363, -0.5917506, 0.009046129, -0.04996687, 0.0062803496, -0.4849014, 0.05720417, 0.057956517, -1.3103348, -0.09619535, 0.06294816, 0.11963625) * conv2d_2_texOff(vec2(0, -1));
    result += mat4(-0.35520667, 0.07030486, 0.08129326, -0.00017009811, -0.27802485, 0.18322131, 0.056435984, -0.035469774, -1.016923, -0.19861908, -0.14549735, -0.03570727, 0.42990553, 0.15874285, 0.07398051, -0.032362957) * conv2d_2_texOff(vec2(1, -1));
    result += mat4(0.103218086, 0.30208942, -0.091227196, -0.07436102, 0.24447371, 0.06551555, -0.14528611, -0.016993651, 0.08139388, -0.19716902, 0.15390721, -0.15553702, -0.29847378, 0.039158564, 0.16514164, -0.05630444) * conv2d_2_texOff(vec2(-1, 0));
    result += mat4(-0.10350748, 0.59938335, 0.08224635, -0.39390093, -0.048800346, 0.25220042, 0.27965719, -0.7149586, -0.117753714, 0.89318556, 0.10694615, -0.40107867, 0.3126249, 0.20058535, -0.26210746, -0.21957305) * conv2d_2_texOff(vec2(0, 0));
    result += mat4(-0.15874729, 0.2735882, 0.1038441, -0.028996622, 0.18262653, -0.11277957, -0.09065718, -0.12505332, 0.014910041, -0.30493712, -0.06908394, 0.15140194, -0.053679354, -0.04235772, -0.066772215, -0.0788772) * conv2d_2_texOff(vec2(1, 0));
    result += mat4(0.18722679, 0.022233652, -0.28068626, 0.1564011, 0.052735806, -0.024578447, 0.055972375, 0.023434438, -0.015232564, -0.11003659, -0.02958382, 0.07606593, -0.16451985, 0.05277438, -0.15513985, 0.20419632) * conv2d_2_texOff(vec2(-1, 1));
    result += mat4(-0.44324756, 0.06180463, -0.19807127, 0.8873653, -0.28618175, 0.22352956, 0.11273026, 0.4716805, 0.0895035, -0.056281384, -0.17583643, 0.48653698, 0.23335673, -0.33337352, 0.18437086, -0.07844706) * conv2d_2_texOff(vec2(0, 1));
    result += mat4(0.10640872, -0.21415141, 0.058799107, -0.08614742, -0.08880996, 0.11127377, 0.06347164, 0.2256829, 0.22119509, -0.01713325, 0.061465573, -0.08665336, -0.1289203, -0.16052137, -0.038039066, 0.082929656) * conv2d_2_texOff(vec2(1, 1));
    result += mat4(0.48343894, -0.070697255, 0.16088535, -0.049593706, 0.7289105, -0.37932575, 0.17126024, -0.0018209993, 0.13588835, 0.000733389, 0.09432972, 0.008547268, 0.022721222, 0.20453632, 0.0046762694, -0.0052664373) * conv2d_3_texOff(vec2(-1, -1));
    result += mat4(-0.35105914, -0.059789762, 0.0025750978, 0.09753049, -0.48997068, 0.28137153, 0.037127644, 0.024901079, 0.24922512, -0.14859363, -0.05524299, -0.037807938, 0.066167325, -0.14446808, 0.025121788, -0.026967036) * conv2d_3_texOff(vec2(0, -1));
    result += mat4(0.31942683, 0.067160465, 0.049225427, -0.10680461, 0.46816394, -0.22563934, 0.19540606, -0.10584391, -0.09178188, 0.05149975, -0.0010295778, 0.026105061, 0.4168506, -0.056370676, 0.10088538, -0.0026953747) * conv2d_3_texOff(vec2(1, -1));
    result += mat4(-0.116989516, -0.053696584, 0.04436822, 0.026163863, 0.29693225, -0.019489178, -0.053970225, -0.05598454, -0.27940547, 0.17396632, 0.0052333605, -0.04871796, 0.023473052, -0.07443703, 0.010630465, -0.09411582) * conv2d_3_texOff(vec2(-1, 0));
    result += mat4(0.1903902, -0.225679, 0.107205056, 0.048262734, -0.4323833, 0.5121899, -0.0021411914, 0.089033075, -0.53095746, 0.6508796, 0.05552415, 0.01372532, -0.22403194, 0.11387373, 0.09417494, 0.085450724) * conv2d_3_texOff(vec2(0, 0));
    result += mat4(0.109713174, -0.12878585, -0.15289974, 0.06266312, -0.5393066, -0.09059529, -0.21852681, -0.10893665, 0.008127227, 0.23362394, 0.01760005, 0.16698825, -0.2058406, 0.16153622, 0.09917509, 0.0061361874) * conv2d_3_texOff(vec2(1, 0));
    result += mat4(-0.0812119, 0.015507757, -0.04380506, 0.040541146, -0.20703554, 0.19549869, 0.16456963, -0.10641857, -0.14982757, -0.19207758, -0.07521612, 0.36622483, -0.08804933, 0.07587366, 0.048089113, 0.12791353) * conv2d_3_texOff(vec2(-1, 1));
    result += mat4(0.10483639, 0.07315888, 0.052412137, -0.6182126, 0.11304849, -0.17139891, -0.065931834, 0.3703708, 0.3798335, -0.007348117, -0.1534934, 1.8182076, -0.015534727, 0.090940274, -0.019033115, 0.44617748) * conv2d_3_texOff(vec2(0, 1));
    result += mat4(-0.026784025, 0.04566704, -0.07920087, -0.16164441, 0.08522715, -0.084198974, -0.16052303, 0.04330756, -0.30104852, -0.028167121, 0.073713526, 0.2923644, -0.08894674, 0.020327676, -0.08958633, 0.22356156) * conv2d_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-1-ReLU)
//!HOOK LUMA
//!BIND conv2d_0
//!BIND conv2d_1
//!BIND conv2d_2
//!BIND conv2d_3
//!SAVE conv2d_1_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.042684413, -0.011012326, -0.00878685, 0.010643135);
    result += mat4(-0.18877415, -0.09089855, 0.0072896937, 0.23530912, -0.0934211, -0.069338076, -0.00844786, 0.05497638, 0.059132297, -0.07186099, -0.005284089, 0.009240251, 0.07578471, -0.0729261, -0.07486577, -0.16516358) * conv2d_0_texOff(vec2(-1, -1));
    result += mat4(0.086664684, -0.060442384, 0.14914125, -0.07955809, -0.23829828, 0.21308875, 0.23503913, 0.090339616, -0.081017, -0.06103283, -0.016862804, 0.0008293084, 0.15803167, -0.06516947, -0.13736767, -0.052404165) * conv2d_0_texOff(vec2(0, -1));
    result += mat4(0.054891616, 0.08749097, 0.050384633, -0.119466245, -0.090476185, 0.30954581, -0.029950086, -0.016718058, -0.027244521, 0.15839703, -0.08564877, 0.15285009, -0.15158606, -0.046746027, -0.07667917, 0.19473897) * conv2d_0_texOff(vec2(1, -1));
    result += mat4(-0.012178883, 0.17008278, -0.07437466, 0.53128177, -0.0515155, -0.07002471, 0.2232988, 0.24204443, -0.05825628, 0.27219185, -0.020577984, 0.08120503, 0.06512096, -0.064028285, -0.043698058, -0.14570558) * conv2d_0_texOff(vec2(-1, 0));
    result += mat4(0.18037078, -0.20733012, 0.2710155, -0.058456894, 0.181085, -0.30579567, -0.03612736, -0.04797417, -0.15321401, 0.25708416, 1.059432, -0.085225135, 0.21254273, 0.099770375, -0.13315867, -0.10311383) * conv2d_0_texOff(vec2(0, 0));
    result += mat4(0.25094235, -0.1702486, -0.057454593, -0.13899079, -0.048523817, -0.20154843, 0.30220234, -0.068558194, 0.5210809, -0.16537571, 0.14300114, 0.074582025, -0.23821272, 0.12164076, -0.04001619, 0.032253567) * conv2d_0_texOff(vec2(1, 0));
    result += mat4(0.080706015, 0.006069105, -0.043602843, -0.24529675, 0.19590034, -0.5448352, -0.2049945, -0.09720787, 0.15580839, 0.009218637, -0.09142852, 0.23706423, -0.04794372, -0.06749567, 0.1628039, -0.05698579) * conv2d_0_texOff(vec2(-1, 1));
    result += mat4(0.056656748, -0.08213934, -0.112287894, -0.0531863, 0.057146437, -0.0058343536, -0.5406026, -0.33009425, -0.0053697345, -0.4517388, -0.748217, -0.20385133, 0.09021538, 0.07225, 0.11318475, 0.096350536) * conv2d_0_texOff(vec2(0, 1));
    result += mat4(0.1585303, -0.040510405, -0.020871915, -0.00038907313, -0.021032648, 0.089684114, -0.036921874, -0.053368293, 0.019662771, -0.12807742, -0.122671105, -0.103924304, -0.13174331, -0.13978162, 0.08677558, 0.12760891) * conv2d_0_texOff(vec2(1, 1));
    result += mat4(-0.34248176, -0.21929976, 0.030525431, -7.675433e-05, 0.4265894, 0.5602678, 0.11240546, 0.1059129, 0.17999111, 0.025918394, 0.107080884, -0.20786646, 0.073234364, 0.02878518, -0.31199798, -0.18550326) * conv2d_1_texOff(vec2(-1, -1));
    result += mat4(0.103012756, 0.074931584, -0.039766394, -0.030197302, -0.25416622, 0.18078984, 0.21822192, -0.116703406, 0.06921031, 0.079845265, 0.24874577, 0.31231636, 0.10445854, -0.20399132, -0.011794116, 0.0140210185) * conv2d_1_texOff(vec2(0, -1));
    result += mat4(0.049203794, 0.07172215, 0.1506995, -0.09819289, -0.012719105, -0.056659713, 0.14108194, 0.0167015, -0.13591777, 0.3502316, -0.33868587, 0.057392195, 0.13970143, -0.08607497, -0.07254006, 0.006505547) * conv2d_1_texOff(vec2(1, -1));
    result += mat4(0.06500739, -0.74012697, 0.03630281, -0.36312285, 0.14175233, 0.55949175, 0.065657765, 0.41448808, -0.027200164, -0.19148263, -0.072313, 0.16467366, -0.26292518, -0.51554716, -0.036916472, -0.44660598) * conv2d_1_texOff(vec2(-1, 0));
    result += mat4(0.36956754, 0.087223426, -0.17320322, 0.21999256, -0.31813338, 0.033125285, -0.18078679, -0.37580523, 0.0821921, -0.22686213, -0.3172341, -0.318797, 0.15096942, 0.014306216, -0.19709918, 0.116944216) * conv2d_1_texOff(vec2(0, 0));
    result += mat4(0.22070698, 0.07090989, 0.17592424, -0.002525239, -0.1320958, 0.07624054, 0.029854959, -0.1979614, -0.04178435, -0.2413084, 0.20388415, 0.15332823, 0.12596431, 0.10260472, -0.17990524, -0.05434134) * conv2d_1_texOff(vec2(1, 0));
    result += mat4(-0.15684433, -0.4854914, -0.09233601, -0.30180347, 0.39937276, 0.4657899, -0.16956586, 1.030501, -0.24533887, -0.08811991, -0.079179004, 0.014807613, 0.26631412, 0.13310678, -0.116129935, 0.46574318) * conv2d_1_texOff(vec2(-1, 1));
    result += mat4(0.07484563, 0.09698919, 0.17581323, 0.27939773, -0.13028108, -0.10737197, -0.44417876, -0.15595461, 0.257421, 0.116753645, 0.07980903, -0.33705282, 0.038941532, 0.6485781, 0.7868257, 0.1995149) * conv2d_1_texOff(vec2(0, 1));
    result += mat4(0.21839814, -0.03372764, -0.24461545, -0.18122116, -0.24002214, 0.13982645, -0.044762775, 0.019324707, -0.04589858, 0.13805042, 0.1778199, 0.05064652, -0.46937785, -0.10375061, 0.26871073, 0.0696916) * conv2d_1_texOff(vec2(1, 1));
    result += mat4(-0.13568732, -0.106092565, -0.21927467, -0.15822773, 0.28233737, 0.45551702, 0.10693086, 0.119410165, -0.11696885, 0.10171857, 0.11723151, 0.11159596, -0.25990444, -0.0062499074, -0.17780681, 0.2567076) * conv2d_2_texOff(vec2(-1, -1));
    result += mat4(-0.120573916, 0.15209089, 0.055111933, 0.06389469, 0.10824278, 0.21931078, 0.28788117, -0.13949794, 0.09850267, -0.15773058, -0.15258087, -0.083398834, 0.094938815, 0.12931266, -0.17891638, -0.12831962) * conv2d_2_texOff(vec2(0, -1));
    result += mat4(-0.012593621, 0.03300292, -0.10723861, 0.04638058, -0.111301094, 0.22043815, -0.08769318, -0.03394287, -0.20468459, -0.3699484, 0.2761041, 0.10903282, -0.05533663, -0.32657585, 0.2694521, -0.10749484) * conv2d_2_texOff(vec2(1, -1));
    result += mat4(0.08490274, 0.23498255, 0.025883486, -0.25052404, 0.2577379, 0.32781178, -0.050873265, -0.22516817, -0.10767229, 0.21484302, 0.06051844, 0.42270836, 0.09445311, 0.26408613, 0.08932983, -0.41040573) * conv2d_2_texOff(vec2(-1, 0));
    result += mat4(-0.11888232, 0.51565516, 0.98010385, -0.070471026, -0.10833566, -0.030997436, 1.0866784, -0.10508088, 0.16110322, 0.26380956, 0.29791, -0.4409, 0.101448074, 0.05394716, 0.43578124, 0.426638) * conv2d_2_texOff(vec2(0, 0));
    result += mat4(0.42438215, -0.03568884, 0.028488673, 0.14208244, -0.3318944, -0.06086438, 0.19113962, -0.104261704, -0.34867382, 0.37454316, 0.334689, 0.3159271, -0.104952864, -0.120030195, -0.18673395, 0.06282467) * conv2d_2_texOff(vec2(1, 0));
    result += mat4(0.24995266, -0.13024196, -0.16221951, 0.64011955, 0.14663237, 0.58979195, -0.20226134, 0.81777024, -0.21020728, -0.11317864, -0.17783621, 0.06665261, 0.09197215, -0.5106811, -0.06720402, 0.047960356) * conv2d_2_texOff(vec2(-1, 1));
    result += mat4(-0.14750536, -0.31305456, -0.5481949, -0.02960463, 0.17321745, -0.11975349, -0.65630126, -0.22410828, 0.5968887, 0.027587451, -0.49452603, -0.68383557, 0.06896839, 0.45890525, -0.22186859, -0.40536952) * conv2d_2_texOff(vec2(0, 1));
    result += mat4(0.20609516, -0.32626727, 0.06516236, 0.13309792, -0.26393035, -0.11567936, -0.17126624, 0.053105533, -0.20889923, -0.50112075, -0.21295664, 0.036774855, -0.043113127, -0.03371433, 0.07375633, 0.19406794) * conv2d_2_texOff(vec2(1, 1));
    result += mat4(0.061121877, 0.037276052, 0.1130368, 0.05436823, -0.18429157, -0.012286745, 0.13081616, 0.15044783, -0.10166003, 0.20361146, 0.13389264, 0.10735191, 0.06705255, 0.07630251, 0.08154733, -0.051773977) * conv2d_3_texOff(vec2(-1, -1));
    result += mat4(-0.14064261, -0.05052008, -0.21792558, -0.04410059, 0.094330266, 0.15968044, 0.05657469, 0.2243525, 0.07220332, -0.23886485, -0.10146681, -0.059583884, -0.30985904, -0.13847038, 0.0109924665, 0.09774365) * conv2d_3_texOff(vec2(0, -1));
    result += mat4(-0.2406376, -0.08432054, 0.14264664, -0.021276113, -0.14803958, 0.046054825, 0.052287586, -0.16277425, 0.084093966, -0.09600658, -0.0129503645, -0.019426676, 0.22165707, -0.00573521, -0.051088274, -0.11208299) * conv2d_3_texOff(vec2(1, -1));
    result += mat4(-0.014409513, 0.113497645, -0.08352071, -0.08350037, 0.29228833, 0.053919405, 0.1734141, -0.43326563, -0.3636163, 0.18959105, 0.0023319167, 0.38501248, 0.22685541, 0.52842164, 0.005780101, 0.5240569) * conv2d_3_texOff(vec2(-1, 0));
    result += mat4(0.008386494, 0.09792959, -0.010207071, 0.07135685, -0.04762849, -0.09443096, 0.012653251, 0.28703403, -0.014785405, -0.013921215, -0.15590096, -0.24354817, -0.37500665, -0.032967243, -0.023880795, 0.079548284) * conv2d_3_texOff(vec2(0, 0));
    result += mat4(0.047161955, -0.05536646, 0.00035768983, -0.07580358, -0.06745932, -0.35445455, 0.05479217, -0.072217174, -0.05909403, -0.061273668, 0.06486499, -0.08487081, 0.53124475, -0.014735263, 0.0786832, -0.036877662) * conv2d_3_texOff(vec2(1, 0));
    result += mat4(0.3745718, 0.25916216, 0.04465985, 0.073294535, -0.09536068, 0.2898998, -0.10304361, 0.24102606, -0.027329333, -0.9500066, -0.2993579, 0.34180617, 0.18839954, 0.1711666, -0.15225923, 0.4754349) * conv2d_3_texOff(vec2(-1, 1));
    result += mat4(0.05950132, 0.30065987, 0.4143196, 0.078852095, -0.18605408, -0.15637799, -0.28726384, -0.349723, 0.64332765, -0.70423985, -1.2837317, -0.29586196, -0.3326011, -0.19303136, -0.15985888, -0.019432714) * conv2d_3_texOff(vec2(0, 1));
    result += mat4(-0.25563973, -0.031667903, 0.1498073, 0.01776562, 0.030108826, 0.06960039, -0.07138435, -0.005732488, 0.098876484, -0.32655704, -0.2969346, -0.08772628, 0.28227258, -0.19020355, -0.123977184, -0.05686878) * conv2d_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-1-ReLU)
//!HOOK LUMA
//!BIND conv2d_0
//!BIND conv2d_1
//!BIND conv2d_2
//!BIND conv2d_3
//!SAVE conv2d_1_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.012058452, 0.035459418, 0.0020235123, 0.02138105);
    result += mat4(-0.27048945, -0.15216513, -0.56439227, -0.72569335, 0.06902982, -0.124421865, -0.0028085725, -0.46687803, -0.27972996, -0.30724597, 0.36219263, -0.32720062, 0.01755325, -0.11166817, 0.041267466, 0.050279096) * conv2d_0_texOff(vec2(-1, -1));
    result += mat4(0.123987, 0.0635712, 0.1900054, 0.1515304, 0.010567942, -0.016811093, 0.06286553, -0.17851111, 0.1753958, 0.21771027, 0.08844965, -0.56422937, 0.0749339, 0.1462589, -0.07169983, -0.12169353) * conv2d_0_texOff(vec2(0, -1));
    result += mat4(0.13043118, 0.38533115, -0.08687753, -0.098886535, 0.020644201, 0.14750102, 0.12408261, -0.41414288, -0.039991155, 0.24843374, -0.33877984, -0.21652898, -0.06514563, -0.20232098, -0.13754359, -0.029486215) * conv2d_0_texOff(vec2(1, -1));
    result += mat4(-0.10021081, -0.1358276, 0.6510585, -0.1789248, 0.0530571, -0.21948235, 0.4442679, -0.21620616, -0.09634525, -0.1523073, -0.61563313, 0.50299287, 0.09090999, 0.10945205, -0.04221829, 0.11210599) * conv2d_0_texOff(vec2(-1, 0));
    result += mat4(-0.13971923, 0.036167882, 0.16633019, 0.13758305, -0.14243245, 0.13257267, 0.22588421, 0.077722326, -0.496797, -0.06929072, 0.14952676, 0.16488895, 0.29225838, 0.11251328, 0.161039, 0.09794535) * conv2d_0_texOff(vec2(0, 0));
    result += mat4(-0.2226956, -0.0019855483, 0.25955975, -0.02854396, -0.09928865, 0.42465854, -0.049392145, 0.16713408, -0.07152766, 0.2951388, -0.07461576, 0.20836486, 0.1249179, -0.03861313, 0.11316237, 0.19167934) * conv2d_0_texOff(vec2(1, 0));
    result += mat4(-0.17385809, 0.008925299, -0.387115, 0.19814822, 0.1263724, -0.05977668, -0.54597026, 0.49932623, -0.022810824, 0.03269762, 0.59250075, -0.007137566, -0.08911065, -0.03264151, -0.0033877613, -0.11269822) * conv2d_0_texOff(vec2(-1, 1));
    result += mat4(0.13175856, -0.0764686, 0.08803108, 0.1433389, 0.45028248, 0.09578076, -0.11786847, 0.16706738, 0.60061747, 0.027031219, 0.026740124, 0.035115507, -0.24601386, 0.14495645, -0.03162993, -0.17910877) * conv2d_0_texOff(vec2(0, 1));
    result += mat4(-0.006928952, 0.1629482, -0.114114836, -0.068467826, -0.042800624, 0.10178578, -0.19198069, 0.081305355, -0.010695266, -0.13109359, -0.18033825, -0.076629326, -0.08399564, -0.10613263, -0.04830894, -0.07337152) * conv2d_0_texOff(vec2(1, 1));
    result += mat4(-0.0892244, 0.047263846, 0.73766726, -0.5480812, 0.28793567, 0.15710412, -0.32357463, 0.6721122, -0.1833216, -0.08243846, -1.0102098, -0.23818539, 0.051962975, -0.11682391, 0.42990884, -0.80880654) * conv2d_1_texOff(vec2(-1, -1));
    result += mat4(-0.055735633, 0.10928957, 0.16485757, -0.041874524, -0.12380668, -0.27412575, 0.062253665, -0.24108793, -0.26011714, 0.1858366, 0.34453288, 0.16818003, -0.1146422, -0.08572841, -0.110089466, -0.0513213) * conv2d_1_texOff(vec2(0, -1));
    result += mat4(0.009881801, -0.05057188, 0.3933309, -0.11649382, 0.0070847427, 0.052101552, 0.1456722, -0.023981981, 0.20509958, -0.10847739, -0.19705199, 0.26608458, 0.10968863, 0.029413933, -0.1456579, 0.4807913) * conv2d_1_texOff(vec2(1, -1));
    result += mat4(-0.38067463, -0.04243029, -0.3925418, -0.42448673, 0.26709786, 0.059117507, 0.026020754, 0.5621717, 0.2119238, -0.11214634, 1.4102949, -0.12251065, -0.5040687, -0.09616722, 0.76216185, 0.25918564) * conv2d_1_texOff(vec2(-1, 0));
    result += mat4(-0.04778037, 0.25219002, -0.4696615, -0.22104095, -0.05839358, -0.2547952, 0.015254039, 0.06160808, 0.4099829, -0.092901774, 0.40927598, -0.02063658, 0.21946512, -0.0024611873, -0.30187133, -0.49522907) * conv2d_1_texOff(vec2(0, 0));
    result += mat4(-0.033961415, -0.17669849, -0.2705705, -0.037797462, 0.11113812, 0.25503772, 0.11605272, -0.12802775, 0.00088775234, 0.26074794, 0.15172206, 0.08769989, -0.11901896, 0.07713709, -0.039179455, 0.43932754) * conv2d_1_texOff(vec2(1, 0));
    result += mat4(-0.14061785, -0.19862945, 0.100173995, -0.13494575, 0.3124522, -0.10799204, -0.030452548, 0.5401654, -0.05634719, -0.015557984, -1.4267026, -0.044390813, 0.8323417, -0.37981972, -0.86465156, -0.5436853) * conv2d_1_texOff(vec2(-1, 1));
    result += mat4(0.2967579, 0.029478623, 0.019859063, 0.31079462, 0.21380939, -0.22567141, -0.18742774, 0.20253386, -0.12506099, 0.0070204637, 0.21994108, -0.053757507, -0.29969767, 0.3646486, 0.32239926, -0.015044463) * conv2d_1_texOff(vec2(0, 1));
    result += mat4(-0.029350266, 0.0402756, -0.061346106, 0.20011136, -0.07884663, -0.10585681, -0.10629222, 0.018422162, -0.14510909, 0.1292288, 0.099847905, 0.0203754, -0.113875575, 0.13771832, 0.0040402007, 0.4012859) * conv2d_1_texOff(vec2(1, 1));
    result += mat4(-0.099291615, -0.057911653, 0.41263682, -0.19909443, 0.0036022263, 0.100471996, 0.18956554, -0.28363618, 0.043008607, 0.0035231092, 0.52729076, -0.09314525, -0.06949709, 0.02968905, 1.0775689, -0.77997947) * conv2d_2_texOff(vec2(-1, -1));
    result += mat4(0.24712528, -0.10583815, 0.37779632, -1.077764, 0.16624779, -0.022670645, 0.06552302, -0.2871312, 0.10898993, -0.187577, -0.533865, 0.7048716, 0.0812303, 0.049407665, -0.54117566, 0.42726758) * conv2d_2_texOff(vec2(0, -1));
    result += mat4(0.09352304, -0.06986354, -0.25987706, -0.048131682, -0.04950373, 0.009200149, -0.1436869, 0.049079474, -0.0481729, 0.097965464, -0.4278237, -0.8274962, -0.01191229, -0.14893481, -0.11789976, -0.19409682) * conv2d_2_texOff(vec2(1, -1));
    result += mat4(0.011703021, -0.09205684, -0.27635732, 0.69008315, -0.18548134, 0.059267413, -0.22924715, 0.68566036, -0.16586253, 0.07831387, 0.37324068, 0.19373812, -0.07427127, 0.01235896, -0.2959704, -0.17499664) * conv2d_2_texOff(vec2(-1, 0));
    result += mat4(-0.35970524, -0.19255517, 0.04412487, 0.0052177566, -0.53174955, -0.61505544, -0.18177322, -0.11955076, -0.23533337, -0.69158685, 0.24462491, -0.08451503, -0.07140216, -0.028848095, 0.4301919, -0.2763707) * conv2d_2_texOff(vec2(0, 0));
    result += mat4(-0.2057636, -0.11039615, 0.043038752, -0.06468883, 0.038858563, 0.81524706, 0.25682005, 0.04588688, 0.08548999, 1.3636647, 0.5434624, -0.10513345, 0.09528403, 0.08614796, -0.10576254, 0.10042762) * conv2d_2_texOff(vec2(1, 0));
    result += mat4(0.27273422, -0.1191354, 0.43636876, 0.13831557, 0.27879697, 0.027796188, 0.22091848, 0.39287913, 0.01633617, -0.1941439, 0.066316046, 0.34854794, 0.2038614, -0.008311466, -0.25652653, 0.6412611) * conv2d_2_texOff(vec2(-1, 1));
    result += mat4(0.29463226, -0.0009987323, -0.2013805, -0.02519769, 0.3210097, -0.26492965, -0.07431939, 0.16753961, 0.49159908, 0.1136095, -0.7062503, 0.042610943, -0.025232885, -0.19175045, -0.0707381, 0.1349151) * conv2d_2_texOff(vec2(0, 1));
    result += mat4(0.0056497073, -0.15268354, -0.16845344, -0.22153054, 0.004310382, -0.0057750405, -0.15224794, 0.114378236, -0.17400911, -0.15607373, -0.15479787, -0.17152087, -0.23364085, 0.22582379, -0.098124325, 0.11095499) * conv2d_2_texOff(vec2(1, 1));
    result += mat4(0.09927786, 0.11992528, 0.4470019, 0.15784584, 0.16774814, 0.023916934, 0.6016653, 0.2514428, 0.07814069, 0.019986678, -0.22482115, 0.36261928, -0.027704092, 0.034857333, -0.030249538, 0.45752984) * conv2d_3_texOff(vec2(-1, -1));
    result += mat4(0.26234362, -0.14162499, 0.024117418, -0.11694994, -0.22016199, 0.02056312, -0.0062089683, -0.646424, -0.1219842, -0.086772054, 0.09396628, 0.11092015, -0.03297434, -0.11729525, -0.02628596, 0.0041183275) * conv2d_3_texOff(vec2(0, -1));
    result += mat4(0.19978689, 0.35821435, 0.2069716, 0.02233376, -0.08985767, -0.15527199, 0.32737797, -0.05527474, 0.06361696, 0.15971066, -0.030555587, -0.06871243, 0.10211239, 0.14210403, 0.07950669, -0.16530086) * conv2d_3_texOff(vec2(1, -1));
    result += mat4(-0.052045558, 0.03557603, -0.4090573, -0.03590507, 0.036470745, 0.29859757, -0.75994164, 0.029404676, 0.11688835, -0.16666003, 0.03414285, 0.00035598327, -0.007650666, 0.11415025, -0.011377247, -0.07922599) * conv2d_3_texOff(vec2(-1, 0));
    result += mat4(-0.008035429, -0.15122312, -0.32955846, -0.4162706, 0.21801671, -0.2775352, 0.09475202, 0.053313497, -0.17902707, 0.114835344, -0.03138573, 0.04988764, 0.08832104, -0.35015774, 0.0010382214, 0.12586756) * conv2d_3_texOff(vec2(0, 0));
    result += mat4(-0.08303971, 0.054687563, 0.04399768, -0.12401692, -0.1373685, 0.036890626, -0.39018935, 0.18237384, 0.1728456, 0.27233353, 0.16889283, -0.29278636, -0.19187987, -0.23390493, -0.13853998, 0.0646253) * conv2d_3_texOff(vec2(1, 0));
    result += mat4(-0.02163818, 0.00910984, 0.07445484, 0.3016377, 0.0017149409, 0.0248837, 0.5699882, 0.4462191, 0.12150789, -0.08298095, 0.1884362, 0.015103644, 0.12861355, -0.037176445, 0.15049104, 0.12742098) * conv2d_3_texOff(vec2(-1, 1));
    result += mat4(-0.3739506, -0.16414681, -0.038746264, 0.22043437, 0.18799178, -0.08257279, -0.6567427, -0.17414452, 0.74977505, 0.20972586, 0.0073756315, 0.14346273, 0.22649907, -0.14069432, 0.1924944, 0.025278006) * conv2d_3_texOff(vec2(0, 1));
    result += mat4(-0.5594325, -0.010090559, 0.1471611, 0.17096616, 0.13121603, 0.015675036, 0.2369946, -0.061505888, 0.24923263, -0.15643363, -0.18878439, -0.06637364, 0.18180172, 0.15890859, -0.054897558, 0.009285086) * conv2d_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-1-ReLU)
//!HOOK LUMA
//!BIND conv2d_0
//!BIND conv2d_1
//!BIND conv2d_2
//!BIND conv2d_3
//!SAVE conv2d_1_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.017340308, -0.019687496, -0.0024025994, -0.031134807);
    result += mat4(0.14488836, 0.15617222, 0.24995932, -0.20602857, 0.07457725, -0.05089757, 0.1919826, 0.05913797, 0.029240673, -0.14323239, -0.12811571, -0.016654877, -0.037849896, -0.044904917, 0.011908693, 0.20476887) * conv2d_0_texOff(vec2(-1, -1));
    result += mat4(-0.14481299, -0.06820936, -0.13883872, -0.05500995, -0.016674483, 0.060298495, 0.2047487, 0.049329262, 0.15717609, -0.11201403, -0.43433315, 0.038867023, -0.011876664, 0.06909828, 0.01268808, -0.061022058) * conv2d_0_texOff(vec2(0, -1));
    result += mat4(-0.23890416, 0.06723417, 0.019676834, 0.10210641, -0.09049304, -0.14209805, 0.1413747, 0.046595637, -0.22619314, -0.3812248, 0.15453394, 0.108850084, 0.005480026, 0.070482835, 0.0031755085, -0.12541054) * conv2d_0_texOff(vec2(1, -1));
    result += mat4(0.31987897, 0.0615686, -0.3975373, 0.11863347, 0.28750372, -0.13401811, 0.0760137, 0.17732449, 0.16414236, -0.17121066, 0.13583848, -0.56622183, -0.18358624, -0.15444285, 0.048461676, 0.12779245) * conv2d_0_texOff(vec2(-1, 0));
    result += mat4(-0.06398393, 0.06722182, -0.027211612, -0.07538544, -0.38504684, 0.04372612, -0.2316804, 0.15608099, 0.49591798, 0.1576374, 0.55207884, 0.2779325, -0.029350363, 0.12857172, -0.05641292, 0.025787216) * conv2d_0_texOff(vec2(0, 0));
    result += mat4(-0.028369924, 0.21301828, -0.024104927, 0.055602882, -0.40717828, -0.17891307, -0.295342, 0.0033105956, -0.3710164, -0.38472205, 0.081832826, 0.022325462, 0.17720103, -0.14714798, -0.10774241, -0.042427894) * conv2d_0_texOff(vec2(1, 0));
    result += mat4(0.07340591, 0.03715935, 0.0052450444, -0.035622485, 0.09179712, 0.5195772, 0.3391883, 0.06311508, -0.17292568, -0.04444075, 0.17278573, -0.06079131, -0.089864954, -0.044937786, -0.03979694, 0.060385704) * conv2d_0_texOff(vec2(-1, 1));
    result += mat4(-0.056307472, -0.3707715, 0.075873554, -0.06702324, 0.026160933, -0.06355235, -0.74494296, -0.107552685, -0.018595887, 0.90654457, -0.3571631, 0.1279783, 0.020567235, 0.15675215, 0.018051492, -0.0068191322) * conv2d_0_texOff(vec2(0, 1));
    result += mat4(-0.15263507, 0.22343095, -0.24015929, 0.11979613, 0.09178956, 0.045213476, 0.14159034, -0.13668562, -0.111204915, 0.21071827, -0.3713811, 0.027777663, 0.053988844, 0.008589407, 0.0014281778, -0.012949662) * conv2d_0_texOff(vec2(1, 1));
    result += mat4(0.018772757, 0.14670497, 0.21131219, 0.14210835, 0.016244236, -0.029278057, -0.18770012, -0.24322161, -0.20966169, 0.22614162, 0.14078443, -0.063990705, 0.031151341, -0.058134153, -0.5093579, 0.16071557) * conv2d_1_texOff(vec2(-1, -1));
    result += mat4(0.10765616, 0.15357406, -0.11580444, 0.05300243, 0.12445824, -0.14583331, -0.048617847, 0.1631091, 0.26900324, 0.03895971, 0.61425877, -0.15825124, 0.16624531, 0.091453135, 0.019480286, -0.053835534) * conv2d_1_texOff(vec2(0, -1));
    result += mat4(-0.19276977, 0.014981885, -0.18121888, 0.05310704, -0.21167228, -0.05253529, 0.0108297905, 0.02579475, 0.25998238, -0.21757886, -0.16248564, 0.054890875, -0.08875917, -0.25118804, 0.16169702, 0.012575426) * conv2d_1_texOff(vec2(1, -1));
    result += mat4(0.116372004, 0.4852574, -0.008204406, 0.30790752, 0.053777285, -0.25007823, 0.320905, -0.82310075, 0.26665443, -0.19714248, -0.699838, 0.53830475, -0.027435746, -0.02037032, -0.8199938, 0.5747324) * conv2d_1_texOff(vec2(-1, 0));
    result += mat4(-0.42939714, 0.024702828, -0.33913442, -0.07046914, 0.6451655, 0.084024146, 0.14454111, 0.3492084, -0.4482967, -0.037986673, -0.26934886, -0.18702535, -0.6568262, -0.0388689, -0.54918814, -0.6796734) * conv2d_1_texOff(vec2(0, 0));
    result += mat4(0.10233614, 0.12563628, 0.18052123, 0.051445574, -0.16920927, -0.13647845, -0.030910768, 0.070817135, -0.08123445, -0.09324202, 0.02098911, 0.025577955, 0.2966419, -0.19609657, 0.4466385, -0.22584629) * conv2d_1_texOff(vec2(1, 0));
    result += mat4(0.05655131, 0.08924367, -0.16577123, -0.12143397, -0.17510849, -0.2212669, 0.09201883, -0.0020949736, -0.15109304, 0.06458211, 0.3167938, -0.23590852, -0.017636402, 0.21972726, 0.0025182427, 0.06209528) * conv2d_1_texOff(vec2(-1, 1));
    result += mat4(-0.07672382, -0.32485682, -0.025270592, -0.17038974, 0.20503815, 0.08961216, -0.26528487, 0.11186554, -0.07426315, 0.0034636813, -0.16142152, -0.053405337, 0.24825227, 0.06331157, 0.8194105, 0.08002364) * conv2d_1_texOff(vec2(0, 1));
    result += mat4(0.017499413, -0.13600506, 0.265451, 0.14754125, 0.0003032719, -0.032281186, 0.023638505, -0.010426936, 0.12656476, 0.19192576, 0.037995923, 0.06292904, -0.0524992, 0.41586637, 0.44702226, 0.065715484) * conv2d_1_texOff(vec2(1, 1));
    result += mat4(0.067742094, -0.16908768, -0.8031413, -0.076241836, 0.007360003, -0.054910816, -0.38493174, -0.37514096, 0.1338376, -0.03982973, -0.010626242, -0.016812824, 0.21424946, -0.21410498, -0.039047398, -0.056662392) * conv2d_2_texOff(vec2(-1, -1));
    result += mat4(0.1998654, -0.046438374, -0.28451136, 0.041123092, 0.31707332, -0.017821167, -0.22482176, 0.22823006, 0.15921766, -0.10437334, 0.41970316, -0.24452993, 0.08313144, 0.085339256, -0.20493919, -0.09849804) * conv2d_2_texOff(vec2(0, -1));
    result += mat4(0.029725337, 0.18071659, 0.24822284, 0.0703666, -0.1496339, -0.057549343, 0.023302102, 0.122207895, -0.257646, 0.010110776, -0.46341065, -0.036311325, -0.18490152, -0.116960995, -0.06631443, 0.09669033) * conv2d_2_texOff(vec2(1, -1));
    result += mat4(0.0025874474, -0.07285587, -0.04476258, -1.0396242, 0.104973555, -0.021069603, -0.13416433, -0.59028816, -0.060436383, -0.18236636, 0.30641955, -0.3616789, -0.16008604, 0.29695737, -0.17380698, 0.22274195) * conv2d_2_texOff(vec2(-1, 0));
    result += mat4(0.48286545, 0.08040905, 0.20795262, 0.1745168, 0.5266815, -0.464332, 0.50284415, 0.8960674, 0.4862434, 0.20586133, 0.6901777, 1.2361128, -0.30542162, -0.0018511099, -0.05925373, 0.11725837) * conv2d_2_texOff(vec2(0, 0));
    result += mat4(-0.08358229, -0.1377493, -0.20663069, 0.17510939, -0.8824828, 0.124879405, -0.1665411, -0.11844708, -1.0033555, 0.3007729, 0.15289813, -0.08403701, -0.28882208, 0.3530724, 0.27224553, -0.15799375) * conv2d_2_texOff(vec2(1, 0));
    result += mat4(-0.0357076, -0.1162146, 0.16077721, -0.27636003, 0.06199247, -0.26808617, 0.07367261, -0.2293384, 0.0017537746, -0.18031701, 0.12834136, -0.035884295, 0.21609366, -0.19682631, 0.32049942, -0.121130854) * conv2d_2_texOff(vec2(-1, 1));
    result += mat4(0.16379282, 0.5860354, -0.035985265, 0.19390047, 0.27075967, 0.44814512, -0.31964916, 0.31522858, 0.038512684, 0.4798331, -0.8895328, -0.31818455, 0.3625331, 0.20037077, -0.27835098, -0.16096044) * conv2d_2_texOff(vec2(0, 1));
    result += mat4(0.037498824, 0.18473633, -0.18812637, -0.0926213, -0.24170223, -0.14410575, -0.08570759, 0.112453185, 0.43218568, -0.27724668, -0.416527, 0.0047681397, 0.072435394, -0.4548649, 0.3467402, 0.23570302) * conv2d_2_texOff(vec2(1, 1));
    result += mat4(0.026878862, -0.0054201228, -0.1530945, 0.07534664, -0.09706483, -0.25690985, 0.1583413, 0.08827554, 0.02138883, -0.052865714, 0.090475276, -0.12788808, -0.01745817, 0.01312461, -0.07861306, -0.11645284) * conv2d_3_texOff(vec2(-1, -1));
    result += mat4(0.11005661, -0.098031536, -0.1065923, 0.042511646, -0.13756804, -0.00277639, -0.27081233, 0.11590057, -0.059558306, 0.11672527, 0.21551627, 0.10930238, 0.22339214, -0.042645723, -0.14005935, 0.011071548) * conv2d_3_texOff(vec2(0, -1));
    result += mat4(-0.13300125, 0.07933158, -0.18780716, -0.01586275, -0.20094466, 0.16603746, 0.065837875, 0.072648995, -0.0554006, -0.06250166, -0.13206504, -0.0046675834, 0.09118552, -0.00084430864, -0.16215876, 0.011986883) * conv2d_3_texOff(vec2(1, -1));
    result += mat4(-0.068216525, 0.361823, 0.16318728, -0.017136134, -0.069930114, 0.33314154, 0.4596103, -0.3786885, 0.17986344, -0.13468313, 0.04366131, -0.2540776, 0.14976558, 0.121361494, 0.0973411, -0.4332304) * conv2d_3_texOff(vec2(-1, 0));
    result += mat4(0.18297467, 0.016725121, -0.08919352, 0.20343186, 0.5790889, -0.05645069, -0.055454206, -0.08059607, 0.12603521, 0.14410903, 0.3475668, 0.28740877, 0.13379388, 0.062050924, 0.011434581, -0.7498423) * conv2d_3_texOff(vec2(0, 0));
    result += mat4(-0.09216585, 0.17450513, 0.31224558, 0.03045953, -0.10025679, 0.08870231, 0.06103983, 0.015933393, -0.39584205, -0.028308665, -0.39592546, 0.23424876, 0.1764627, 0.15409099, 0.30314422, 0.011382236) * conv2d_3_texOff(vec2(1, 0));
    result += mat4(0.025374932, -0.33056146, -0.34729078, -0.12620093, 0.07066081, -0.2535482, 0.067600474, -0.16062936, -0.0076711546, 0.3902233, -0.1655845, -0.10610696, 0.1216936, -0.24520023, -0.19061872, -0.17690943) * conv2d_3_texOff(vec2(-1, 1));
    result += mat4(0.095207416, -0.67126465, 0.34942475, -0.24091598, -0.086488366, -0.07973916, -0.762392, 0.12857826, 0.1693955, 0.6731177, -0.48613432, 0.1466791, 0.09741641, 0.0023761077, 0.048234843, -0.012384777) * conv2d_3_texOff(vec2(0, 1));
    result += mat4(-0.17446618, -0.33516207, 0.16242985, 0.05475289, 0.004791159, 0.00043990958, 0.30922234, 0.19559966, -0.27294874, 0.09017745, -0.2887363, -0.048817873, -0.050289027, 0.11582911, -0.13685048, 0.09328516) * conv2d_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-2-ReLU)
//!HOOK LUMA
//!BIND conv2d_1_0
//!BIND conv2d_1_1
//!BIND conv2d_1_2
//!BIND conv2d_1_3
//!SAVE conv2d_2_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.0016116564, 0.0140217, -0.014276797, 0.032340433);
    result += mat4(-0.07178392, 0.016315721, 0.0005946311, 0.030577589, 0.04333689, -0.093452394, -0.03004882, -0.050107926, -0.18490277, 0.26364493, -0.072260775, 0.039436042, 0.10363384, -0.028109187, 0.022135373, -0.03164059) * conv2d_1_0_texOff(vec2(-1, -1));
    result += mat4(-0.060812775, -0.027507998, 0.08723827, 0.046105627, -0.09353014, -0.10598249, -0.013066516, -0.0071146223, 0.20277588, -0.016686883, -0.1035257, -0.089943685, -0.14820841, 0.55914414, 0.22274832, 0.23501529) * conv2d_1_0_texOff(vec2(0, -1));
    result += mat4(0.090052575, 0.06477594, -0.0070001115, -0.025469808, -0.03425754, -0.07294174, 0.0056329295, 0.0047411043, 0.16222997, 0.12144206, 0.09321884, 0.040264226, -0.04666454, 0.026579954, 0.050071947, 0.0076818587) * conv2d_1_0_texOff(vec2(1, -1));
    result += mat4(-0.08513167, -0.2875495, 0.041612845, -0.05138494, -0.09915952, 0.058951408, -0.1342867, -0.06935923, 0.037381623, 0.0919032, 0.17679717, 0.047678914, 0.101249166, -0.025736677, -0.024897905, -0.029233104) * conv2d_1_0_texOff(vec2(-1, 0));
    result += mat4(-0.068017535, 0.6301482, -0.26178157, 0.019698642, 0.06426559, -0.05189016, -0.14722882, -0.021859683, 0.04635214, 0.13306151, 0.042442184, 0.1065489, -0.8038567, 0.04119868, -0.26764, 0.07693732) * conv2d_1_0_texOff(vec2(0, 0));
    result += mat4(0.075273335, -0.28333327, 0.19145235, 0.09513326, 0.009794974, 0.49292368, -0.044377442, 0.024185028, -0.18392205, -0.38400832, -0.0046880613, -0.011231526, -0.8897519, 0.09199683, 0.12134915, 0.11562762) * conv2d_1_0_texOff(vec2(1, 0));
    result += mat4(0.16570432, 0.40337393, 0.015051043, -0.060783073, 0.20551817, -0.03533, 0.12241853, -0.05348068, 0.12149841, 0.065062605, -0.11252291, -0.095354445, 0.10423435, -0.21775512, 0.069606744, -0.031629123) * conv2d_1_0_texOff(vec2(-1, 1));
    result += mat4(0.6460741, 0.14160515, 0.47721875, 0.34894952, 0.36413196, 0.13436675, 0.1483222, -0.0845658, -0.32323244, -0.48473448, -0.094253786, -0.21110763, 0.23572126, -0.026917353, -0.018204913, 0.010475741) * conv2d_1_0_texOff(vec2(0, 1));
    result += mat4(-0.53249466, 0.24587016, -0.30272746, -0.27224007, 0.30246344, -0.10718816, -0.07307292, -0.13663685, 0.10813337, 0.0865046, 0.0773426, 0.12373443, -0.31325296, 0.11406258, 0.032060362, 0.007786539) * conv2d_1_0_texOff(vec2(1, 1));
    result += mat4(-0.114592634, -0.1237957, -0.028392505, -0.0451241, -0.016470285, 0.069527104, 0.08691624, 0.050399024, 0.029355677, -0.22757515, -0.03442622, -0.005107544, -0.05239135, -0.004135231, 0.02433436, 0.020816857) * conv2d_1_1_texOff(vec2(-1, -1));
    result += mat4(0.11775898, 0.060123272, -0.098467164, 0.036160126, -0.018650878, 0.59256804, 0.13154592, 0.10119831, -0.163676, -1.2136017, -0.20482856, -0.038299114, -0.075876825, 0.33163872, -0.102083705, -0.024919622) * conv2d_1_1_texOff(vec2(0, -1));
    result += mat4(0.31219944, -0.0058680535, -0.007267952, -0.10193347, -0.15070787, 0.14449143, 0.029485961, 0.024213849, 0.283513, -0.23905759, 0.008131418, -0.0019627465, 0.07785088, 0.16787751, 0.1254994, 0.052326743) * conv2d_1_1_texOff(vec2(1, -1));
    result += mat4(-0.12166575, -0.022989959, 0.16047159, -0.0049578706, -0.18839242, 0.093603864, 0.036626857, 0.04650495, -0.037966672, -0.34665927, -0.020736754, 0.030776102, 0.15200391, -0.05308605, -0.01665302, -0.015148991) * conv2d_1_1_texOff(vec2(-1, 0));
    result += mat4(0.18189196, 0.11606551, 0.0501763, -0.087623715, -0.09908626, 0.21889333, -0.02159087, 0.08742199, 0.4474708, -0.015130144, 0.7541795, 0.24680516, 0.1323254, -0.42770717, 0.14092831, 0.05129375) * conv2d_1_1_texOff(vec2(0, 0));
    result += mat4(-0.5243228, -0.030999888, -0.07326469, -0.01073922, -0.8842717, 0.07121405, 0.122859485, 0.06663911, 0.5692027, -0.057710417, -0.1157748, -0.0010078104, 0.45262274, -0.28402534, -0.051606968, -0.0013918148) * conv2d_1_1_texOff(vec2(1, 0));
    result += mat4(-0.17276578, -0.051045336, 0.07410003, 0.12283039, -0.00547139, -0.00341309, -0.010939392, -0.0016168455, -0.053534437, -0.02280984, 0.036317512, 0.055286255, -0.045057, -0.048533812, 0.025246356, 0.01564801) * conv2d_1_1_texOff(vec2(-1, 1));
    result += mat4(-0.075450085, -0.07351188, 0.06430049, 0.16461048, -0.02439493, 0.10749386, -0.009211288, -0.021171553, 0.267843, 0.15343265, -0.007827711, 0.013996766, -0.08798558, -0.028267896, 0.007338673, 0.020663666) * conv2d_1_1_texOff(vec2(0, 1));
    result += mat4(0.3589905, -0.009084765, 0.016114205, 0.036301587, -0.1740047, 0.05202388, -0.015650894, -0.0064869453, 0.036118742, -0.15387653, -0.018667853, -0.01209729, 0.10280624, 0.011172811, 0.032254886, 0.012621561) * conv2d_1_1_texOff(vec2(1, 1));
    result += mat4(-0.04834014, -0.03526158, 0.05853831, 0.084554285, -0.28603014, -0.045017116, 0.26015744, -0.012468212, -0.06592498, -0.061726715, 0.043690905, 0.027016442, 0.017288918, -0.10919584, -0.043848794, 0.028733881) * conv2d_1_2_texOff(vec2(-1, -1));
    result += mat4(0.027486352, -0.349797, -0.027179768, -0.0013235832, -0.27719748, 0.34134665, -0.23344098, -0.0602352, -0.022250434, -0.062771015, 0.02326751, 0.009445905, 0.07089943, 0.021603946, 0.049525265, 0.029747402) * conv2d_1_2_texOff(vec2(0, -1));
    result += mat4(-0.0065616057, -0.0007921599, 0.011979688, -0.012808949, -0.12567553, 0.051304962, 0.08071553, -0.001188184, -0.026608888, 0.032864925, 0.0030524454, 0.021533625, 0.056682047, -0.076001935, 0.020241361, 0.033183243) * conv2d_1_2_texOff(vec2(1, -1));
    result += mat4(-0.14704564, 0.27562207, 0.019860022, 0.028287191, 0.14170235, 0.18212168, -0.03879993, 0.6179209, -0.029668843, 0.07192611, -0.035148107, 0.030636815, 0.053909782, -0.09575066, -0.032652784, -0.019200137) * conv2d_1_2_texOff(vec2(-1, 0));
    result += mat4(0.8140166, -0.33012336, 0.24890704, 0.050513603, 0.2880904, -0.35702807, 0.3235871, 0.0799433, -0.040245235, 0.069440655, -0.0267066, -0.06736572, 0.07852883, -0.5296, 0.03480436, 0.0006398863) * conv2d_1_2_texOff(vec2(0, 0));
    result += mat4(0.8719787, -0.06819611, -0.018990856, -0.0721697, -0.046735037, 0.003399876, -0.030062016, 0.07610814, 0.01898067, 0.035018347, -0.064313665, 0.006702074, 0.26719117, -0.43626022, -0.062359873, -0.045097504) * conv2d_1_2_texOff(vec2(1, 0));
    result += mat4(-0.108166456, 0.1632682, -0.048928294, 0.0352736, 0.07232684, 0.29997268, 0.2300139, 0.067888275, 0.040322863, 0.030843442, 0.05987516, 0.033828784, 0.14950477, -0.08285096, 0.08011602, 0.056967665) * conv2d_1_2_texOff(vec2(-1, 1));
    result += mat4(-0.42694804, -0.10358815, 0.07877955, 0.019714126, -0.21404517, -0.07253548, -0.08699267, -0.13583452, 0.19119735, -0.012615169, 0.08298881, -0.022804292, 0.012007984, -0.39893395, 0.18984659, 0.1259673) * conv2d_1_2_texOff(vec2(0, 1));
    result += mat4(0.4382115, 0.014568933, -0.014228096, 0.015283748, 0.024885207, 0.0040985416, 0.052312836, -0.00840694, -0.08268298, 0.049490377, -0.018271057, -0.020799547, 0.61019176, -0.06575747, 0.15428685, 0.032139625) * conv2d_1_2_texOff(vec2(1, 1));
    result += mat4(-0.1103638, -0.24382193, -0.0021984496, 0.023088237, 0.003917495, 0.27951375, -0.024743905, 0.043511987, 0.01994665, 0.09042718, 0.08001624, 0.025604095, 0.1424135, -0.063713714, 0.05055283, 0.006594607) * conv2d_1_3_texOff(vec2(-1, -1));
    result += mat4(0.089594215, -0.26647395, 0.111056216, 0.11005409, 0.38198596, -0.48019555, -0.13853139, -0.18726984, -0.13978605, 0.36154184, 0.04966506, 0.01841499, 0.20530596, -0.109932445, -0.09282244, 0.033195525) * conv2d_1_3_texOff(vec2(0, -1));
    result += mat4(-0.026680512, -0.035815246, 0.0145682, 0.028691273, -0.31977448, -0.22379017, -0.13368441, -0.0065354207, -0.18989044, 0.23734513, 0.009926452, 0.03997482, 0.11098721, -0.05701889, 0.05198063, 0.0008146918) * conv2d_1_3_texOff(vec2(1, -1));
    result += mat4(0.046974234, -0.6315373, 0.22552557, -0.5043373, 0.15039201, 0.21299054, 0.013669797, 0.0072580543, -0.2812821, 0.111724705, -0.043064557, -0.0013668948, -0.02739455, -0.0439339, 0.018383132, -0.05493821) * conv2d_1_3_texOff(vec2(-1, 0));
    result += mat4(-0.07456543, 0.47421628, 0.051593374, 0.04282623, -0.10432053, -0.12629968, 0.25613713, 0.11983452, -0.2887882, 0.045606792, 0.10627029, 0.12909806, -0.32911238, -0.03163113, 0.09387817, 0.5279224) * conv2d_1_3_texOff(vec2(0, 0));
    result += mat4(0.17722927, 0.06328448, -0.008994296, -0.04602209, 0.05955998, 0.076387055, 0.030967932, 0.055060692, -0.268533, 0.17084622, 0.032699108, 0.037646223, -0.26747283, 0.022585792, -0.0052424474, -0.03718011) * conv2d_1_3_texOff(vec2(1, 0));
    result += mat4(-0.010180411, 0.35240108, -0.027932547, -0.0787834, 0.05416718, 0.3311954, -0.12372095, -0.087418094, -0.16849296, -0.074643396, 0.03130342, 0.065659545, -0.079385266, 0.0011491027, -0.007578512, 0.03224556) * conv2d_1_3_texOff(vec2(-1, 1));
    result += mat4(-0.4952282, 0.28173047, 0.013040495, -0.013693254, -0.06403208, 0.064919874, -0.14142747, -0.10408415, -0.1934128, -0.026647728, 0.11354118, 0.07091706, 0.15526253, 0.009439815, 0.02066057, 0.0020739087) * conv2d_1_3_texOff(vec2(0, 1));
    result += mat4(-0.06444213, -0.050060943, -0.029164882, 0.0034186568, -0.014414396, -0.08906378, -0.03222982, -0.043057702, -0.20625849, 0.16155711, 0.031150155, 0.03191052, 0.34221584, 0.05589677, 0.031364746, 0.094496354) * conv2d_1_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-2-ReLU)
//!HOOK LUMA
//!BIND conv2d_1_0
//!BIND conv2d_1_1
//!BIND conv2d_1_2
//!BIND conv2d_1_3
//!SAVE conv2d_2_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.020907562, 0.051519904, 0.004025018, 0.012838635);
    result += mat4(0.0031744768, -0.11728889, -0.0047050696, 0.06373327, 0.036726005, 0.06609036, 0.049950615, 0.17614485, -0.32997555, 0.014641409, 0.081182264, -0.07919155, -0.19536918, -0.46960676, 0.016764, 0.47363475) * conv2d_1_0_texOff(vec2(-1, -1));
    result += mat4(-0.17114286, -0.09082788, -0.019113917, -0.06096694, -0.044028904, 0.004388121, 0.017435232, 0.11718931, 0.4229845, -0.039230697, 0.24911089, -0.22115454, -0.8559903, -1.0016639, 0.056378588, -0.21188162) * conv2d_1_0_texOff(vec2(0, -1));
    result += mat4(0.22287893, 0.08208969, -0.05347362, 0.17382339, 0.077205196, -0.063387565, 0.0133471945, 0.1278937, 0.02451678, 0.29897645, -0.20019333, 0.035748534, -0.22976047, -0.62586397, -0.32414898, 0.10808306) * conv2d_1_0_texOff(vec2(1, -1));
    result += mat4(0.08604741, 0.067420244, -0.120265596, 0.04651316, 0.08795654, 0.28762528, 0.28650737, -0.12001891, 0.07282678, -0.39539564, 0.19386075, -0.12519884, -0.29190686, -0.025415573, -0.048851524, 0.056699894) * conv2d_1_0_texOff(vec2(-1, 0));
    result += mat4(0.0029094212, -0.0056027942, 0.4622342, 0.07185407, -0.6783579, 0.23182988, 0.35710406, 0.21463121, 0.005757732, -0.0974986, -0.7756018, -0.52199864, -0.062789515, -0.37965363, 0.22294925, 0.5948862) * conv2d_1_0_texOff(vec2(0, 0));
    result += mat4(-0.09940342, -0.046650127, -0.2681366, -0.0681941, 0.14202707, 0.038633112, 0.2782476, 0.18217503, -0.053161237, 0.30853584, 0.24053691, 0.6429152, -0.014886472, -0.23501647, -0.048990157, 0.1406616) * conv2d_1_0_texOff(vec2(1, 0));
    result += mat4(-0.117957525, 0.6456593, 0.4443233, 0.40475813, 0.032213457, 0.14895347, 0.11499221, 0.21742125, 0.07235454, -0.20731468, -0.14050148, -0.13629226, -0.10762253, -0.037572715, 0.025096059, 0.13854228) * conv2d_1_0_texOff(vec2(-1, 1));
    result += mat4(-0.0057440316, -1.0421077, -1.2486165, -1.2702764, -0.0064959745, 0.10872661, 0.2396473, -0.03633486, 0.17960645, -0.26594314, -0.11910224, -0.30076158, -0.18298545, -0.0035316695, 0.062204015, -0.36974114) * conv2d_1_0_texOff(vec2(0, 1));
    result += mat4(-0.056661, 1.1751522, 0.3941314, 0.7767375, 0.014559706, -0.06263625, 0.19227074, -0.20788455, 0.09501717, 0.034079492, 0.06669195, 0.22303842, 0.025841638, -0.11585611, 0.016951745, 0.29505157) * conv2d_1_0_texOff(vec2(1, 1));
    result += mat4(0.39236626, 0.20790094, -0.35882658, -0.32753286, 0.024261013, 0.028498108, -0.030219533, 0.08684579, -0.0075397226, -0.065764576, -0.078874715, -0.2489706, 0.10573096, -0.05824668, -0.050766822, -0.0051559606) * conv2d_1_1_texOff(vec2(-1, -1));
    result += mat4(-0.12361742, 0.21435739, 0.10601367, -0.3074418, 0.29480368, 0.25744852, 0.020637518, 0.12709369, -0.23088132, -1.3187712, 0.23015307, 0.27084053, 0.035128582, -0.11053937, 0.060682125, -0.3746682) * conv2d_1_1_texOff(vec2(0, -1));
    result += mat4(0.03769216, -0.050791573, 0.013949821, -0.053851034, 0.23206025, 1.5472457, -0.20905508, 0.24124593, -0.083613455, -1.2183553, 0.16187707, -0.47220066, -0.16389607, -1.4915924, -0.093669765, 0.12735969) * conv2d_1_1_texOff(vec2(1, -1));
    result += mat4(0.11359122, 0.21317953, -0.2854131, -0.05212575, -0.034172487, -0.041620836, 0.012191899, 0.08086835, -0.13628858, 0.09478358, -0.054523725, 0.0640467, 0.03960268, -0.041670598, -0.06735924, -0.12027836) * conv2d_1_1_texOff(vec2(-1, 0));
    result += mat4(0.3910543, -0.40020314, -0.032621518, -0.5630948, 0.18626158, -0.075502895, -0.23416606, 0.14312814, -0.73079926, -0.295574, 0.561242, -0.065812126, 0.024016157, 0.022435995, -0.1349801, 0.27300057) * conv2d_1_1_texOff(vec2(0, 0));
    result += mat4(-0.16706812, -0.066321254, -0.057062898, 0.4443227, 0.058483806, 0.53187317, -0.0674255, 0.9356748, -0.008629555, -0.21394575, -0.16509426, -0.91222733, -0.029347135, -0.48837376, -0.4969213, -0.53777254) * conv2d_1_1_texOff(vec2(1, 0));
    result += mat4(0.04553135, -0.013839943, -0.09338917, 0.27556664, 0.081337914, 0.12279045, 0.019205736, 0.04967726, -0.015074711, 0.05812557, 0.038298994, -0.09074704, 0.010639862, -0.015736815, 0.0030932985, -0.0016413351) * conv2d_1_1_texOff(vec2(-1, 1));
    result += mat4(-0.04137299, -0.22907248, 0.13398276, 0.37713107, 0.067183696, -0.085011356, -0.011665301, 0.45076397, -0.034449093, -0.043588433, 0.00947799, -0.36405218, 0.16628245, 0.054975566, 0.03167458, -0.09813912) * conv2d_1_1_texOff(vec2(0, 1));
    result += mat4(-0.06517379, 0.20642205, 0.11157918, -0.27304575, 0.0031954395, -0.1927721, -0.0019003913, 0.6138191, -0.11941135, 0.032949332, -0.0521811, -0.29868892, -0.002705818, -0.16481473, -0.040983956, -0.3468507) * conv2d_1_1_texOff(vec2(1, 1));
    result += mat4(-0.06538467, 0.09044791, -0.07703634, -0.09411588, 0.34142882, 0.12353218, -0.111447565, 0.8391204, -0.08035813, 0.10337552, 0.020741524, 0.027382735, -0.005969964, 0.021634694, 0.04043049, -0.056705765) * conv2d_1_2_texOff(vec2(-1, -1));
    result += mat4(-0.28164127, -0.45223945, 0.15462564, -0.12460015, -0.39189178, 0.35276568, 0.033688474, 0.9718588, -0.24079955, 0.31509155, 0.04708655, -0.07599852, -0.03512791, -0.18583517, -0.030928228, -0.14774935) * conv2d_1_2_texOff(vec2(0, -1));
    result += mat4(0.1842524, 0.0030433086, 0.075150765, 0.19679375, 0.19247046, -0.030250177, -0.06994248, 0.27319065, -0.09918321, 0.21605903, 0.14399482, 0.061411664, 0.0317043, 0.23024723, -0.022572026, -0.27585843) * conv2d_1_2_texOff(vec2(1, -1));
    result += mat4(0.17867683, -0.21442306, 0.07002352, -0.11982447, 0.17456487, 0.70163083, 0.35833198, -0.4218817, -0.08642471, 0.18753386, 0.08246379, 0.103460915, -0.16495793, 0.04260013, 0.10095175, -0.09631633) * conv2d_1_2_texOff(vec2(-1, 0));
    result += mat4(0.20721564, 0.8622436, -0.27429, -0.7699969, 0.022362148, -0.70620453, 0.17909047, -1.3758086, 0.042303294, 0.17319015, 0.13412514, 0.25918168, -0.011338483, 0.36102182, 0.023044119, -0.194089) * conv2d_1_2_texOff(vec2(0, 0));
    result += mat4(-0.05761861, 0.046321046, 0.10465949, 0.3133327, 0.030601311, 0.13649099, -0.016309083, -0.17556442, -0.11032381, 0.16765402, 0.25261846, 0.2029326, -0.19749878, 0.3098951, -0.041747943, -0.70022374) * conv2d_1_2_texOff(vec2(1, 0));
    result += mat4(0.11304138, -0.07230113, -0.03682564, -0.20679037, -0.10251529, 0.020741094, 0.16167079, 0.72618103, -0.023794848, 0.14600363, 0.049633823, 0.1761247, -0.069169916, 0.09782369, 0.070077375, 0.02089318) * conv2d_1_2_texOff(vec2(-1, 1));
    result += mat4(0.068394646, 0.089684464, -0.08461792, 0.69136304, 0.23900558, 0.72533345, 0.1382827, 0.54307395, -0.09134387, 0.15045057, -0.021550333, 0.019955346, 0.00096793013, 0.10959666, 0.18671048, -0.32979673) * conv2d_1_2_texOff(vec2(0, 1));
    result += mat4(0.052417297, 0.09578193, 0.011406501, -0.48269963, 0.033308566, -0.14252158, -0.0056949253, -0.19196507, -0.022448128, 0.21927366, 0.09810581, 0.19338322, 0.026622828, 0.13936909, -0.06823349, -0.7605943) * conv2d_1_2_texOff(vec2(1, 1));
    result += mat4(-0.017573133, 0.13327186, 0.13617179, 0.042600993, -0.14403732, 0.25242755, 0.21254182, -0.09322919, -0.041762277, 0.10206624, -0.06097341, 0.083670296, 0.06172249, 0.02419519, 0.0010144901, 0.01927539) * conv2d_1_3_texOff(vec2(-1, -1));
    result += mat4(-0.039383788, -0.7178877, -0.06755693, -0.41525593, -0.11896611, 0.14200294, -0.37369728, -0.26055324, -0.09846504, -0.052315433, -0.014807762, -0.065948725, 0.041153066, -0.04715303, -0.22019948, -0.5388037) * conv2d_1_3_texOff(vec2(0, -1));
    result += mat4(0.06641112, 0.09193711, 0.03774413, -0.24717455, 0.044628434, 0.29915488, 0.22905914, 0.15836492, -0.05236084, 0.07180532, 0.040351544, 0.2659413, 0.4629498, -0.77128196, -0.1738166, -0.24848436) * conv2d_1_3_texOff(vec2(1, -1));
    result += mat4(0.061137434, -0.014927852, -0.021920886, 0.3966293, 0.11061045, -0.040991914, 0.0035905573, 0.015106213, 0.10882679, -0.026795339, -0.022624342, -0.027262887, 0.067980446, 0.021795027, -0.0066688014, -0.04517336) * conv2d_1_3_texOff(vec2(-1, 0));
    result += mat4(0.19848305, -1.4593208, 0.6035147, 0.35423073, -0.0068916585, -0.001216771, 0.062235147, -0.096354604, 0.21444967, 0.25416553, -0.07393456, -0.060246654, -0.43960467, -0.49079996, 0.6814027, 0.14962484) * conv2d_1_3_texOff(vec2(0, 0));
    result += mat4(0.07885259, -0.22042286, -0.013019417, -0.39285147, 0.041827675, 0.50102544, -0.11008076, 0.0861614, 0.020343844, 0.10926595, 0.16890776, 0.6490841, 0.10094334, -2.015963, -0.13425902, -1.4022644) * conv2d_1_3_texOff(vec2(1, 0));
    result += mat4(-0.13805336, -0.24635603, -0.08396985, -0.61145496, 0.15020561, 0.02556904, 0.022434305, -0.025977092, 0.022491982, 0.012352028, 0.08526008, -0.03644116, -0.07410636, -0.017045846, 0.016095793, 0.033953343) * conv2d_1_3_texOff(vec2(-1, 1));
    result += mat4(-0.09484077, 0.3043744, 0.4865856, -0.002300076, 0.15410735, 0.1313057, -0.011836678, -0.19705223, 0.10768164, 0.22546051, 0.0032063725, 0.0942055, 0.14003275, 0.12351202, 0.11833861, -0.44578964) * conv2d_1_3_texOff(vec2(0, 1));
    result += mat4(-0.025251418, -0.062778525, -0.013419117, 0.0046717, 0.11577662, 0.3379935, 0.03158058, 0.10205679, 0.15625815, 0.22746506, 0.027108178, 0.14533278, 0.017807763, -0.28041193, -0.06621321, -0.7751486) * conv2d_1_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-2-ReLU)
//!HOOK LUMA
//!BIND conv2d_1_0
//!BIND conv2d_1_1
//!BIND conv2d_1_2
//!BIND conv2d_1_3
//!SAVE conv2d_2_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.04876215, 0.061036646, -0.09217501, -0.0016979452);
    result += mat4(0.034232922, 0.09368829, -0.048885133, -0.06830685, 0.034104645, -0.024913078, -0.0110766515, 0.037528504, -0.016028099, 0.1713179, -0.05660502, 0.0049822535, 0.28902757, 0.13230962, -0.15054381, -0.34557992) * conv2d_1_0_texOff(vec2(-1, -1));
    result += mat4(0.13366395, -0.065542206, 0.03908324, -0.018846933, -0.094967365, -0.09036536, 0.1273017, 0.015691964, 0.07796363, -0.057486843, -0.0019508312, -0.0963728, 0.0671257, -0.090859264, -0.448771, -0.12917475) * conv2d_1_0_texOff(vec2(0, -1));
    result += mat4(-0.006555958, -0.08371094, -0.076538436, 0.04886956, 0.042018283, -0.027730241, 0.075281315, 0.016118327, -0.08034531, 0.05609647, -0.0917216, 0.20705086, 0.10803086, -0.1757023, -0.19281952, -0.15512674) * conv2d_1_0_texOff(vec2(1, -1));
    result += mat4(0.20511635, 0.1725111, 0.076811254, -0.10754896, -0.21394521, -0.04676743, 0.16539054, 0.33154884, -0.4185173, -0.33745226, -0.33949208, 0.007838045, 0.2026763, 0.13039109, -0.33207116, -0.27698684) * conv2d_1_0_texOff(vec2(-1, 0));
    result += mat4(0.073000066, -0.43043175, 0.13469006, -0.06535744, -0.13866037, 0.22818325, 0.24920255, 0.11949679, -0.067852534, -0.071333595, -0.7630239, -0.2670297, 0.2767074, -0.5851851, -3.8150272, -0.69585377) * conv2d_1_0_texOff(vec2(0, 0));
    result += mat4(-0.24758838, 0.20573221, -0.045180105, -0.004821115, -0.16202433, 0.10255843, 0.27647582, 0.06700002, 0.026406523, -0.028886715, -0.28528342, 0.0024754342, 0.16817431, -0.020770015, 0.27078566, -0.41335487) * conv2d_1_0_texOff(vec2(1, 0));
    result += mat4(0.017386166, 0.11667963, 0.07580775, -0.13891499, 0.015413562, -0.057992965, -0.044724956, 0.57578504, 0.3256954, 0.08494341, 0.15984862, 0.20348191, -0.18499333, 0.05065657, 0.005393591, -0.10701197) * conv2d_1_0_texOff(vec2(-1, 1));
    result += mat4(0.26381642, 1.5968606, -0.10364957, -0.43997616, -0.07239394, 0.12711233, -0.11792853, 0.864299, -0.15307516, -0.42418727, 1.8427134, -0.2815313, 0.24256219, -0.33713526, -0.50198853, -0.434038) * conv2d_1_0_texOff(vec2(0, 1));
    result += mat4(-0.04840268, -0.15018398, -0.0754169, -0.03208611, 0.04308169, -0.032875415, 0.20428611, 0.41817427, -0.006328515, 0.123779, 0.18261783, 0.09145279, 0.16381551, 0.04455655, -0.060461145, -0.1033668) * conv2d_1_0_texOff(vec2(1, 1));
    result += mat4(-0.095887825, -0.23944968, 0.30970004, -0.08020435, 0.15372302, 0.021705782, 0.010979488, -0.118602775, -0.112626776, 0.004235629, 0.013230361, 0.11415977, 0.025365815, -0.09801066, -0.030285247, 0.051213317) * conv2d_1_1_texOff(vec2(-1, -1));
    result += mat4(-0.10985608, -0.027423508, -0.002124163, -0.18101665, 0.18040909, -0.18693982, -0.03190474, -0.09086754, -0.546998, -0.307916, 0.060047604, 0.06444271, -0.10978825, -0.2096884, -0.15844408, -0.066356994) * conv2d_1_1_texOff(vec2(0, -1));
    result += mat4(0.041053224, -0.16441132, 0.106258996, 0.17246635, 0.17930149, 0.06279533, 0.0958223, -0.10922696, 0.06920592, 0.019988552, -0.030148271, 0.17140487, -0.34680396, -0.13821183, -0.3231273, 0.047748704) * conv2d_1_1_texOff(vec2(1, -1));
    result += mat4(-0.19281444, -0.33236292, 0.43439496, 0.09186985, 0.21958739, 0.01633886, -0.02779062, -0.27076596, -0.40243503, 0.042226154, 0.2786877, -0.37100714, -0.097063765, -0.13479002, 0.00965896, 0.10896096) * conv2d_1_1_texOff(vec2(-1, 0));
    result += mat4(0.20951708, -0.16225503, -0.434804, 0.5500215, 0.7057625, -0.24058343, -0.49586177, -0.8392422, -0.13518055, 0.46028462, 0.29732037, 0.18426716, -0.36518323, 0.09257479, 0.446278, 0.30942357) * conv2d_1_1_texOff(vec2(0, 0));
    result += mat4(-0.024183024, 0.11985217, -0.19980443, -0.08773907, 0.1484866, 0.04607873, 0.45947224, -0.42431936, -0.24513598, 0.13943909, -0.31403053, 0.045505747, 0.35051447, 0.3013526, -5.7480645, 0.29916322) * conv2d_1_1_texOff(vec2(1, 0));
    result += mat4(0.089447565, -0.22003159, -0.0034516677, -0.24450058, 0.039316136, 0.017585326, 0.014822698, -0.15916418, -0.12752223, -0.036430907, -0.16313298, -0.08881362, 0.008964171, 0.0148620475, 0.04254993, -0.054981638) * conv2d_1_1_texOff(vec2(-1, 1));
    result += mat4(-0.011240074, 0.3626221, 0.5068187, -0.2546946, 0.10180264, 0.07854199, 0.30631325, -0.3548947, -0.09269432, 0.122540854, -2.059031, 0.23607422, -0.14151959, -0.11739254, -0.2388074, 0.29413682) * conv2d_1_1_texOff(vec2(0, 1));
    result += mat4(-0.027039906, 0.062432174, -0.01746774, -0.16163918, 0.19034399, -0.04096386, -1.9387709, -0.40959898, -0.15908933, -0.0034144942, 0.18532604, 0.029431539, -0.14820427, -0.14582361, 0.16814838, 0.3885549) * conv2d_1_1_texOff(vec2(1, 1));
    result += mat4(0.25474247, 0.044379335, 0.07912979, -0.02678401, -0.080179036, -0.022027165, 0.14602707, 0.046489257, 0.02864414, 0.09747502, 0.10800262, -0.08907459, -0.17020956, 0.023502152, 0.006028273, 0.110859826) * conv2d_1_2_texOff(vec2(-1, -1));
    result += mat4(-0.015286922, 0.39182553, 0.36834243, 0.06804767, 0.30349514, 0.10593305, 0.26544663, 0.14152467, -0.053552184, 0.15245616, 0.14953937, -0.11476936, -0.068606175, 0.06142619, -0.021863198, 0.08280719) * conv2d_1_2_texOff(vec2(0, -1));
    result += mat4(-0.22338197, 0.31262273, 0.2010443, 0.09133032, 0.044035256, 0.07017055, -0.046419777, 0.021762129, -0.12433717, 0.22251974, 0.06896658, -0.11445592, -0.007925719, 0.06353368, -0.022658901, 0.04700994) * conv2d_1_2_texOff(vec2(1, -1));
    result += mat4(0.08760221, 0.017489698, -0.07629008, -0.019015845, -0.18772608, -0.21621767, 0.17257439, 0.24097398, -0.023047276, 0.09992211, 0.09791718, -0.15679903, -0.27422526, 0.03177792, 0.061056618, 0.1258129) * conv2d_1_2_texOff(vec2(-1, 0));
    result += mat4(-0.34781972, 0.35419288, 0.39117673, -0.3356571, 0.028878221, -0.42210343, 0.22045964, -0.084224515, -0.09980312, 0.24313343, 0.1375639, -0.3992535, -0.5391131, 0.23367883, 0.063405134, 0.03216834) * conv2d_1_2_texOff(vec2(0, 0));
    result += mat4(-0.038036548, 0.03852969, -0.18939641, 0.048077468, -0.009010091, -0.064056456, -0.070182465, -0.10497828, -0.12824, 0.08565596, 0.332342, -0.21744101, -0.17636369, 0.22629291, -0.033142753, -0.15699534) * conv2d_1_2_texOff(vec2(1, 0));
    result += mat4(0.21844321, 0.041396096, 0.14277557, 0.14932401, -0.12388043, 0.11132213, 0.6418031, 0.27927843, -0.07578104, 0.05894083, 0.14709017, -0.025688194, -0.1793799, 0.0715587, -0.008728562, 0.14704861) * conv2d_1_2_texOff(vec2(-1, 1));
    result += mat4(-0.23896594, 0.29463968, 0.479136, -0.108207665, -0.4123829, 0.1424328, -0.48983586, -0.22134592, -0.04109916, 0.14150688, 0.15351206, -0.43141776, -0.5663098, 0.21249285, 0.33233625, 0.19077983) * conv2d_1_2_texOff(vec2(0, 1));
    result += mat4(-0.11829278, -0.06649712, -0.03804227, 0.15217401, 0.0034973705, -0.019493198, 0.26487404, 0.13875817, 0.14380687, 0.16110191, -0.07102462, -0.32924405, -0.4907955, 0.10861249, 0.08719571, 0.15251286) * conv2d_1_2_texOff(vec2(1, 1));
    result += mat4(-0.06266116, -0.34041858, 0.05044081, 0.11066578, -0.17866176, -0.08240197, 0.01901226, 0.30160436, 0.18857968, 0.026002537, 0.09283131, -0.14198096, -0.10862162, -0.018085554, -0.025328832, -0.0819906) * conv2d_1_3_texOff(vec2(-1, -1));
    result += mat4(-0.031736273, -0.16163191, -0.17791007, 0.080185086, 0.3190332, 0.007668056, 0.15619679, 0.08277755, 0.17180185, -0.09543453, 0.10643762, -0.115333304, 0.039321292, 0.06841015, -0.29110217, -0.17849095) * conv2d_1_3_texOff(vec2(0, -1));
    result += mat4(0.0103533715, -0.03713895, 0.03947562, -0.006019256, 0.11297437, -0.36600056, -0.0004695724, 0.15414482, 0.048921894, -0.0577784, 0.012957792, -0.025864545, -0.16864915, -0.19950613, -0.08373039, -0.19903928) * conv2d_1_3_texOff(vec2(1, -1));
    result += mat4(0.27744386, 0.01034252, 0.030558145, 0.12676676, -0.0048416452, 0.07899187, 0.0078145545, 0.15479963, 0.05073462, -0.059940033, 0.054957006, -0.34947175, 0.050893925, 0.028190201, -0.027418047, 0.08505365) * conv2d_1_3_texOff(vec2(-1, 0));
    result += mat4(0.14076309, 0.25534484, 0.01914289, 0.13393933, -0.08229252, -0.045399316, 0.19895938, 0.23962416, 0.5211412, -0.4614649, -0.044750545, -0.235249, 0.060966972, -0.01573592, -0.03672357, 0.19417182) * conv2d_1_3_texOff(vec2(0, 0));
    result += mat4(-0.085647345, 0.010611496, 0.0880624, 0.06944839, -0.13834879, -0.21005148, -0.05631103, 0.29470924, 0.2690182, -0.11698685, 0.13923179, -0.09221928, -0.00828649, -0.12489086, 0.0053855656, 0.26634017) * conv2d_1_3_texOff(vec2(1, 0));
    result += mat4(0.43167678, -0.33268204, -0.33180162, 0.080081545, 0.055839043, 0.038355794, 0.10954252, -0.07784174, 0.11802536, -0.03885749, 0.082809485, 0.1793183, 0.0877824, 0.03436808, 0.012255782, 0.03914771) * conv2d_1_3_texOff(vec2(-1, 1));
    result += mat4(0.10665348, -0.34293398, 0.596724, 0.09078337, -0.006305632, 0.08420252, 0.217411, -0.0800918, -0.025566392, 0.0065758205, 0.37606472, -0.16127555, 0.15408729, 0.089559495, -3.2980263, -0.026309669) * conv2d_1_3_texOff(vec2(0, 1));
    result += mat4(0.0375634, 0.04730243, -0.084146015, -0.059625976, -0.17249274, -0.05074574, 0.26398557, -0.08430875, 0.16551284, -0.093194276, 0.09992684, -0.06365805, 0.26737282, -0.11760361, 0.13424441, -0.040855955) * conv2d_1_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-2-ReLU)
//!HOOK LUMA
//!BIND conv2d_1_0
//!BIND conv2d_1_1
//!BIND conv2d_1_2
//!BIND conv2d_1_3
//!SAVE conv2d_2_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.026644066, 0.0034359621, 0.01291977, -0.00559978);
    result += mat4(0.0026636901, 0.045504823, 0.062066205, -0.008880998, -0.00411176, 0.015292099, 0.0073646954, -0.0475728, -0.013349281, -0.07506882, -0.1006681, 0.1028369, -0.04201462, -0.005790319, -0.0012919891, -0.059550937) * conv2d_1_0_texOff(vec2(-1, -1));
    result += mat4(0.026240079, 0.019473184, -0.0048894878, -0.010719278, -0.0050918935, 0.044043902, 0.02527041, 0.05020401, 0.10100809, -0.05209071, -0.034114793, 0.0139190685, -0.023241777, -0.12299086, 0.0133303385, -0.2400381) * conv2d_1_0_texOff(vec2(0, -1));
    result += mat4(0.04303676, 0.012787927, -0.011564702, -0.07557861, 0.05384297, 0.027572934, 0.027256727, 0.06650736, -0.22361235, -0.10519426, 0.06985452, -0.19050193, 0.2372576, 0.124692455, 0.056593288, -0.0023709657) * conv2d_1_0_texOff(vec2(1, -1));
    result += mat4(0.103685535, 0.20243387, -0.038518876, 0.048770748, -0.0075933714, -0.014240977, -0.061634418, 0.21386868, 0.042488556, 0.14918818, -0.00626454, -0.2720592, -0.083754204, 0.12543438, -0.032062016, 0.0028670772) * conv2d_1_0_texOff(vec2(-1, 0));
    result += mat4(0.4056511, -0.12901996, -0.014229969, 0.21804598, -0.0061029783, -0.13510644, -0.033577446, 0.43510506, 0.13216454, 0.05053597, 0.042552736, 0.12705435, -0.19926366, 0.39183295, 0.39098197, -0.3384084) * conv2d_1_0_texOff(vec2(0, 0));
    result += mat4(-0.5607021, 0.21313053, 0.042494744, -0.28097078, 0.026736109, 0.094672784, -0.018075425, 0.2264976, 0.19156823, -0.00396934, -0.07054004, 0.25335956, -0.31334838, 0.29566953, 0.15411568, -0.1149641) * conv2d_1_0_texOff(vec2(1, 0));
    result += mat4(-0.12773708, -1.155441, 0.005953651, -0.46491727, -0.0725161, -0.38175568, 0.02182076, -0.055183038, -0.01066495, -3.3641841, -0.09494905, 0.04667828, 0.03735797, 0.2798904, 0.050247617, 0.116932176) * conv2d_1_0_texOff(vec2(-1, 1));
    result += mat4(0.25060686, -0.7826498, 0.34533167, 1.4211726, -0.07280008, -0.78571653, 0.20044187, 0.2107139, -0.006713672, -3.4742649, -0.0010381539, -0.13255438, 0.007665934, 0.17634872, -0.065820284, -0.043773055) * conv2d_1_0_texOff(vec2(0, 1));
    result += mat4(0.06913697, 0.14532623, -0.23764633, 0.28106403, 0.010054932, -0.24475773, -0.046645857, 0.3343575, 0.05471596, -2.9104364, 0.114206165, -0.1566298, -0.1021547, 0.35150668, -0.09331033, 0.060763422) * conv2d_1_0_texOff(vec2(1, 1));
    result += mat4(-0.046245288, 0.029256359, -0.13024329, -0.13976024, 0.011761939, 0.055544447, 0.031039072, -0.024434982, 0.0075748144, -0.03453773, 0.015543969, -0.110793106, -0.075824946, -0.10970241, -0.030847168, 0.052159682) * conv2d_1_1_texOff(vec2(-1, -1));
    result += mat4(0.21084526, 0.06378808, -0.018820241, 0.025104824, 0.03404747, 0.026205014, 0.0494023, -0.09009528, -0.038554292, 0.08049235, -0.05491061, -0.016991828, -0.1362305, 0.12823999, 0.07810687, -0.020814443) * conv2d_1_1_texOff(vec2(0, -1));
    result += mat4(-0.73463315, 0.12632523, 0.03801314, -0.09843435, -0.15514512, -0.033812158, 0.06364495, -0.056822013, -0.7767236, -0.07318993, 0.017147215, -0.19203907, -0.62349766, -0.18745376, -0.0067848074, -0.03280263) * conv2d_1_1_texOff(vec2(1, -1));
    result += mat4(0.06757004, -0.58466154, 0.14347088, -0.022155365, 0.016935596, 0.04744075, 0.03353328, 0.035492588, 0.03470451, -0.7376644, 0.012366158, -0.052975643, 0.053526968, 0.15369552, -0.002713561, -0.11655027) * conv2d_1_1_texOff(vec2(-1, 0));
    result += mat4(0.56108445, 0.3905447, 0.08111457, -0.4148812, 0.048636373, -0.17283234, -0.028881175, 0.03666859, -0.12149955, -0.85328853, -0.19529189, 0.10505763, 0.26630455, 0.5003858, -0.0034972574, 0.00937355) * conv2d_1_1_texOff(vec2(0, 0));
    result += mat4(-0.09813623, -0.05804578, -0.08176221, 0.062319092, 0.2119758, -0.025760964, 0.07862289, 0.014452689, -0.1451977, -1.0066966, -0.06949981, -0.19944759, -0.053472802, -0.6881062, 0.023246605, -0.25115952) * conv2d_1_1_texOff(vec2(1, 0));
    result += mat4(-0.052293744, 0.88846356, -0.0075129415, 0.023553167, 0.011247162, -0.8044807, -0.026706582, 0.03028943, 0.009484867, 0.53414387, 0.053328972, -0.0228974, 0.016700894, -0.28613526, 0.028733253, 0.05941993) * conv2d_1_1_texOff(vec2(-1, 1));
    result += mat4(0.25722855, -1.5320756, -0.038126837, 0.21694666, -0.10533633, -0.9596058, 0.054616816, 0.019129865, 0.047445476, 0.7329473, -0.020078428, -0.05993159, -0.006629987, -2.0195227, -0.011439797, 0.052457303) * conv2d_1_1_texOff(vec2(0, 1));
    result += mat4(0.0605041, -0.1373972, 0.030174594, -0.021199614, -0.026551504, 0.5097795, -0.04979116, -0.040497746, 0.027496623, -2.2920604, 0.06209354, 0.02138253, -0.029272867, -1.7961358, 0.023084324, 0.10620968) * conv2d_1_1_texOff(vec2(1, 1));
    result += mat4(-0.010065091, -0.00763891, 0.04808219, 0.05179343, 0.012155014, -0.038952358, 0.07034075, 0.13265167, 0.044032726, 0.0024625487, 0.046196517, -0.008314385, 0.021671169, 0.0001617993, -0.016322648, -0.0742184) * conv2d_1_2_texOff(vec2(-1, -1));
    result += mat4(-0.13426131, 0.058050595, -0.030945837, -0.11666721, 0.11769839, 0.14049192, -0.089623, 0.14701013, 0.07089815, 0.006214743, 0.030165045, -0.11527725, -0.0031362965, 0.0007559506, 0.014298046, -0.032130167) * conv2d_1_2_texOff(vec2(0, -1));
    result += mat4(-0.01964119, -0.051813636, -0.025481919, -0.21550722, 0.080593675, 0.0061072246, 0.028356658, -0.035433017, 0.024395157, 0.029074943, -0.0073012067, -0.027594093, -0.037448563, -0.03487514, 0.0069612027, -0.058939934) * conv2d_1_2_texOff(vec2(1, -1));
    result += mat4(0.03421438, 0.25754726, 0.060284212, 0.04956383, 0.14222786, 0.073052995, 0.16582096, 0.4070295, -0.031461127, 0.06034744, -0.026304293, 0.07782227, -0.051377684, -0.011057006, -0.014289552, -0.018421682) * conv2d_1_2_texOff(vec2(-1, 0));
    result += mat4(0.3243416, 0.26511225, 0.34489635, 0.27077156, 0.27181748, 0.20193245, 0.1837199, -0.08034095, -0.12687859, -0.05776684, -0.053054083, -0.042805247, 0.05514121, -0.026326768, -0.018168362, -0.06437127) * conv2d_1_2_texOff(vec2(0, 0));
    result += mat4(0.2017732, 0.23192774, -0.018353475, -0.0014091467, 0.017860584, -0.0010579189, -0.041463755, 0.10039678, 0.00438727, -0.14251593, 0.08442485, 0.045846704, 0.02502844, 0.01713686, -0.042104274, 0.110902555) * conv2d_1_2_texOff(vec2(1, 0));
    result += mat4(-0.006788884, 0.060291946, -0.05935449, -0.051870726, -0.16477232, -0.73363674, -0.027909707, 0.14584514, -0.018679593, 0.27152926, 0.045760516, -0.026055297, -0.048353188, 0.049990315, 0.04247048, -0.006715155) * conv2d_1_2_texOff(vec2(-1, 1));
    result += mat4(-0.039304394, -0.65931624, 0.08826594, 0.048369218, 0.14499986, -1.0777208, -0.0062141987, 0.14950015, 0.029411776, 0.285203, 0.002805003, -0.13353534, 0.04172097, -0.3217432, 0.24635492, -0.108494334) * conv2d_1_2_texOff(vec2(0, 1));
    result += mat4(0.10871781, -0.4917801, 0.09421995, -0.057461236, 0.048649635, -1.2288821, 0.052425202, -0.017569825, 0.056759246, 0.11927216, -0.07061702, -0.21411107, 0.012818788, -0.7443022, 0.085984096, -0.09379416) * conv2d_1_2_texOff(vec2(1, 1));
    result += mat4(0.0451776, -0.0443184, 0.031168815, 0.061718326, -0.043752845, -0.02800522, -0.042447012, -0.11359071, 0.030218843, 0.05372262, 0.04102787, 0.03208186, -0.020059878, 0.038900677, 0.033137336, 0.0027926) * conv2d_1_3_texOff(vec2(-1, -1));
    result += mat4(-0.056141444, 0.0142154265, -0.00701089, 0.027392669, 0.13507651, 0.16109197, 0.113903396, 0.12660083, 0.08368416, -0.039584666, 0.04737135, 0.038148176, -0.030945074, 0.013725103, -0.03794523, -0.014694913) * conv2d_1_3_texOff(vec2(0, -1));
    result += mat4(0.03931668, -0.014098366, 0.0092319725, 0.02633128, 0.04325641, -0.04011396, -0.10966308, 0.3448921, 0.08270008, 0.011265193, 0.033872787, -0.062207818, 0.008272695, -0.021250652, 0.050191477, 0.078740686) * conv2d_1_3_texOff(vec2(1, -1));
    result += mat4(-0.29917732, -0.057704862, 0.2971307, -0.030169884, 0.014525799, -0.20604001, -0.06759038, -0.08469938, 0.020411849, -0.046972223, 0.01661068, 0.058228936, 0.06695921, 0.01662957, 0.066620156, 0.042245623) * conv2d_1_3_texOff(vec2(-1, 0));
    result += mat4(0.11022856, 0.07680184, -0.06671146, 0.53029007, -0.049003147, 0.3436512, 0.046681415, -0.29876107, 0.022896491, 0.21284649, -0.013418779, 0.14527372, -0.11284193, -0.24935538, -0.08567846, 0.2764048) * conv2d_1_3_texOff(vec2(0, 0));
    result += mat4(-0.08449688, -0.011147097, 0.06517317, -0.049577795, -0.19069603, -0.1467909, -0.055285268, -0.26289472, 0.066939145, -0.025858382, 0.064462245, 0.01746375, -0.6977837, 0.10943567, 0.09017466, -0.3464121) * conv2d_1_3_texOff(vec2(1, 0));
    result += mat4(-0.0065774093, 0.3137664, -0.011781333, -0.015299364, -0.032876994, 0.34641656, -0.05540366, -0.10143875, 0.023715094, 0.10377569, 0.036199667, -0.04733205, -0.031916007, 0.22285572, -0.005122019, 0.08382498) * conv2d_1_3_texOff(vec2(-1, 1));
    result += mat4(0.0053891754, 1.0340964, -0.041194625, 0.18276784, -0.024517432, -1.2967606, -0.104881935, -0.049355622, 0.03194576, -0.13825355, 0.02477424, 0.12344183, -0.02319696, -1.5114988, 0.064019665, 0.1008395) * conv2d_1_3_texOff(vec2(0, 1));
    result += mat4(0.08167346, 0.4271778, -0.017185524, -0.015311368, 0.07620911, 0.4324744, 0.043526713, -0.15210772, -0.007699967, -0.5187902, 0.008254404, 0.09220155, -0.12686765, -2.0151863, 0.066918045, 0.0061397557) * conv2d_1_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-3-ReLU)
//!HOOK LUMA
//!BIND conv2d_2_0
//!BIND conv2d_2_1
//!BIND conv2d_2_2
//!BIND conv2d_2_3
//!SAVE conv2d_3_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.009093954, -0.046106618, -0.029771404, -0.011352834);
    result += mat4(-0.03139504, -0.37591898, 0.43405393, 0.13575876, 0.18949498, -0.023054915, 0.13963564, -0.04934544, 0.014923857, -0.1478349, -0.13283792, 0.020978948, 0.12617624, 0.122843705, 0.120498925, -0.039761595) * conv2d_2_0_texOff(vec2(-1, -1));
    result += mat4(-0.5632661, -0.53623587, 0.10180392, -0.16750282, -0.025627239, -0.15858869, -0.20231608, -0.047740806, -0.12390835, 0.09642403, -0.46697125, 0.18929575, -0.10565239, -0.36551267, 0.14202842, -0.26281643) * conv2d_2_0_texOff(vec2(0, -1));
    result += mat4(-0.37953472, -0.07359053, -0.038356077, 0.02856401, -0.055343695, -0.05569917, 0.03686956, -0.016379163, -0.15416673, -0.04698956, -0.09077844, -0.06397243, 0.04275305, -0.019328149, -0.060078025, -0.006735979) * conv2d_2_0_texOff(vec2(1, -1));
    result += mat4(-0.16446732, 0.08741287, -0.2830653, -0.046232875, 0.05919743, 0.075659625, -0.2707217, 0.26323503, 0.025266139, -0.15200922, -0.065656886, -0.04896738, -0.1334076, -0.1357827, -0.07787897, 0.22665939) * conv2d_2_0_texOff(vec2(-1, 0));
    result += mat4(-0.163388, 0.23606823, -0.4776987, -0.12101474, 0.018600307, 0.03433725, 0.21568292, -0.11361549, -0.18332775, 0.04471268, 0.42824623, -0.19352448, 0.07711884, 0.3597946, 0.3832484, -0.36390552) * conv2d_2_0_texOff(vec2(0, 0));
    result += mat4(0.020032534, 0.015862774, -0.13262424, 0.122706376, -0.22682999, -0.12152992, 0.2417263, -0.10752049, -0.11854908, -0.15984139, -0.03138054, -0.052549034, 0.019715536, 0.14383116, -0.052756935, 0.26863855) * conv2d_2_0_texOff(vec2(1, 0));
    result += mat4(0.014197971, -0.041475795, -0.27382287, 0.05071768, -0.09315317, -0.17296712, 0.3146068, 0.117063135, -0.09412329, -0.05910955, 0.06315499, -0.07533495, -0.15436152, 0.12675034, -0.023088124, 0.09295473) * conv2d_2_0_texOff(vec2(-1, 1));
    result += mat4(-0.13203485, -0.005234461, -0.19983862, -0.011995585, 0.13423443, 0.123476826, 0.01478262, -0.0024858774, 0.13374211, 0.017441293, 0.16603749, 0.037025448, -0.0029206795, 0.07814614, -0.36566874, 0.015376856) * conv2d_2_0_texOff(vec2(0, 1));
    result += mat4(-0.08066659, -0.044155236, -0.09586787, -0.05225543, 0.10154988, 0.19851063, 0.004509855, 0.010505531, 0.12985183, 0.071587354, -0.0072382772, 0.03145392, -0.19811058, -0.22562617, -0.22260386, -0.0886009) * conv2d_2_0_texOff(vec2(1, 1));
    result += mat4(-0.036992863, 0.005064238, 0.05573088, 0.049713355, 0.11112718, -0.016891243, 0.11834005, 0.05606208, -0.13711175, 0.0293474, -0.09804728, -0.038928088, -0.10303746, 0.22802731, -0.0013709404, -0.045628004) * conv2d_2_1_texOff(vec2(-1, -1));
    result += mat4(0.0461423, -0.111275785, 0.29284874, -0.03080121, -0.18483166, -0.24654534, 0.20625763, -0.14220123, 0.080272324, 0.365453, -0.22789133, 0.07482855, -0.032167256, 0.24576199, 0.5533319, -0.1771542) * conv2d_2_1_texOff(vec2(0, -1));
    result += mat4(0.040682886, -0.029892346, 0.033107746, 0.0074931616, 0.034801383, -0.019737035, -0.05302436, 0.049442973, 0.16285545, 0.22309889, 0.024612354, 0.08938908, -0.017235318, -0.23297587, 0.0014005913, -0.24685223) * conv2d_2_1_texOff(vec2(1, -1));
    result += mat4(0.12315223, -0.0155184325, 0.18853615, -0.033486865, -0.39537913, -0.15705338, 0.02918964, -0.022653721, 0.05297589, 0.064280145, 0.05204548, -0.19975647, 0.00040459665, 0.40414715, -0.21109147, -0.07613295) * conv2d_2_1_texOff(vec2(-1, 0));
    result += mat4(-0.18426616, -0.567598, -0.43349823, -0.08117534, -0.28182057, -0.04353162, -0.11591508, 0.055636313, 0.5941714, -0.11628653, -0.09274605, 0.05804102, -0.32078943, 0.3906408, -0.11527999, -0.24331) * conv2d_2_1_texOff(vec2(0, 0));
    result += mat4(0.16905127, -0.29871175, -0.14295626, 0.23055254, -0.091986425, -0.13884646, 0.04452111, -0.23876938, 0.13270846, 0.120989285, 0.041528802, 0.20027058, 0.24388282, 0.026744246, 0.15274341, 0.0840293) * conv2d_2_1_texOff(vec2(1, 0));
    result += mat4(0.12059756, 0.090242304, -0.08310769, -0.012722158, -0.260873, 0.045339096, -0.26235983, 0.064878225, 0.23190102, -0.050568465, 0.12674092, -0.019680206, 0.10233896, -0.19229718, 0.23911592, 0.14640202) * conv2d_2_1_texOff(vec2(-1, 1));
    result += mat4(-0.1588415, 0.5865907, -0.14438461, 0.047422085, -0.49207804, -0.02663791, -0.061397232, -0.14736487, -0.104081705, 0.0167303, 0.3841152, -0.02016499, 0.16472062, -0.19687694, -0.20743595, -0.13998377) * conv2d_2_1_texOff(vec2(0, 1));
    result += mat4(0.0723279, 0.18523635, 0.049303334, -0.016373513, 0.12272233, 0.061572004, -0.16944462, -0.15050516, 0.041492976, -0.14307284, 0.20441912, 0.10286354, -0.22479913, 0.09723909, 0.035278626, -0.10060937) * conv2d_2_1_texOff(vec2(1, 1));
    result += mat4(0.03969813, -0.08729173, 0.0084641995, -0.0031075603, -0.031285863, 0.23439902, -0.11018457, 0.09715723, -0.025381716, 0.2066982, 0.35813257, -0.058451284, -0.18476444, -0.18626216, 0.08801294, 0.27980557) * conv2d_2_2_texOff(vec2(-1, -1));
    result += mat4(0.08203006, -0.13873701, 0.12168716, -0.004459612, -0.0071851867, -0.18034592, 0.06161344, -0.014242642, -0.44995755, -0.34649035, -2.3022544, 0.04805136, 0.08500437, -0.18580656, 0.15868954, -0.5548782) * conv2d_2_2_texOff(vec2(0, -1));
    result += mat4(-0.07149486, -0.324451, 0.18458685, -0.06320863, -0.09327728, 0.034327447, 0.076386735, -0.07611398, -0.40669975, -0.024748065, -0.25321633, -0.5415524, -0.20751992, -0.13159831, 0.1080071, -0.17989965) * conv2d_2_2_texOff(vec2(1, -1));
    result += mat4(0.0019801091, 0.047891997, -0.006443167, -0.017722903, -0.21038678, 0.023343608, -0.087213986, 0.13225438, 0.19445656, 0.04297401, -0.13932799, -0.02958112, -0.05944142, 0.151063, 0.011572225, -0.010344348) * conv2d_2_2_texOff(vec2(-1, 0));
    result += mat4(-0.019643027, -0.0144028505, -0.22105129, 0.18617687, -0.39780256, 0.14003836, 0.0010809557, 0.14022565, -0.5407326, 0.041437577, -0.040766083, 0.09899558, -0.08571664, -0.020964747, -0.238794, 0.021449825) * conv2d_2_2_texOff(vec2(0, 0));
    result += mat4(0.034403425, -0.09352241, -0.24261291, -0.2660237, 0.1057827, 0.15276311, 0.024972416, -0.13749065, 0.06420959, 0.052182708, 0.071724616, 0.071477085, 0.098490454, -0.102253124, -0.3029897, -0.00448815) * conv2d_2_2_texOff(vec2(1, 0));
    result += mat4(0.10386644, 0.05016951, -0.075563915, 0.012272805, 0.045978643, -0.023767354, 0.16502881, 0.035445444, 0.23239508, -0.08139325, 0.14074081, 0.0395307, -0.012333446, -0.036453523, 0.011038833, 0.017250406) * conv2d_2_2_texOff(vec2(-1, 1));
    result += mat4(-0.07519559, -0.025236817, -0.12992309, -0.06488421, -0.14902125, 0.13172576, -0.00943197, -0.15763652, 0.19784911, -0.015081102, -0.12532103, 0.022510828, -0.1171489, 0.1761139, 0.027180698, 0.056955468) * conv2d_2_2_texOff(vec2(0, 1));
    result += mat4(-0.042117614, 0.010440881, 0.060444765, -0.063393496, 0.022742165, 0.024269963, -0.08270393, -0.08851121, 0.0058683488, -0.0876978, -0.015949411, -0.011186763, 0.033277657, 0.20082761, -0.050847676, -0.053953595) * conv2d_2_2_texOff(vec2(1, 1));
    result += mat4(-0.21232341, -0.8512117, 0.28511116, 0.124301836, -0.14394872, -0.89430636, 0.31695837, -0.88681895, 0.04658703, 0.09920635, 0.050403878, 0.013742579, -0.13912998, -0.26947063, -0.047857087, 0.040771708) * conv2d_2_3_texOff(vec2(-1, -1));
    result += mat4(0.14909953, -0.11244831, 0.12871851, -0.063442454, 0.8709309, 0.02320304, -0.4892738, -0.1559887, 0.07382341, 0.16965774, 0.24687065, -0.10361559, 0.14060971, -0.36530885, 0.020560449, 0.1991003) * conv2d_2_3_texOff(vec2(0, -1));
    result += mat4(0.095596604, -0.2323125, 0.06981746, 0.05534776, 1.2347633, -0.14804572, 0.081568964, -0.48416072, 0.12931208, 0.03390161, 0.0024525402, -0.04777092, 0.19054417, -0.23519683, -0.075954325, 0.10324893) * conv2d_2_3_texOff(vec2(1, -1));
    result += mat4(-0.48033154, 0.3336462, 0.057772283, -0.45017916, 0.0570117, 0.045627464, 0.14253992, -0.08261601, -0.025415896, 0.03116416, -0.14783284, 0.12425637, 0.11336388, 0.19623981, 0.26803765, -0.15741996) * conv2d_2_3_texOff(vec2(-1, 0));
    result += mat4(-0.31752434, 0.1786475, 0.1685205, 0.22519186, -0.09395428, -0.18483354, -0.11014555, 0.058792915, 0.031003501, -0.20373538, -0.16117375, 0.12755945, -0.5854539, -0.012876169, -0.09988858, 0.096702866) * conv2d_2_3_texOff(vec2(0, 0));
    result += mat4(-0.24249321, 0.14781179, 0.0012106239, -0.16162542, -0.032977916, 0.053014092, 0.28463274, -0.02218281, -0.019464843, 0.09607626, 0.074282214, -0.15227607, 0.13291718, -0.04887593, 0.07384317, 0.09813214) * conv2d_2_3_texOff(vec2(1, 0));
    result += mat4(0.13571821, -0.44730356, -1.4882036, 0.5214405, 0.06152359, -0.03502732, 0.1193646, -0.015765598, -0.06346018, 0.04121828, 0.023924753, 0.028127313, 0.15010735, -0.10139304, -0.30495396, -0.111048736) * conv2d_2_3_texOff(vec2(-1, 1));
    result += mat4(0.0058939946, -0.18045497, -0.30321455, 0.19564119, -0.016512072, -0.021385068, -0.083695054, -0.020833207, -0.052514873, 0.04538915, -0.10580721, -0.035858177, 0.13583419, -0.2883147, -0.42187527, 0.13108757) * conv2d_2_3_texOff(vec2(0, 1));
    result += mat4(0.047445584, 0.011768822, -0.17025253, -0.0031202831, 0.1340654, -0.0046162773, 0.0681209, 0.064717226, -0.05193246, 0.0013096129, 0.111623876, 0.008852086, -0.020796137, 0.041441616, -0.027958136, 0.04868799) * conv2d_2_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-3-ReLU)
//!HOOK LUMA
//!BIND conv2d_2_0
//!BIND conv2d_2_1
//!BIND conv2d_2_2
//!BIND conv2d_2_3
//!SAVE conv2d_3_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.03197685, 0.009466869, 0.009720253, 0.039991707);
    result += mat4(0.37893903, 0.029461196, -0.07913403, -0.17677213, -0.13564703, 0.0061546164, -0.014508667, -0.07446174, 0.1286484, -0.014526213, 0.023690516, -0.026472604, 0.034104735, -0.011661503, -0.02349436, -0.15787004) * conv2d_2_0_texOff(vec2(-1, -1));
    result += mat4(0.17973754, -0.025870606, -0.04362594, 0.13789046, 0.21330658, -0.0062301573, -0.038159616, 0.023180036, -0.11684705, 0.009604447, -0.010649863, -0.10914116, -0.06552211, 0.03518744, 0.012694888, -0.11660528) * conv2d_2_0_texOff(vec2(0, -1));
    result += mat4(0.06452859, -0.0018188148, -0.0074033635, -0.0051766946, 0.10563202, -0.0060778167, 0.0144405505, -0.25975505, -0.033107426, 0.01369438, 0.032051113, -0.20464087, 0.056185428, -0.005931526, -0.040381536, 0.19963878) * conv2d_2_0_texOff(vec2(1, -1));
    result += mat4(-0.3103058, -0.0014426091, -0.19712692, 0.06665031, 0.14681278, 0.011923919, 0.07417436, 0.25585368, -0.099381074, 0.11781022, 0.072132275, -0.0798054, 0.053646874, 0.03300083, -0.046118744, -0.01421105) * conv2d_2_0_texOff(vec2(-1, 0));
    result += mat4(-0.31073308, 0.12140132, 0.07259658, -0.09613751, -0.1170934, -0.034619007, 0.004716991, 0.2237734, -0.017459607, 0.30396596, 0.04244998, -0.08023382, 0.13175777, 0.3817638, -0.119583055, -0.22009438) * conv2d_2_0_texOff(vec2(0, 0));
    result += mat4(-0.038602423, -0.009261041, 0.04130815, -0.028456325, -0.0069257133, 0.03644131, 0.0002282628, 0.035437483, -0.17509446, 0.020995421, -0.03400703, 0.24009852, 0.2419408, 0.01399761, 0.026791897, -0.45194805) * conv2d_2_0_texOff(vec2(1, 0));
    result += mat4(-0.10147737, -0.08687581, -0.106373206, 0.18008259, -0.033435907, 0.048170384, 0.10435757, -0.4733361, -0.07510881, 0.055513356, 0.08802642, 0.026395272, 0.024282448, -0.03983503, -0.108089015, -0.30702028) * conv2d_2_0_texOff(vec2(-1, 1));
    result += mat4(-0.04572913, 0.038807407, -0.0427059, -0.00894672, 0.15958552, 0.10744134, 0.020510249, 0.09948813, 0.08110379, 0.04224443, 0.08228267, 0.105734825, -0.1222076, 0.016081369, -0.16655725, 0.34774745) * conv2d_2_0_texOff(vec2(0, 1));
    result += mat4(-0.10145903, 0.021042647, -0.0082651535, 0.048754748, 0.10899471, 0.07187288, -0.047488198, 0.116483375, -0.016801804, -0.041228686, -0.051476948, -0.035630748, -0.18621068, 0.047729004, 0.095745504, -0.23297389) * conv2d_2_0_texOff(vec2(1, 1));
    result += mat4(0.005734367, 0.03685439, 0.02499601, 0.2719659, -0.012392193, 0.00064525096, 0.0038660108, -0.21096927, -0.06908588, 0.052110057, 0.028235726, 0.2433543, 0.04362542, 0.041879404, -0.07352681, -0.4487334) * conv2d_2_1_texOff(vec2(-1, -1));
    result += mat4(-0.12360228, 0.016729414, -0.04290733, -0.21198723, 0.019725986, 0.009074661, -0.018515982, 0.23687911, -0.18923388, 0.021555645, -0.008871802, 0.12984817, -0.16015153, 0.07093554, 0.06394781, -0.8010943) * conv2d_2_1_texOff(vec2(0, -1));
    result += mat4(0.0221012, -0.0023415368, -0.005647753, -0.0091246, 0.04746056, -0.046625823, 0.008915393, 0.02414209, -0.079910785, 0.032733984, 0.0064547895, -0.098206885, -0.11611039, -0.011963244, 0.026545417, -1.2430792) * conv2d_2_1_texOff(vec2(1, -1));
    result += mat4(0.018286062, 0.07787173, 0.04053361, 0.3198714, 0.08884302, -0.029055543, -0.09440727, -0.07690468, -0.07908165, 0.07405705, 0.05970915, 0.20745757, 0.19865292, -0.06229548, -0.2030823, -0.53383) * conv2d_2_1_texOff(vec2(-1, 0));
    result += mat4(-0.007921443, 0.075805284, -0.030105418, 0.18413953, 0.22062647, 0.03251561, 0.022013897, -0.28956917, -0.07948229, -0.00369928, 0.038778625, 0.06671214, 0.5591264, 0.20492686, 0.09616514, 0.0163817) * conv2d_2_1_texOff(vec2(0, 0));
    result += mat4(0.13207968, -0.04410131, -0.0005425774, 0.16599797, 0.10816751, -0.016959824, 0.0075476263, -0.019818287, -0.002914562, -0.0044033327, -0.048578326, 0.09626158, 0.053525448, 0.11977648, 0.013745466, -2.315545) * conv2d_2_1_texOff(vec2(1, 0));
    result += mat4(-0.12052032, 0.0519926, 0.022980101, 0.20643046, -0.10373932, -0.03582757, -0.04091566, -0.14564225, 0.08576637, -0.027791372, 0.0879579, 0.172523, 0.120239116, 0.006110247, 0.07548316, -0.41816127) * conv2d_2_1_texOff(vec2(-1, 1));
    result += mat4(-0.049161553, 0.032522038, -0.029410522, -0.26320434, -0.19940381, 0.04008777, -0.008045143, -0.23896164, 0.44206932, -0.031835098, -0.02621084, -0.023675324, -0.05011334, -0.19800723, -0.23836961, 0.0535939) * conv2d_2_1_texOff(vec2(0, 1));
    result += mat4(-0.05496718, 0.0101593, 0.041979924, 0.044925284, -0.044922456, -0.012198926, 0.021584783, 0.21126793, 0.15055561, -0.009572472, -0.018008208, 0.4090995, 0.049061194, 0.06250413, 0.13745123, -0.022868399) * conv2d_2_1_texOff(vec2(1, 1));
    result += mat4(-0.0939945, 0.021408113, -0.040988505, -0.4418341, 0.08988295, 0.040019028, -0.019014282, -0.044736486, 0.19743088, -0.1080404, -0.1686452, -0.51512396, -0.060349002, 0.05956909, 0.023571232, 0.1039599) * conv2d_2_2_texOff(vec2(-1, -1));
    result += mat4(0.12085725, -0.019170385, -0.048719358, -0.3464677, 0.084851585, -0.03802808, 0.01708072, -0.2230396, 0.4396354, -0.012365446, 0.11286693, -0.51991636, 0.02369014, -0.06417212, -0.054144878, -0.5593772) * conv2d_2_2_texOff(vec2(0, -1));
    result += mat4(0.19084796, -0.00918441, 0.020554962, -0.2946312, -0.07484234, 0.0072653014, -0.013959481, 0.17476802, 0.1548115, -0.00068255607, 0.006365023, -0.034286655, -0.15683083, -0.03244829, -0.06638063, 0.7390953) * conv2d_2_2_texOff(vec2(1, -1));
    result += mat4(0.028709609, 0.01652505, -0.056770623, -0.18193471, 0.009310439, 0.03729884, -0.021764277, -0.18761191, -0.21660407, -0.03974824, -0.17621416, 0.0827566, -0.041147914, -0.040964626, -0.03406308, -0.319752) * conv2d_2_2_texOff(vec2(-1, 0));
    result += mat4(-0.31386158, -0.04102667, -0.10513362, -1.036077, -0.1422989, -0.123584285, -0.017489254, -0.36400154, -0.56399155, 0.21876346, 0.13502249, -0.6025036, -0.29705185, 0.012172212, -0.069099315, 0.60837084) * conv2d_2_2_texOff(vec2(0, 0));
    result += mat4(-0.3554675, -0.011191665, 0.0051719043, -0.60856956, 0.2437946, 0.00028163605, -0.015517917, -0.22459862, -0.12787163, -0.043747246, -0.017964432, 0.25179666, -0.03177197, 0.04002045, -0.026100859, -0.20909217) * conv2d_2_2_texOff(vec2(1, 0));
    result += mat4(-0.11029903, -0.002407244, -0.082475685, -0.4840578, 0.17298996, 0.06120491, -0.03881493, -0.17745546, 0.092759, -0.05453083, -0.0962216, -0.047635056, -0.06585347, -0.028480329, -0.0069189845, 0.015593754) * conv2d_2_2_texOff(vec2(-1, 1));
    result += mat4(-0.20604818, -0.050251845, -0.10691628, -0.5601715, -0.0887056, -0.07379078, -0.15468492, -0.0159541, 0.06203925, -0.106010154, 0.012874496, 0.1455384, 0.034383323, -0.008992264, -0.009715732, 0.24092267) * conv2d_2_2_texOff(vec2(0, 1));
    result += mat4(-0.0915811, -0.032262098, 0.008914765, -0.17160316, 0.048902486, -0.084567524, 0.040422224, -0.36013052, 0.11999774, -0.021290582, 0.047865834, 0.18009092, -0.04564632, -0.03301961, 0.030279774, -0.17927381) * conv2d_2_2_texOff(vec2(1, 1));
    result += mat4(-0.11416233, 0.039816156, -0.18124492, -0.06610455, 0.087441996, -0.046884093, 0.05726735, -3.765711, -0.064054765, 0.028807098, -0.00031757646, -0.12875982, 0.016545147, -0.061678987, 0.032253474, 0.2397545) * conv2d_2_3_texOff(vec2(-1, -1));
    result += mat4(0.17590956, 0.027081784, 0.0027072034, -0.04297356, -0.21598643, 0.49206418, -0.45759508, -1.9272473, -0.25017938, 0.077664606, -0.000397508, 0.20174164, 0.2726898, -0.06675011, 0.025685104, -0.12042066) * conv2d_2_3_texOff(vec2(0, -1));
    result += mat4(0.047420952, -0.017641606, -0.0029313304, 0.058260296, 0.27110732, 0.13242292, -0.18235794, -1.8893739, -0.030195795, -0.016581358, -0.001447501, 0.08176395, 0.046655018, -0.08347213, 0.012317623, -0.04790402) * conv2d_2_3_texOff(vec2(1, -1));
    result += mat4(-0.6091348, 0.20123994, -0.28800824, -0.81151146, 0.038319476, 0.024404824, 0.30499846, -0.19334753, 0.053648766, -0.16307841, -0.021395247, -0.032647878, -0.065300524, -0.055020493, 0.049905103, -0.11085886) * conv2d_2_3_texOff(vec2(-1, 0));
    result += mat4(0.21887879, 0.13360706, -0.06467966, -0.28524056, -0.12001086, 0.12892407, 0.56911814, -0.1621812, 0.47479445, -0.28701475, 0.09711453, -0.045114405, -0.22296593, 0.041357882, 0.091506965, -0.23854895) * conv2d_2_3_texOff(vec2(0, 0));
    result += mat4(0.09556192, 0.09798181, -0.00044131352, -0.16591777, -0.045971982, 0.0869465, 0.13185643, 0.5340369, -0.007127164, -0.00655284, -0.03419772, 0.027136208, -0.02467685, -0.04082877, 0.012524493, 0.20262086) * conv2d_2_3_texOff(vec2(1, 0));
    result += mat4(-1.4300147, -0.34250337, -0.21723461, 0.27289546, -0.0037726637, -0.064412974, 0.0047339955, 0.1978106, 0.08262324, -0.016738327, -0.059941836, -0.11812271, -0.043182828, -0.004949407, -0.0154561205, 0.22197235) * conv2d_2_3_texOff(vec2(-1, 1));
    result += mat4(-0.47153488, -0.14200768, 0.019477723, 0.2677832, 0.04378184, -0.0060784053, 0.022313016, 0.015855001, -0.18932775, 0.13978744, 0.10805037, 0.014322482, -0.4323616, -0.013261398, 0.15860967, -0.19852833) * conv2d_2_3_texOff(vec2(0, 1));
    result += mat4(-0.18400237, -0.08250004, 0.021548035, -0.019654367, 0.072155505, 0.016899591, 0.011339357, 0.10484389, 0.14368536, 0.0075784833, -0.04134971, -0.13728352, 0.060934767, 0.03404921, 0.04667244, -0.039446313) * conv2d_2_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-3-ReLU)
//!HOOK LUMA
//!BIND conv2d_2_0
//!BIND conv2d_2_1
//!BIND conv2d_2_2
//!BIND conv2d_2_3
//!SAVE conv2d_3_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.002013495, 0.017951693, -0.033837277, 0.0067746737);
    result += mat4(-0.19244328, -0.032445733, 0.0384929, -0.0010473132, -0.018531958, 0.09678128, -0.0048232726, 0.0942715, 0.032843415, 0.17320022, -0.10760454, 0.044555347, -0.02255001, -0.007061429, 0.032806575, -0.08771166) * conv2d_2_0_texOff(vec2(-1, -1));
    result += mat4(-0.07906122, -0.31947276, 0.029273713, -0.0667113, 0.066709384, 0.051541906, 0.010659969, 0.08550476, 0.022534713, 0.097241506, -0.13187172, 0.06076088, 0.14226279, -0.11246526, 0.14377011, -0.04610357) * conv2d_2_0_texOff(vec2(0, -1));
    result += mat4(-0.056424726, -0.012585067, 0.0077799708, 0.098485336, 0.037150968, 0.07689292, -0.040272582, 0.0152799, -0.09361864, 0.040604472, -0.03538387, -0.103867516, 0.050438877, -0.105522364, 0.036817048, -0.03142214) * conv2d_2_0_texOff(vec2(1, -1));
    result += mat4(-0.2636894, 0.5668854, -0.11931384, 0.036896404, 0.2220039, -0.12625705, -0.0012065987, -0.23907807, 0.03012159, -0.2475896, -0.06361573, -0.03686182, 0.15516458, -0.10575294, 0.043885488, -0.09594016) * conv2d_2_0_texOff(vec2(-1, 0));
    result += mat4(-0.1600004, -0.1692221, 0.16330482, -0.12133015, -0.24822308, 0.31427085, 0.047580626, -0.21857522, 0.46376118, -0.28014138, -0.047653265, -0.02585211, -0.29482922, -0.30760977, 0.65106463, 0.11640053) * conv2d_2_0_texOff(vec2(0, 0));
    result += mat4(-0.07149673, 0.03217042, -0.019210324, 0.086977474, 0.012352594, -0.15849459, 0.085542515, -0.08540329, 0.0028209207, -0.094848424, 0.053305205, 0.048215255, -0.111065395, 0.23031811, -0.14982879, 0.21885426) * conv2d_2_0_texOff(vec2(1, 0));
    result += mat4(-0.10545956, -0.10977405, -0.050232846, -0.06122222, 0.2539012, -0.1371526, 0.12088696, -0.096310265, -0.034822296, 0.109474115, 0.028194325, 0.02140806, -0.017013589, 0.048585963, -0.04915936, 0.17598474) * conv2d_2_0_texOff(vec2(-1, 1));
    result += mat4(-0.0043166913, -0.144477, 0.020302644, -0.09180306, 0.02832013, 0.3408872, 0.0051920526, -0.123616524, 0.08825121, 0.012863541, 0.003505181, 0.044100355, -0.12167099, -0.08794477, -0.03150544, -0.35386425) * conv2d_2_0_texOff(vec2(0, 1));
    result += mat4(0.0033708739, 0.011373062, 0.013439134, 0.00057548226, 0.042888053, 0.003533616, 0.09715636, -0.012319796, -0.019974139, 0.08799158, -0.06042456, 0.051348276, -0.10471078, -0.0024519826, 0.09349889, -0.06178982) * conv2d_2_0_texOff(vec2(1, 1));
    result += mat4(0.032517802, 0.0026621267, 0.038824122, -0.013348115, 0.09866215, 0.009881601, -0.02758739, -0.05274342, -0.058060784, -0.013624714, 0.030156465, -0.026986165, 0.054266397, -0.06810068, 0.026735803, -0.0965735) * conv2d_2_1_texOff(vec2(-1, -1));
    result += mat4(-0.11128844, 0.03184735, 0.04344447, -0.06814112, 0.04323502, 0.043412607, -0.032416917, -0.033644903, -0.1284383, 0.08504895, -0.024995323, 0.048360597, -0.009727119, -0.04727075, 0.026943866, -0.21939467) * conv2d_2_1_texOff(vec2(0, -1));
    result += mat4(-0.06287497, -0.024509167, -0.030477948, 0.0013769533, 0.04600945, 0.021387553, -0.054080397, 0.0151178315, -0.0483962, 0.0134980595, -0.005960856, 0.008157216, -0.012752727, 0.08711487, 0.05183089, -0.09103491) * conv2d_2_1_texOff(vec2(1, -1));
    result += mat4(0.014431399, -0.036772367, 0.13168308, 0.09967675, -0.25900555, 0.2703185, -0.0063312063, -0.11760361, -0.06957414, -0.12251451, 0.08652267, 0.05251238, 0.022356404, 0.62096053, 0.04348302, -0.23994325) * conv2d_2_1_texOff(vec2(-1, 0));
    result += mat4(0.15057287, 0.057973642, 0.091188, -0.08505121, -0.23321387, 0.24330465, 0.07079573, -0.45803636, 0.48080817, 0.04713761, -0.061762825, 0.44705275, 0.41713083, -0.094086185, 0.06796389, -0.36111745) * conv2d_2_1_texOff(vec2(0, 0));
    result += mat4(-0.0072143893, 0.082643226, -0.05239135, 0.062070966, -0.080273174, -0.006983277, -0.012073794, 0.0659655, 0.09316985, 0.11766399, -0.07481751, -0.071968384, 0.020979865, 0.031110862, 0.041505918, 0.18391557) * conv2d_2_1_texOff(vec2(1, 0));
    result += mat4(0.015800325, 0.03823791, 0.03924558, -0.078693114, -0.19943179, 0.17100905, -0.055579145, -0.053898048, 0.03966025, -0.06948847, 0.013742269, -0.1590633, 0.10510633, -0.3052228, -0.00895283, -0.133082) * conv2d_2_1_texOff(vec2(-1, 1));
    result += mat4(0.08441153, -0.06336806, 0.012379368, 0.0748601, -0.23291184, 0.12931238, 0.031974133, -0.14639105, 0.038389504, -0.010806086, 0.050610192, 0.08915213, -0.15197195, -0.111687966, -0.094980314, -0.41887787) * conv2d_2_1_texOff(vec2(0, 1));
    result += mat4(0.00038966723, 0.0023344564, 0.021530146, 0.0039533796, 0.058594193, 0.060165666, -0.007261481, 0.026254956, -0.07949878, 0.04736933, 0.0063146246, 0.15080452, 0.09165024, -0.0127395885, 0.061509617, -0.112146504) * conv2d_2_1_texOff(vec2(1, 1));
    result += mat4(0.0036831356, -0.106113285, 0.076906994, -0.06860609, 0.06863676, -0.036501423, 0.007863887, 0.05062298, -0.17322776, 0.310778, -0.1553338, 0.0873652, 0.10006397, -0.20127726, 0.036839128, 0.057538074) * conv2d_2_2_texOff(vec2(-1, -1));
    result += mat4(-0.064594775, -0.041125167, -0.0747717, -0.1767427, -0.045648757, 0.098110154, -0.07719644, 0.097599685, -0.56378084, 0.42646244, 0.12997921, -0.33762038, -0.12381468, 0.14679554, -0.08494098, 0.1405014) * conv2d_2_2_texOff(vec2(0, -1));
    result += mat4(0.023055667, -0.10348572, -0.013355914, 0.03800566, 0.10291341, 0.007403384, -0.008179721, -0.09873972, 0.009692934, 0.06847363, -0.033846196, -0.019459283, 0.08218869, -0.15122491, -0.010759968, -0.30213642) * conv2d_2_2_texOff(vec2(1, -1));
    result += mat4(-0.014648218, 0.010898572, 0.0310637, 0.21531512, 0.19265974, -0.045331158, 0.1798333, 0.07952563, 0.15418203, 0.11114002, 0.038907807, 0.0016045767, -0.0929759, 0.105738565, -0.03518507, 0.13619304) * conv2d_2_2_texOff(vec2(-1, 0));
    result += mat4(-0.25597882, 0.15448335, -0.1498883, -0.038152296, -0.3439685, 0.21562847, -0.2043657, -0.1455353, 0.09867395, 0.30487615, -0.122212864, 0.23258609, -0.020059476, -0.05289685, -0.020271178, -0.1925249) * conv2d_2_2_texOff(vec2(0, 0));
    result += mat4(-0.051781766, -0.12935151, 0.03715201, -0.3163169, 0.013879485, -0.027116481, 0.0068625407, 0.028243765, 0.018747408, 0.16512078, -0.07036779, 0.19666748, -0.2085465, -0.03016694, 0.03798086, -0.03378288) * conv2d_2_2_texOff(vec2(1, 0));
    result += mat4(-0.057851586, -0.030173728, -0.012449377, -0.15930407, 0.05714581, -0.052414212, -0.022051891, 0.044490874, -0.014140392, -0.0058592865, -0.085904814, -0.007310541, -0.0010531337, 0.033507448, -0.058864698, -0.021770317) * conv2d_2_2_texOff(vec2(-1, 1));
    result += mat4(-0.07796512, -0.08710503, 0.032889977, 0.03986305, 0.059483074, 0.009883993, -0.03376454, 0.086851, -0.106581435, -0.008685688, 0.016481083, 0.0127896285, 0.14181958, -0.034685653, 0.07180188, 0.14215942) * conv2d_2_2_texOff(vec2(0, 1));
    result += mat4(0.0897717, -0.11353723, -0.06751338, -0.09324831, -0.05255828, -0.045082834, -0.040510584, 0.024068307, 0.011639822, -0.03593605, 0.006494175, -0.010621925, 0.091854595, 0.027440771, -0.09465107, -0.064326204) * conv2d_2_2_texOff(vec2(1, 1));
    result += mat4(-0.09019981, 0.1238555, 0.028100148, 0.1607948, 0.58874655, 1.2473346, -0.14736241, 0.25600767, -0.015588784, -0.046664316, 0.081607334, 0.012406652, 0.0730226, 0.07755276, -0.07190064, 0.13347498) * conv2d_2_3_texOff(vec2(-1, -1));
    result += mat4(0.32993415, -0.19276516, 0.03674621, -0.063807525, 1.2488561, 0.24476793, 0.04880616, 0.6073971, 0.0048482246, -0.1416201, 0.3030357, -0.16945733, 0.077242844, 0.116778664, -0.116321884, 0.24363312) * conv2d_2_3_texOff(vec2(0, -1));
    result += mat4(0.02594935, 0.023782952, 0.028307274, 0.11963194, 0.4840628, 1.0102857, 0.38884804, 0.27936038, 0.09980509, 0.0056739426, 0.08783079, 0.06358447, 0.09008691, 0.08843665, -0.10601781, 0.03812305) * conv2d_2_3_texOff(vec2(1, -1));
    result += mat4(-0.6697451, 1.2100993, 0.27757406, -1.1198212, 0.059656795, -0.17533368, -0.059514873, -0.03257793, -0.034348175, 0.06768327, 0.0503886, -0.038453545, -0.1304302, 0.2527529, -0.052665185, 0.030487323) * conv2d_2_3_texOff(vec2(-1, 0));
    result += mat4(-0.27683696, 0.26943603, 0.039424516, -0.075977616, -0.0003320017, 0.15642948, 0.10330125, 0.22979422, -0.30314568, -0.3469081, 0.30163544, -0.031355433, -0.15714958, -0.121189065, 0.05068709, -0.3771409) * conv2d_2_3_texOff(vec2(0, 0));
    result += mat4(-0.122261584, -0.035094433, 0.08292668, 0.018874828, 0.14489129, 0.039954312, -0.12521411, -0.16093162, 0.14624164, 0.05556001, -0.04525103, -0.095507815, -0.029749911, 0.04424881, 0.03472817, 0.17055504) * conv2d_2_3_texOff(vec2(1, 0));
    result += mat4(-0.45446426, 0.6177883, -0.09305868, 0.02913999, 0.0030000985, -0.07949083, 0.0257773, 0.011817507, -0.019860765, 0.008087447, 0.02306534, 0.007796729, -0.0088950405, -0.009308649, -0.025112703, -0.06734964) * conv2d_2_3_texOff(vec2(-1, 1));
    result += mat4(-0.17803042, -0.06253541, -0.12226033, -0.02511907, -0.029828176, 0.131226, -0.037633233, -0.029562583, 0.052031927, -0.008945971, 0.051976632, 0.04962588, -0.14011759, 0.08021034, 0.04145528, 0.0894469) * conv2d_2_3_texOff(vec2(0, 1));
    result += mat4(0.0741707, -0.03927973, -0.07536183, -0.16477391, -0.0004491242, 0.026855236, 0.008416536, 0.05495654, 0.05229332, -0.022330288, -0.015339377, 0.0005636166, 0.019633975, 0.020482581, -0.014309795, 0.004396874) * conv2d_2_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-3-ReLU)
//!HOOK LUMA
//!BIND conv2d_2_0
//!BIND conv2d_2_1
//!BIND conv2d_2_2
//!BIND conv2d_2_3
//!SAVE conv2d_3_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.012237041, 0.016840631, 0.013321678, 0.007706652);
    result += mat4(-0.09253268, -0.31037372, 0.059195682, 0.035239045, 0.022469053, -0.06815368, -0.0069074132, -0.057629734, -0.010841238, -0.09389067, -0.03814839, 0.035245486, 0.014257425, 0.03851035, 0.024492145, 0.01494798) * conv2d_2_0_texOff(vec2(-1, -1));
    result += mat4(0.1433067, -0.30404577, -0.02661987, -0.062046237, -0.05921778, 0.15055239, 0.010894747, -0.027623756, 0.059921768, -0.0011853547, 0.09911544, -0.07290927, -0.03205436, -0.034147024, -0.051488545, 0.08135736) * conv2d_2_0_texOff(vec2(0, -1));
    result += mat4(0.032781627, -0.54118246, -0.003075039, 0.07164099, 0.07144015, -0.0006478866, -0.009499374, -0.51897645, -0.071310475, 0.0032334607, 0.015669119, -0.6009979, 0.015458561, -0.24313785, 0.019831872, -0.0339539) * conv2d_2_0_texOff(vec2(1, -1));
    result += mat4(-0.03394234, -0.713019, -0.038286902, -0.07923022, 0.04935009, 0.4898222, 0.030060124, -0.0837064, 0.016229559, -0.019386552, 0.13709599, 0.011276776, 0.028320003, -0.065775275, 0.028961128, -0.047259808) * conv2d_2_0_texOff(vec2(-1, 0));
    result += mat4(0.13810556, -0.49482358, 0.10965908, 0.0071960427, -0.021066029, -0.30214432, -0.049666196, -0.06876718, -0.21122167, -0.19679774, 0.096000545, 0.050556973, 0.026920106, -0.40690586, -0.16335258, -0.012386836) * conv2d_2_0_texOff(vec2(0, 0));
    result += mat4(0.051534373, -0.18193987, 0.005662878, -0.033747725, -0.10516578, 0.046241246, -0.0069642724, 0.17586455, -0.06287305, -0.16597241, 0.06303388, 0.12156573, 0.16277847, 0.12386714, -0.015697567, -0.27386746) * conv2d_2_0_texOff(vec2(1, 0));
    result += mat4(-0.010443169, -0.3075228, -0.05277244, -0.015552717, 0.027389022, 0.059743144, 0.04283912, 0.045986757, 0.0027940075, -0.042870894, 0.076944, 0.053725477, -0.027887765, -0.21710625, 0.00850186, -0.025661882) * conv2d_2_0_texOff(vec2(-1, 1));
    result += mat4(0.027504561, -0.43355823, 0.026347948, -0.03898752, -0.05685967, 0.18610705, 0.017202167, 0.14471565, 0.011641464, 0.09087736, 0.08877668, 0.10608464, 0.030982213, -0.05164567, -0.22469404, -0.019994719) * conv2d_2_0_texOff(vec2(0, 1));
    result += mat4(-0.0018243957, -0.23000051, -0.011605892, -0.05621964, 0.002728994, 0.045968, 0.06108526, 0.051917158, -0.05300302, -0.17184967, -0.03028342, -0.0047246553, 0.007847357, -0.1011958, 0.067006096, -0.0977127) * conv2d_2_0_texOff(vec2(1, 1));
    result += mat4(0.0064074057, -0.0073300246, 0.007951715, 0.051623534, -0.008967649, 0.11102349, 0.02588364, 0.1084567, 0.0118131265, -0.119380094, -0.0015791799, 0.037055656, -0.025625084, 0.29928297, 0.05152511, -0.015602721) * conv2d_2_1_texOff(vec2(-1, -1));
    result += mat4(0.008596643, 0.22169738, 0.012002129, 0.05114267, 0.074006714, 0.08953417, -0.053505633, 0.07517279, 0.052556504, 0.047497913, 0.02625809, -0.04683355, 0.15322371, -0.13140002, -0.043095604, 0.024350531) * conv2d_2_1_texOff(vec2(0, -1));
    result += mat4(0.046479385, -0.011660055, -0.011108348, -0.0332869, 0.045186874, -0.013450514, -0.02076097, 0.06384375, -0.010667719, 0.06404749, -0.006476996, -0.19582424, 0.029816896, 0.05833459, 0.021392114, -0.09977608) * conv2d_2_1_texOff(vec2(1, -1));
    result += mat4(0.024390876, -0.087076485, 0.0755498, -0.03492841, -0.045170166, 0.11870893, 0.007762089, -0.032235738, 0.032115474, -0.13722795, 0.043888688, 0.065312214, -0.033059813, 0.26011148, -0.028666379, 0.06542417) * conv2d_2_1_texOff(vec2(-1, 0));
    result += mat4(-0.014031898, 0.14095983, 0.09456383, -0.03441948, 0.026775718, -0.09788429, 0.108909965, -0.19124126, 0.025687918, 0.015235274, 0.053457525, 0.06871636, 0.046217237, -0.05085751, 0.28038317, 0.11137212) * conv2d_2_1_texOff(vec2(0, 0));
    result += mat4(0.112499624, -0.085310414, -0.021976942, -0.20636147, 0.030476598, -0.23223189, -0.018269857, 0.150226, 0.066493355, 0.082590766, -0.041937288, -0.0780113, 0.082534745, 0.29378417, -0.006645655, -0.034103177) * conv2d_2_1_texOff(vec2(1, 0));
    result += mat4(3.858224e-05, 0.061431114, 0.035964582, 0.060766947, -0.005997719, -1.0006844, -0.034428336, -0.06754782, 0.023257814, 0.27557495, -0.030940956, 0.027155727, 0.042578537, 0.092041604, 0.04873805, 0.07373815) * conv2d_2_1_texOff(vec2(-1, 1));
    result += mat4(0.02294465, -0.07904211, -0.016750032, 0.036815777, -0.0040773014, 0.19476639, -0.0036368908, 0.06607566, 0.02166648, 0.2633427, 0.017362233, 0.01970516, -0.039279886, 0.28867796, -0.1878874, -0.0752016) * conv2d_2_1_texOff(vec2(0, 1));
    result += mat4(-0.017432515, 0.17636788, 0.024408398, 0.04998082, 0.024812814, 0.04777254, -0.025221048, -0.0044214516, 0.028928258, 0.0040764473, 0.008961572, 0.10508208, -0.058410153, -0.023513285, 0.0858864, -0.058042344) * conv2d_2_1_texOff(vec2(1, 1));
    result += mat4(-0.009255835, 0.10798716, -0.015638942, 0.0010140006, 0.022128426, 0.13251023, 0.025268473, -0.08104042, -0.08962332, 0.10989683, -0.12783396, 0.03900268, 0.05055069, 0.050963845, 0.05555001, -0.03707802) * conv2d_2_2_texOff(vec2(-1, -1));
    result += mat4(-0.074677594, 0.021939943, 0.003915388, -0.010557592, -0.048010476, -0.19399077, 0.0043105655, -0.23440619, 0.028404579, 0.07293613, 0.053142667, -0.38918325, -0.14477526, 0.06051216, -0.021963445, 0.01099414) * conv2d_2_2_texOff(vec2(0, -1));
    result += mat4(0.102739744, 0.18273662, -0.014584407, 0.29244196, 0.0009947264, 0.06830259, -0.011213027, 0.13422163, 0.014784342, 0.095893115, 0.0040425044, 0.39984626, 0.027278638, -0.071930245, -0.03798468, -0.21047692) * conv2d_2_2_texOff(vec2(1, -1));
    result += mat4(-0.009389412, -0.05035106, -0.005752481, 0.023756046, -0.008399489, -0.10825584, 0.049120236, 0.058206197, -0.017800191, 0.31880328, -0.00741045, 0.020177545, -0.05699409, -0.06947856, -0.037836004, -0.023923064) * conv2d_2_2_texOff(vec2(-1, 0));
    result += mat4(0.03422605, 0.101679295, 0.043176416, -0.21236414, -0.057062116, -0.06435432, -0.08102767, -0.055158157, 0.1196593, -0.037806198, 0.13058482, 0.035425194, -0.009000395, 0.29069963, 0.013341352, -0.10388763) * conv2d_2_2_texOff(vec2(0, 0));
    result += mat4(0.030201403, -0.20320587, -0.01624097, -0.041135613, 0.095249906, -0.041634843, -0.01685811, -0.0874171, 0.12534268, -0.23456942, -0.07581533, 0.013098546, 0.01633888, -0.123583056, -0.017788962, -0.14522892) * conv2d_2_2_texOff(vec2(1, 0));
    result += mat4(-0.031664327, 0.10901494, -0.040779732, -0.02451184, 0.0016069983, -0.07226916, -0.0005892511, 0.013458359, -0.030760799, 0.24618976, -0.08532963, -0.019430473, 0.03777155, 0.047796868, 0.01050731, -0.031724997) * conv2d_2_2_texOff(vec2(-1, 1));
    result += mat4(0.046219096, -0.1126453, 0.06875356, -0.028035253, -0.050528582, 0.104437724, -0.03329869, -0.06706529, 0.0327562, 0.073152654, 0.02665182, -0.028910043, 0.016412769, -0.07703881, -0.03791009, -0.0373658) * conv2d_2_2_texOff(vec2(0, 1));
    result += mat4(0.010490066, 0.26143438, -0.053881157, 0.014772205, 0.034764443, 0.1334239, -0.009522307, 0.025299106, 0.059368677, 0.12474343, -0.023199277, 0.08451734, -0.0016884726, -0.029531183, 0.004045037, -0.18041083) * conv2d_2_2_texOff(vec2(1, 1));
    result += mat4(0.018167721, 0.6702042, -0.023856303, -0.06893953, 0.4138134, -0.033846468, -0.0236712, 0.7230157, 0.02913327, 0.21273452, 0.07464989, -0.024515504, -0.027250918, 0.009574753, -0.04760163, 0.02669663) * conv2d_2_3_texOff(vec2(-1, -1));
    result += mat4(0.18673357, 0.029966868, -0.010607815, 0.11731494, 0.46217972, -0.31385133, 0.386755, 0.3028572, -0.029753197, -0.27162954, -0.020683598, 0.05995404, 0.024596438, -0.02682391, -0.07204157, 0.063921005) * conv2d_2_3_texOff(vec2(0, -1));
    result += mat4(-0.037384845, -0.12453684, 0.00040231488, 0.1761165, 0.1285152, 0.15333654, 0.29901025, 0.30785927, -0.09124239, -0.03023584, 0.050723854, 0.329607, -0.037456717, 0.023151182, -0.03552642, 0.18845241) * conv2d_2_3_texOff(vec2(1, -1));
    result += mat4(-0.029636558, 0.1258242, 0.30014133, -0.9215776, 0.10654319, 0.13389178, 0.23353738, -0.010439836, -0.039217856, 0.01481335, -0.10866966, 0.009400311, -0.021369195, 0.084326945, -0.09138006, -0.019960351) * conv2d_2_3_texOff(vec2(-1, 0));
    result += mat4(0.37107202, -0.35153943, 0.002348929, 0.34303176, 0.42710748, -0.18407167, 0.4733705, 0.012169977, 0.2583424, 0.23943152, 0.39308542, -0.003211128, -0.026115078, -0.6084694, 0.034646954, 0.022119539) * conv2d_2_3_texOff(vec2(0, 0));
    result += mat4(0.0062516537, -0.24750778, 0.07262093, -0.17606023, 0.27813318, -0.18875381, -0.06680547, 0.08232854, -0.18284129, -0.11699034, -0.08349394, -0.008786976, -0.069882706, 0.2977789, -0.0276464, -0.27154484) * conv2d_2_3_texOff(vec2(1, 0));
    result += mat4(0.027129712, -0.89029205, -0.015106628, -0.5365512, 0.015661892, -0.0152935535, -0.046196945, 0.020683672, -0.011685081, -0.12178665, -0.04783443, -0.04207959, 0.002435341, 0.2063279, -0.026680242, -0.0010856502) * conv2d_2_3_texOff(vec2(-1, 1));
    result += mat4(0.1882203, 0.2266746, -0.019684797, -0.09571448, 0.01796102, 0.008326705, 0.0069343443, 0.0012043348, 0.03428547, -0.0674506, 0.16007005, 0.010333827, -0.05389978, -0.025850201, -0.0023371994, -0.13165724) * conv2d_2_3_texOff(vec2(0, 1));
    result += mat4(0.02116264, 0.34308338, -0.06602457, 0.037091967, -0.021536779, 0.21056192, 0.00848063, 0.029063003, -0.025745057, 0.10759355, -0.0394953, 0.015808199, -0.014111393, -0.02217847, 0.021839578, 0.0028474883) * conv2d_2_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-4-ReLU)
//!HOOK LUMA
//!BIND conv2d_3_0
//!BIND conv2d_3_1
//!BIND conv2d_3_2
//!BIND conv2d_3_3
//!SAVE conv2d_4_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0034821015, -0.000690439, 0.008925155, -0.013007978);
    result += mat4(0.009489293, -0.027773317, -0.014100081, -0.0126850465, -0.0053614713, 0.03179907, 0.02577175, -0.017267575, -0.011041946, 0.1497359, 0.055702817, -0.060869783, 0.016495494, 0.16727485, 0.047385555, -0.025566734) * conv2d_3_0_texOff(vec2(-1, -1));
    result += mat4(-0.027389802, 0.04692717, -0.035886377, 0.07004645, 0.0115202125, 0.058479022, 0.031674292, -0.04622172, 0.0069535277, 0.019570721, -0.061939415, 0.08360954, -0.005579002, -0.05380906, -0.032921195, 0.056105953) * conv2d_3_0_texOff(vec2(0, -1));
    result += mat4(0.012766654, 0.0030924517, -0.0074246316, 0.03018321, -0.009639229, 0.015524892, 0.0049369796, -0.003775368, -0.006556514, 0.029725665, -0.0034088618, 0.032248717, -0.0018223485, 0.01905979, 0.03277189, -0.025154939) * conv2d_3_0_texOff(vec2(1, -1));
    result += mat4(0.005557546, -0.018686004, -0.09169593, 0.08821935, 0.0054540387, -0.23842111, -0.0963912, 0.06449907, -0.013959792, -0.34355408, -0.016480863, 0.044005126, 0.004798581, 0.5989806, -0.06755217, 0.021509381) * conv2d_3_0_texOff(vec2(-1, 0));
    result += mat4(-0.0062304134, 0.05550364, 0.2328005, -0.078091145, -0.01581146, -0.015043687, -0.10616477, 0.08553141, 0.036131278, -0.07028686, 0.17200229, -0.20486078, -0.02181417, 0.015339027, -0.23746647, 0.12554795) * conv2d_3_0_texOff(vec2(0, 0));
    result += mat4(-0.002568639, -0.02902897, -0.06638004, 0.05381153, 0.0013385561, -0.004142995, -0.01903433, 0.016666306, -0.00076882035, 0.006894832, -0.029691868, -0.015705813, -0.003351211, 0.056602966, 0.10427731, -0.10154227) * conv2d_3_0_texOff(vec2(1, 0));
    result += mat4(-0.0053988607, -0.07528912, -0.018199582, 0.02546507, -0.07499131, 0.053858556, 0.042581256, -0.04401339, -0.011783253, -0.12840985, -0.011040819, 0.03668004, 0.020338934, 0.31463072, 0.050997127, -0.03933453) * conv2d_3_0_texOff(vec2(-1, 1));
    result += mat4(-0.037229113, 0.046850827, -0.054990176, 0.09173147, 0.102799185, -0.008709043, 0.0497397, -0.034603536, -0.08241012, -0.016373875, -0.056412634, 0.04287955, 0.0072518424, -0.10289912, -0.012051862, 0.02321894) * conv2d_3_0_texOff(vec2(0, 1));
    result += mat4(-0.0034903553, -0.061010063, -0.010641682, -0.017825712, -0.056043472, 0.034915842, -0.009602229, -0.0074876687, 0.017426403, 0.04295081, -0.006961116, 0.015925393, 0.005949645, 0.06463417, 0.014883644, -0.022481823) * conv2d_3_0_texOff(vec2(1, 1));
    result += mat4(0.0062589184, -0.028697722, -0.007106424, 0.002549266, 0.022500722, 0.021881158, -0.007532569, -0.0026564521, -0.043900404, 0.53011286, -0.16600353, 0.15316701, 0.009367551, 0.1309907, 0.025344178, -0.04583213) * conv2d_3_1_texOff(vec2(-1, -1));
    result += mat4(-0.005101047, -0.20025915, 0.08428169, -0.023557305, -0.06440607, -0.08143261, -0.16557145, 0.14638437, -0.039785266, -0.013874403, 0.27482605, -0.23133145, -0.014051121, 0.0008587737, -0.013790557, 0.009419344) * conv2d_3_1_texOff(vec2(0, -1));
    result += mat4(0.0043191924, 0.058091737, 0.03086602, -0.018680986, 0.030847292, 0.05797709, -0.028118845, 0.051166896, -0.03901806, -0.008239104, -0.050262667, 0.211843, 0.007861072, 0.018654166, -0.023346018, 0.0014553053) * conv2d_3_1_texOff(vec2(1, -1));
    result += mat4(0.034651157, -0.2688541, -0.009569381, 0.010925925, -0.05265457, -0.055054903, -0.083431065, 0.07626786, 0.024525769, -0.12558085, -0.029551178, -0.013412053, -0.024284635, -0.01997142, 0.023136947, -0.025673766) * conv2d_3_1_texOff(vec2(-1, 0));
    result += mat4(-0.035200316, -0.010271944, -0.15404962, 0.07194293, -0.08966891, -0.06634798, -0.23954014, 0.23415506, 0.110809125, 0.15001369, -0.0141171655, 0.0038580203, 0.078697376, -0.096526735, -0.057955496, 0.13842916) * conv2d_3_1_texOff(vec2(0, 0));
    result += mat4(0.037104562, 0.01475004, -0.02956469, -0.0019092229, -0.0021801202, -0.017556215, -0.059649177, 0.08549521, 0.07199469, 0.34994742, 0.07979711, -0.06335568, -0.027583556, -0.0019324925, 0.046762954, -0.06552829) * conv2d_3_1_texOff(vec2(1, 0));
    result += mat4(-0.032927025, -0.13204017, 0.01579133, -0.015660632, -0.046880264, -0.22581932, -0.037584748, 0.0053320336, 0.019703668, 0.4713143, -0.011595099, 0.018438136, -0.0036803554, 0.18951389, -0.0069658514, -0.019258676) * conv2d_3_1_texOff(vec2(-1, 1));
    result += mat4(0.0967197, 0.11172207, 0.047131993, -0.051256374, 0.13357691, 0.1340492, 0.05945561, 0.0018901234, 0.08094624, 0.012112562, 0.07346025, -0.08337845, -0.086047955, -0.15081005, -0.021505196, -0.01248423) * conv2d_3_1_texOff(vec2(0, 1));
    result += mat4(-0.07810362, -0.029700708, 0.005523986, -0.0036782813, -0.094941065, -0.10057476, -0.014556552, 0.003194686, -0.036551017, 0.008469397, 0.041208055, -0.05115848, 0.0032043024, 0.15333371, 0.0370977, -0.05209685) * conv2d_3_1_texOff(vec2(1, 1));
    result += mat4(-0.010918603, 0.32807934, 0.031084497, -0.06475584, 0.006005882, -0.6764937, 0.020357002, 0.007832051, -0.012824005, 0.025470994, 0.0027873325, 0.00044248183, -0.0022485459, -0.05159993, 0.006822434, -0.0016975685) * conv2d_3_2_texOff(vec2(-1, -1));
    result += mat4(0.024380643, -0.0445326, 0.08629985, -0.09649129, -0.0155199785, 0.018555496, -0.06582268, -0.09273389, 0.01960788, -0.05868754, 0.011186596, -0.025239225, 0.00514572, -0.026071422, 0.054509092, -0.08205089) * conv2d_3_2_texOff(vec2(0, -1));
    result += mat4(-0.015805993, -0.014314249, 0.034870304, -0.032171097, 0.018741297, 0.08974034, -0.016262129, -0.010281618, -0.0028829013, -0.007579302, 0.06547186, -0.061522257, -0.005513846, -0.03055464, 0.0064933817, -0.012673623) * conv2d_3_2_texOff(vec2(1, -1));
    result += mat4(0.018236624, 0.22132899, 0.027888896, -0.037653398, 0.00030045374, -0.5382957, 0.00611927, 0.0030319493, -0.012489928, 0.020783663, 0.089795336, -0.057341903, 0.034937166, 0.0234592, -0.10303218, 0.04296549) * conv2d_3_2_texOff(vec2(-1, 0));
    result += mat4(-0.034774616, -0.069523156, 0.05401104, 0.27075192, 0.012291605, -0.24131449, -0.08820372, -0.16973248, 0.03195172, 0.16910622, 0.2447775, -0.34762564, 0.038120914, 0.058178794, 0.08588183, 0.08577127) * conv2d_3_2_texOff(vec2(0, 0));
    result += mat4(0.016878748, -0.042581152, 0.051630758, -0.111545876, -0.061538693, -0.15755557, -0.059272718, -0.04685311, -0.0051978845, 0.071915716, 0.2546651, -0.2327447, 0.010664944, -0.039893407, -0.028971467, 0.028974162) * conv2d_3_2_texOff(vec2(1, 0));
    result += mat4(-0.0323396, 0.29052898, 0.009829094, -0.014655708, 0.037010092, -0.711668, -0.015814317, 0.0021145318, 0.06027267, 0.20533325, 0.02891254, -0.027703043, 0.0063109333, 0.13999546, -0.027657583, -0.00851114) * conv2d_3_2_texOff(vec2(-1, 1));
    result += mat4(-0.114042066, -0.061341304, 0.006587868, -0.027738176, -0.19293752, 0.057491545, -0.025312055, 0.0051443824, -0.20059898, -0.083573654, 0.07532941, -0.047037005, 0.29397318, -0.010920877, 0.051180024, -0.0685157) * conv2d_3_2_texOff(vec2(0, 1));
    result += mat4(0.0058009364, 0.03351931, 0.025047017, -0.016875368, -0.102492094, 0.11970267, -0.004642828, 0.02572323, -0.0006414133, 0.0059532137, 0.045738004, -0.03164843, 0.031896506, -0.04464703, -0.019317202, -0.0076391096) * conv2d_3_2_texOff(vec2(1, 1));
    result += mat4(0.014942608, 0.21788742, 0.05063443, -0.071593404, -0.02106682, -0.15746316, -0.06168267, 0.010473292, 0.0067374753, -0.23488697, 0.07172335, -0.041831918, 0.031535685, 0.33468458, -0.025831794, -0.008861543) * conv2d_3_3_texOff(vec2(-1, -1));
    result += mat4(0.020274853, 0.14836878, -0.0186724, 0.002123136, 0.016699221, -0.1338437, 0.022252262, -0.012078228, -0.036593102, -0.1800366, -0.058087017, 0.08275453, -0.05357176, -0.21002622, -0.11268638, 0.07303505) * conv2d_3_3_texOff(vec2(0, -1));
    result += mat4(-0.020612756, -0.08831165, -0.018962627, 0.004814289, -0.0077978047, 0.09438517, -0.0056109806, 0.029935155, 0.014534384, -5.4235494e-05, -0.10581292, 0.09077774, 0.04653936, 0.26227048, 0.0067760632, -0.004334402) * conv2d_3_3_texOff(vec2(1, -1));
    result += mat4(0.06661602, -1.17312, 0.09915509, 0.04633734, -0.06611919, -0.048983134, -0.0028495106, 0.053475697, -0.0007105348, -0.19527934, 0.005366361, -0.009545893, -0.13679561, 0.08339481, 0.036458407, -0.08758511) * conv2d_3_3_texOff(vec2(-1, 0));
    result += mat4(0.035683535, 0.11342541, 0.19930673, -0.27409554, 0.00059875695, -0.17787722, -0.08766668, -0.014497668, 0.22570029, -0.05276283, -0.23060998, 0.25548047, 0.19439141, -0.22159435, 0.09976562, 0.11139441) * conv2d_3_3_texOff(vec2(0, 0));
    result += mat4(0.010035014, -0.02940204, -0.030722585, 0.0148081705, 0.011199003, 0.046917155, 0.030812113, -0.008051814, -0.011545123, -0.08292705, -0.17297673, 0.14853278, -0.14099179, 0.036059856, 0.08154065, -0.07305646) * conv2d_3_3_texOff(vec2(1, 0));
    result += mat4(0.07854409, -0.5124896, -0.03403076, 0.0366933, 0.066927336, 0.104794964, 0.009555107, -0.01550003, -0.0064562107, -0.15387407, -0.002945813, 0.016042665, -0.3624994, 0.06313415, -0.015088418, -0.13468237) * conv2d_3_3_texOff(vec2(-1, 1));
    result += mat4(0.01801173, 0.07030763, 0.033099283, -0.02002024, -0.12443124, -0.059167705, 0.011728259, 0.004048073, -0.21491264, 0.108641826, -0.111090936, 0.0761683, -0.29638848, -0.052618425, -0.06385739, 0.1031675) * conv2d_3_3_texOff(vec2(0, 1));
    result += mat4(0.0026226372, -0.1116339, -0.036091506, 0.07141465, -0.10731534, 0.032683715, 0.0046686996, -0.014677367, 0.036539152, 0.004361113, -0.016831411, -0.009956042, 0.10920262, 0.054595318, 0.003000685, -0.024082249) * conv2d_3_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-4-ReLU)
//!HOOK LUMA
//!BIND conv2d_3_0
//!BIND conv2d_3_1
//!BIND conv2d_3_2
//!BIND conv2d_3_3
//!SAVE conv2d_4_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.004486471, 0.011436195, -0.008108224, 0.006421022);
    result += mat4(0.008054595, -0.05760597, -0.0127046285, -0.11422434, 0.0008386947, 0.036718354, 0.005965094, 0.10837695, -0.00937201, 0.074647225, 0.0011837771, 0.037176672, 0.007607297, -0.03235294, 0.019302443, -0.009491848) * conv2d_3_0_texOff(vec2(-1, -1));
    result += mat4(-0.065169245, -0.043351065, -0.013854184, -0.17888048, 0.044127338, 0.016512074, 0.010384147, 0.118624106, -0.021044498, -0.016420754, 0.0018297437, 0.059034582, -0.0077071516, 0.06374544, -0.018837309, 0.0516269) * conv2d_3_0_texOff(vec2(0, -1));
    result += mat4(0.013812953, -0.004885587, -0.016729655, 0.024848316, 0.01629816, 0.04331894, -0.0014174759, 0.0042137275, -0.02862538, -0.04942006, -0.013629967, -0.1519132, -0.041781895, 0.029191656, -0.00080827076, 0.048217196) * conv2d_3_0_texOff(vec2(1, -1));
    result += mat4(0.05465828, 0.10653112, -0.019188011, 0.06230822, 0.024923636, -0.038846556, -0.011035869, 0.037752934, 0.0032114885, 0.09823095, -0.013083519, 0.132179, -0.07089785, -0.028200394, 0.020072596, -0.14945073) * conv2d_3_0_texOff(vec2(-1, 0));
    result += mat4(0.056565166, 0.07150479, 0.061420508, 0.15852778, -0.22644347, 0.019766634, -0.055689443, -0.22929029, 0.038485568, 0.16723952, -0.0026333993, 0.19457282, 0.2527069, -0.009755536, 0.009056009, -0.0021000034) * conv2d_3_0_texOff(vec2(0, 0));
    result += mat4(0.021916041, -0.0074661323, -0.022776717, 0.0141780535, -0.011938058, -0.043118402, -0.013667855, 0.009841705, 0.03684278, 0.07692882, 0.012796983, 0.07920897, -0.09877573, 0.06130059, 0.054240294, 0.0059870803) * conv2d_3_0_texOff(vec2(1, 0));
    result += mat4(-0.017752912, -0.08185486, -0.06503527, -0.10561472, 0.005220385, 0.086687386, 0.017722901, 0.13457482, -0.025621187, 0.010063906, -0.03961333, -0.025233302, 0.03464027, -0.14897169, 0.039800137, -0.12192466) * conv2d_3_0_texOff(vec2(-1, 1));
    result += mat4(-0.012029554, -0.17210114, 0.089772224, -0.09705903, 0.079741985, 0.17035545, 0.10887278, 0.2767207, -0.03952406, -0.2343406, -0.12611477, 0.026258694, -0.0063543976, -0.23039515, -0.21764119, -0.18514743) * conv2d_3_0_texOff(vec2(0, 1));
    result += mat4(-0.014609126, -0.036849946, -0.032717455, 0.014928927, 0.007859108, 0.14651228, 0.010292354, 0.25726226, -0.021417568, 0.05120976, -0.028983872, -0.04987429, -0.021223959, -0.1524279, 0.098942496, -0.2350176) * conv2d_3_0_texOff(vec2(1, 1));
    result += mat4(-0.0062645283, -0.030917196, -0.009799985, 0.20031944, -0.054479584, 0.044720024, 0.005927477, 0.0137507515, 0.05466501, 0.1996982, -0.015592255, 0.07342262, -0.03377825, -0.028459884, 0.0048896964, 0.05182459) * conv2d_3_1_texOff(vec2(-1, -1));
    result += mat4(0.16513644, -0.03919094, 0.01478009, 0.111529045, -0.22198735, -0.0521673, -0.02856099, -0.2332644, -0.24125879, -0.23031686, 0.04163698, 0.22651784, 0.008939289, -0.0724111, 0.0019911162, -0.260784) * conv2d_3_1_texOff(vec2(0, -1));
    result += mat4(0.0028162987, 0.06675018, 0.001858511, 0.15357703, -0.049635924, -0.07289674, 0.0038710115, -0.07519456, 0.10703799, -0.051651128, 0.038070437, -0.37072566, 0.034323666, 0.04636791, -0.0066196164, 0.07630469) * conv2d_3_1_texOff(vec2(1, -1));
    result += mat4(-0.0033726227, 0.0057019996, -0.011636609, -0.012265043, -0.02008305, 0.04908172, 0.072547056, -0.012953669, 0.077041335, -0.21447659, -0.07399844, -0.0011508965, -0.037110474, -0.06422502, 0.04197548, 0.028162384) * conv2d_3_1_texOff(vec2(-1, 0));
    result += mat4(-0.15936874, 0.03933437, -0.030369194, -0.3639581, -0.28613383, -0.1029412, 0.23673673, -0.066955544, -0.1714181, -0.6526972, 0.12077048, -0.54001194, 0.13864024, 0.04506747, 0.017605193, -0.027056118) * conv2d_3_1_texOff(vec2(0, 0));
    result += mat4(-0.018889615, 0.17727773, 0.006928867, 0.052768722, -0.049539715, -0.08631019, 0.010981628, 0.05511366, -0.014498841, 0.08343889, -0.03594863, 0.3059114, -0.110368945, -0.07183568, -0.023269612, -0.079552315) * conv2d_3_1_texOff(vec2(1, 0));
    result += mat4(0.014428974, 0.07407337, -0.014518448, -0.025769478, -0.011257196, -0.077601016, 0.016131414, -0.080387644, -0.0030629593, -0.012811047, -0.06223334, 0.07493222, 0.0017077796, 0.019088095, 0.040250346, -0.02602515) * conv2d_3_1_texOff(vec2(-1, 1));
    result += mat4(0.03324969, 0.18104063, 0.08509577, 0.10975837, 0.033106938, -0.08362102, 0.24036364, -0.0047041127, 0.047722034, 0.38819358, 0.072768666, 0.22138174, -0.020482242, -0.33697242, -0.09412067, -0.13116597) * conv2d_3_1_texOff(vec2(0, 1));
    result += mat4(0.0076461947, 0.09298127, 0.006322427, 0.041081697, 0.025534563, -0.05985541, 0.037449714, 0.030225305, -0.024794793, 0.006843591, 0.046343803, 0.028408147, 0.0020282702, -0.01825519, 0.06752767, 0.054206014) * conv2d_3_1_texOff(vec2(1, 1));
    result += mat4(-0.026819605, 0.12695056, 0.022697084, 0.14668164, -0.0076775034, 0.04610961, 0.00015309932, 0.011815789, 0.0018914867, -0.013156144, -0.0023772726, 0.0038656443, 0.018821925, 0.08035632, 0.0040185326, 0.119376846) * conv2d_3_2_texOff(vec2(-1, -1));
    result += mat4(0.058967035, -0.011067325, 0.015737988, 0.29124355, -0.08567674, 0.05446212, 0.0032559843, -0.5638896, 0.06940115, 0.12312707, 0.00992105, 0.13641328, 0.089293666, -0.004784682, 0.012770268, 0.13229255) * conv2d_3_2_texOff(vec2(0, -1));
    result += mat4(-0.01707323, 0.0032111604, 0.01582106, 0.095011346, -0.0047699446, 0.006258691, -0.00073478953, 0.032200415, -0.07938284, -0.0031229325, 0.009823461, 0.05094397, 0.017497282, 0.012788686, 0.008119644, 0.04832641) * conv2d_3_2_texOff(vec2(1, -1));
    result += mat4(-0.04340275, -0.099092826, -0.033520028, 0.08049154, 0.00045631378, -0.08482037, 0.0069966326, -0.20060629, 0.0427687, -0.057565536, -0.0033986813, -0.07941228, 0.03134527, -0.029875835, -0.016098397, -0.05959223) * conv2d_3_2_texOff(vec2(-1, 0));
    result += mat4(0.15705279, -0.013417311, -0.102037944, 0.0059741293, -0.14612843, -0.5528511, -0.019903222, -0.54130507, 0.107802466, 0.02371327, -0.0563654, -0.17378539, -0.03872913, -0.113435596, -0.06930459, -0.012294629) * conv2d_3_2_texOff(vec2(0, 0));
    result += mat4(-0.087645076, -0.041685034, -0.000993629, -0.003203951, 0.0006721713, -0.3960591, -0.0002549441, -0.37039977, -0.07180762, 0.13643444, 0.09949598, 0.068006165, 0.027353656, -0.0044281245, -0.021017168, -0.02398797) * conv2d_3_2_texOff(vec2(1, 0));
    result += mat4(-0.006280645, 0.301106, 0.060393758, -0.030311706, 0.001803276, 0.040270753, 0.019412782, 0.039913196, -0.0016202527, 0.04930703, -0.042920016, 0.0835051, -0.00586453, 0.0937267, -0.079186, 0.084869094) * conv2d_3_2_texOff(vec2(-1, 1));
    result += mat4(0.0187981, 0.2786141, 0.1522357, -0.0799436, -0.025531836, -0.62698424, -0.1529165, 0.043772984, 0.009668471, -0.25136542, -0.16795889, -0.005765583, 0.02071583, 0.3706712, 0.20171186, 0.19190311) * conv2d_3_2_texOff(vec2(0, 1));
    result += mat4(-0.004864479, 0.112152316, 0.036165934, -0.025513867, -0.016947377, -0.3466565, -0.055057608, -0.0567016, -0.022349637, -0.17342809, 0.11000891, -0.18153484, -0.015971169, 0.15947045, -0.04385294, 0.06383435) * conv2d_3_2_texOff(vec2(1, 1));
    result += mat4(-0.008708798, 0.12245846, 0.008020415, -0.04512215, -0.004263119, 0.028144894, 0.0024383338, -0.20528056, -0.0031629193, -0.14397767, -0.013350222, -0.080553494, -0.049023658, -0.13017124, -0.020881396, -0.31586245) * conv2d_3_3_texOff(vec2(-1, -1));
    result += mat4(0.042203885, 0.10250278, -0.009374864, 0.1209694, -0.10631868, -0.09386463, -0.0075154235, -0.20230906, 0.30753413, -0.19458602, -0.023099605, -0.34287104, 0.023103023, -0.021053528, -0.014821938, -0.12937401) * conv2d_3_3_texOff(vec2(0, -1));
    result += mat4(0.0002844027, -0.084831074, -0.008763425, -0.13201767, 0.06884424, -0.041098893, -0.01119997, 0.12361056, 0.10966187, -0.02023798, -0.01675072, -0.16216677, -0.04793764, -0.0035411196, 0.015837632, -0.011866899) * conv2d_3_3_texOff(vec2(1, -1));
    result += mat4(0.02930859, -0.3499387, -0.025103021, 0.10541333, 0.06383553, -0.01158549, -0.0061088274, -0.08285697, -0.06435018, 0.15550692, 0.011422762, 0.060749665, 0.018713983, 0.35533422, 0.043027695, 0.35362625) * conv2d_3_3_texOff(vec2(-1, 0));
    result += mat4(-0.3227368, -0.06627837, -0.009231986, -0.25869715, -0.108600296, 0.045489397, 0.080093466, -0.051062305, 0.2070024, 0.34477922, -0.22870046, 0.35104373, 0.16473976, 0.060710084, 0.07223087, 0.30477777) * conv2d_3_3_texOff(vec2(0, 0));
    result += mat4(0.0938999, 0.06439779, -0.015912212, 0.095875815, -0.024997806, -0.12138904, -0.087043434, -0.24098864, 0.23672655, -0.21462908, -0.15518942, -0.047061205, -0.0073770215, 0.13218926, 0.021189312, 0.2352984) * conv2d_3_3_texOff(vec2(1, 0));
    result += mat4(-0.043939073, -0.012248698, 0.1040979, -0.21977492, -0.06642388, -0.5411432, -0.075221084, -0.093294404, 0.023390017, -0.017332949, 0.042311374, -0.0051259976, -0.042727746, -1.1595134, -0.0056059365, -0.024737274) * conv2d_3_3_texOff(vec2(-1, 1));
    result += mat4(0.037859954, 0.022804383, 0.15475157, 0.13635658, 0.033001766, 0.11888834, -0.08811682, 0.20263621, -0.039998997, -0.3698207, -0.16719098, -0.2395014, 0.02952542, -0.09047316, -0.083860874, -0.039438125) * conv2d_3_3_texOff(vec2(0, 1));
    result += mat4(-0.0070548784, 0.010067567, -0.06063097, 0.09757376, -0.009449339, 0.14482175, 0.024308404, -0.14095286, 0.0038282184, -0.03698258, -0.17879993, -0.14432411, -0.024530875, 0.026591733, 0.04790655, -0.105404444) * conv2d_3_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-4-ReLU)
//!HOOK LUMA
//!BIND conv2d_3_0
//!BIND conv2d_3_1
//!BIND conv2d_3_2
//!BIND conv2d_3_3
//!SAVE conv2d_4_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.00085590815, -0.11058401, -0.004185463, -0.0033007439);
    result += mat4(0.03823268, -0.019020189, 0.00018768836, 0.027770892, 0.017778257, 0.06785351, 0.016936855, 0.013549008, 0.024078304, 0.08316261, -0.005495352, 0.066463076, 0.046780355, -0.041758947, -0.017557176, -0.0054221856) * conv2d_3_0_texOff(vec2(-1, -1));
    result += mat4(-0.025678746, -0.10280958, 0.024094058, -0.0040769344, 0.016095359, -0.15375787, -0.021476876, 0.022859545, -0.040547997, 0.025901314, 0.020619253, -0.06908779, -0.020138957, 0.026933072, -0.03399025, 0.0028764158) * conv2d_3_0_texOff(vec2(0, -1));
    result += mat4(0.007628262, -0.13878727, -0.10763706, 0.053357467, 0.014702342, 0.09429799, -0.011309879, -0.024363752, 0.01924733, -0.027515104, -0.026817039, 0.009725977, -0.0332836, -0.12684208, -0.045493912, 0.026372673) * conv2d_3_0_texOff(vec2(1, -1));
    result += mat4(-0.064366944, -0.018640222, 0.011883216, -0.0742675, 0.0038255658, 0.048140004, -0.007838568, -0.092930645, -0.08776454, -0.035311278, -0.010420959, 0.042268436, 0.112246506, 0.08553889, -0.004101589, -0.024978181) * conv2d_3_0_texOff(vec2(-1, 0));
    result += mat4(0.033005666, 0.057112344, -0.018707704, 0.12040178, -0.024868574, 0.065879755, 0.032752957, -0.02654638, 0.016687788, -0.059444685, -0.0055422513, -0.012550685, -0.002186373, 0.058615502, 0.13555507, -0.08719716) * conv2d_3_0_texOff(vec2(0, 0));
    result += mat4(0.01071929, -0.022304386, -0.089002155, 0.04483563, -0.011982952, -0.06877027, -0.11784859, 0.038036026, 0.06239937, -0.027241068, -0.09715287, -0.007881415, -0.0877954, -0.102293424, -0.021691427, -0.10489054) * conv2d_3_0_texOff(vec2(1, 0));
    result += mat4(0.006457746, -0.13768657, -0.006150537, 0.02746698, -0.06314659, -0.14060311, -0.0039404766, 0.046657413, 0.00038164982, 0.06805547, -0.0048443777, 0.02769594, 0.0007903421, -0.023994446, -0.001164403, -0.00492129) * conv2d_3_0_texOff(vec2(-1, 1));
    result += mat4(0.04739801, 0.024451032, 0.0074115857, -0.018651037, -0.051858146, -0.1011536, 0.0102512585, -0.073696464, 0.031331535, -0.019273419, -0.01153505, -0.0034610513, -0.026108146, -0.08050173, -0.040775858, -0.018263852) * conv2d_3_0_texOff(vec2(0, 1));
    result += mat4(-0.07336693, -0.054785915, -0.0010816916, -0.0071093775, -0.003674597, 0.09670952, -0.012198478, 0.0007809784, -0.07044101, 0.0152350925, 0.01537399, 0.024172718, 0.083375245, -0.05664275, 0.031770498, 0.05458728) * conv2d_3_0_texOff(vec2(1, 1));
    result += mat4(-0.0032337923, -0.13865645, -0.014511409, -0.010342687, 0.010041881, -0.14545114, -0.0039418726, 0.047045536, -0.16806088, 0.032554418, -0.01483906, -0.067735314, -0.0037072988, 0.034718335, -0.0011665163, -0.03968599) * conv2d_3_1_texOff(vec2(-1, -1));
    result += mat4(0.105183564, -0.036910396, -0.026704492, 0.08240763, -0.18027656, -0.13785379, 0.007948856, -0.22817267, -0.1175495, -0.03729761, -0.04843841, 0.21426615, 0.06505314, -0.0075961724, -0.008818496, -0.03298748) * conv2d_3_1_texOff(vec2(0, -1));
    result += mat4(-0.0025340097, -0.047293518, 0.12153946, 0.0084230015, 0.013953263, -0.06403232, -0.35412008, 0.1169761, 0.27518418, 0.093933634, -0.18054408, 0.18026589, 0.0011440839, 0.0763932, -0.00076926313, 0.012290704) * conv2d_3_1_texOff(vec2(1, -1));
    result += mat4(0.030042555, -0.0009587555, -0.001202289, 0.029447034, -0.06954318, -0.087543786, -0.007960058, -0.12491024, -0.014970156, -0.109748, -0.015615756, -0.013737572, 0.04586475, -0.0112464, 0.021506175, 0.03597247) * conv2d_3_1_texOff(vec2(-1, 0));
    result += mat4(0.065826766, -0.11697414, -0.0022320582, -0.042270895, 0.11588371, -0.111551955, -0.07009092, 0.18297946, 0.19230916, 0.056357726, 0.0048539694, 0.12399604, -0.013110491, -0.07906368, 0.036724664, -0.19380264) * conv2d_3_1_texOff(vec2(0, 0));
    result += mat4(-0.07301905, -0.12396714, 0.026970396, 0.015073662, -0.1007614, -0.14880058, 0.1572256, -0.008956302, -0.19633359, 0.045041624, 0.027694758, -0.17924063, -0.09584804, 0.008314921, 0.0038424637, -0.068474315) * conv2d_3_1_texOff(vec2(1, 0));
    result += mat4(-0.02770373, -0.05037191, 0.0057348306, 0.010792001, -0.047242325, -0.11885265, -0.00055493787, -0.016961357, -0.0007123378, -0.12080456, -0.007890615, 0.071344964, -0.03839615, 0.07262445, -0.014579452, -0.06667177) * conv2d_3_1_texOff(vec2(-1, 1));
    result += mat4(-0.03531029, -0.048666224, 0.019286212, -0.03561909, -0.021833556, -0.0586722, -0.01131484, 0.026468305, -0.05054643, -0.06391145, 0.033776414, -0.10665902, -0.036353648, 0.03833119, -0.025905538, -0.042378392) * conv2d_3_1_texOff(vec2(0, 1));
    result += mat4(0.025932793, -0.135575, -0.016550971, 0.0056329845, 0.064621136, 0.031509116, -0.019101372, 0.0039553186, 0.011645904, -0.023366414, 0.02224235, -0.006213978, 0.044379987, 0.054857265, -0.063743204, -0.047336783) * conv2d_3_1_texOff(vec2(1, 1));
    result += mat4(-0.0491011, -0.13581134, 0.002052526, 0.005384292, 0.029966263, -0.1530521, 0.0018354566, 0.041927725, 0.00043623787, -0.026352987, -0.01611735, -0.01862278, 0.045986883, -0.019270157, -0.007055283, -0.0024951526) * conv2d_3_2_texOff(vec2(-1, -1));
    result += mat4(-0.020129455, -0.05723123, -0.016844293, -0.074482545, -0.10768988, -0.109089434, -0.027481044, -0.19331563, 0.019124715, -0.109836645, -0.03063768, 0.038573273, 0.086899795, -0.08591294, 0.06038487, 0.019893931) * conv2d_3_2_texOff(vec2(0, -1));
    result += mat4(-0.02794547, -0.044114344, 0.10325825, 0.016367923, 0.008472824, -0.11473919, -0.1469642, -0.114164285, -0.08011932, -0.06601632, 0.17313485, -0.020012712, 0.01602537, 0.08628178, -0.010208815, -0.07114934) * conv2d_3_2_texOff(vec2(1, -1));
    result += mat4(0.07052508, -0.07140108, -0.010133952, -0.04468804, 0.015952097, -0.13745204, -0.005450291, -0.024775647, -0.01606313, -0.09604996, 0.008099145, 0.063507356, -0.007996992, -0.0899111, -0.007945919, -0.04643389) * conv2d_3_2_texOff(vec2(-1, 0));
    result += mat4(-0.028486598, -0.018204065, -0.009383807, 0.1618174, -0.31363073, 0.0903481, 0.07492366, -0.3283563, -0.06553668, -0.054666102, 0.059254766, -0.013257135, 0.22222002, -0.1344024, -0.035703246, -0.062626004) * conv2d_3_2_texOff(vec2(0, 0));
    result += mat4(-0.01963202, 0.077575274, -0.07972882, -0.07012752, -0.0867664, -0.02190308, -0.77077407, -0.19539578, -0.04152809, -0.11242265, -0.3265278, -0.08167147, 0.109042324, -0.08005127, 0.33898592, 0.042894647) * conv2d_3_2_texOff(vec2(1, 0));
    result += mat4(-0.0544959, -0.07390689, 0.0061917333, 0.016077409, 0.003640489, -0.15214707, 0.0036823177, -0.046046864, 0.08307272, -0.13719694, -0.012346083, 0.02942329, 0.02306496, -0.017555742, 0.004264163, 0.0383943) * conv2d_3_2_texOff(vec2(-1, 1));
    result += mat4(-0.11323149, -0.1634854, -0.008844112, -0.06628908, 0.009997886, -0.13676918, -0.021775927, 0.020638539, -0.03315887, 0.022439217, 0.011280403, -0.07037501, 0.11955546, 0.013897899, 0.023153976, -0.022664962) * conv2d_3_2_texOff(vec2(0, 1));
    result += mat4(0.0487179, -0.123576716, 0.010465506, 0.0012189838, -0.10830605, -0.117511205, 0.014859435, -0.008250388, 0.09148619, -0.0011717153, 0.0487961, -0.007101483, 0.019734008, -0.0077297343, 0.022433942, -0.06256378) * conv2d_3_2_texOff(vec2(1, 1));
    result += mat4(-0.012916365, -0.096959665, 0.017911319, 0.09357031, -0.100207545, -0.04991088, -0.0060314247, -0.08587489, -0.0016821597, -0.025308084, 0.008480917, 0.020714363, -0.011535785, -0.13184907, -0.018957302, -0.036849733) * conv2d_3_3_texOff(vec2(-1, -1));
    result += mat4(-0.0043509216, -0.103378594, 0.023056947, 0.035153102, -0.15202156, 0.055385437, 0.02374999, 0.09936793, 0.24049987, 0.009000901, 0.005903866, -0.04819115, 0.10391678, 0.059671767, -0.03929507, -0.099223495) * conv2d_3_3_texOff(vec2(0, -1));
    result += mat4(0.037527505, -0.09505539, 0.26789346, 0.011569882, -0.00672054, 0.094594955, -0.025339717, -0.012588863, 0.078318976, -0.022854779, 0.09874017, -4.5481058e-05, -0.119791076, -0.045320753, -0.09679077, -0.012302338) * conv2d_3_3_texOff(vec2(1, -1));
    result += mat4(0.16760895, -0.02056834, 0.020374045, 0.044549715, -0.09065339, -0.15149747, -0.0025165167, 0.06937566, 0.04562528, -0.017568784, 0.013704653, 0.02587329, -0.117088094, -0.060738385, -0.00409101, -0.07064041) * conv2d_3_3_texOff(vec2(-1, 0));
    result += mat4(-0.19336312, -0.06734621, 0.2707436, 0.051509283, -0.20292477, 0.032476235, -0.012986176, -0.1253112, -0.09472151, 0.07167364, 0.016214844, -0.09924515, -0.20648772, 0.032588042, 0.18101993, -0.24171743) * conv2d_3_3_texOff(vec2(0, 0));
    result += mat4(0.030255638, -0.09769542, -0.24885134, 0.0072520077, -0.25686038, 0.012751137, -0.43052223, 0.011520737, 0.088716365, 0.06183538, -0.094725415, 0.026166975, 0.05072213, 0.08114631, -0.15193465, -0.038766105) * conv2d_3_3_texOff(vec2(1, 0));
    result += mat4(-0.019670768, -0.10830052, 0.0021040784, -0.04961861, 0.06960776, 0.100839205, 0.0031282785, 0.023023887, 0.0009936473, 0.026023826, 0.0014839089, -0.026171047, -0.38550082, -0.11392588, -0.031401917, -0.3377578) * conv2d_3_3_texOff(vec2(-1, 1));
    result += mat4(0.3704655, -0.031927153, 0.04482619, 0.035416562, -0.15818079, -0.05521503, 0.0055372827, 0.04568237, -0.14067328, 0.02658703, -0.029710643, 0.04415768, -0.21993653, 0.029578632, 0.044697993, 0.17730482) * conv2d_3_3_texOff(vec2(0, 1));
    result += mat4(-0.08173753, 0.0036346568, 0.008878552, 0.034711678, 0.02893631, -0.15060142, 0.0072369417, -0.01749959, -0.12436625, 0.0010711544, -0.09505899, 0.006413828, 0.13056184, 0.10915371, 0.17208618, -0.047722574) * conv2d_3_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-4-ReLU)
//!HOOK LUMA
//!BIND conv2d_3_0
//!BIND conv2d_3_1
//!BIND conv2d_3_2
//!BIND conv2d_3_3
//!SAVE conv2d_4_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0056808833, 0.012048282, -0.005611755, -0.0137288915);
    result += mat4(-0.02197907, -0.0730204, 0.06113036, 0.041394677, 0.001082372, -0.044437423, 0.022057764, -0.036039807, -0.04551191, 0.028281001, -0.12146636, -0.229366, -0.0018181449, 0.17487861, 0.015291132, 0.06115423) * conv2d_3_0_texOff(vec2(-1, -1));
    result += mat4(0.02983461, 0.14524809, -0.109681584, 0.051262714, -0.035724837, 0.110423036, 0.012800332, -0.04363136, 0.10323772, 0.11021576, 0.0102321105, -0.036543056, 0.0878666, 0.11746435, 0.0744654, 0.03734733) * conv2d_3_0_texOff(vec2(0, -1));
    result += mat4(0.046159673, -0.07842022, 0.01673863, -0.017782092, 0.044131894, 0.012316076, 0.005567889, 0.0030530991, 0.008948841, 0.041483127, -0.12870345, -0.014727591, -0.10680149, 0.0981459, -0.018498411, 0.004486978) * conv2d_3_0_texOff(vec2(1, -1));
    result += mat4(0.030458761, -0.039647836, 0.16062923, 0.2575752, 0.08096516, -0.13665523, -0.001818946, -0.10607577, 0.010819096, -0.2470391, 0.0060095172, -0.00054697203, -0.12670946, 0.116846085, 0.12898381, -0.103562474) * conv2d_3_0_texOff(vec2(-1, 0));
    result += mat4(0.21406847, 0.19733611, 0.112423435, 0.11183747, -0.09941286, 0.102186784, 0.032591145, 0.093449935, 0.21242698, 0.040658448, -0.09398546, -0.043863628, -0.13197222, -0.22075157, 0.40502942, -0.19924882) * conv2d_3_0_texOff(vec2(0, 0));
    result += mat4(-0.03721943, 0.0041839173, 0.015727049, -0.0041140984, -0.0010643707, -0.03894691, -0.06840327, -0.015257871, -0.060777724, 0.008749244, 0.03557323, -0.004838384, 0.14282236, 0.17729865, -0.045534145, 0.028859198) * conv2d_3_0_texOff(vec2(1, 0));
    result += mat4(0.041982155, -0.04165953, 0.07200896, 0.1163718, -0.007876423, 0.079244345, -0.118197165, -0.15689918, 0.020781554, 0.03147805, -0.0013811024, 0.0018177069, 0.023526685, 0.2752305, -0.034011584, 0.23803547) * conv2d_3_0_texOff(vec2(-1, 1));
    result += mat4(-0.08264895, 0.10073222, -0.011917952, -0.010800571, 0.037555836, -0.2430904, -0.047478646, -0.028465338, -0.026456626, -0.008213101, -0.004732031, -0.054107472, -0.004560103, 0.09223625, 0.013823333, 0.019064022) * conv2d_3_0_texOff(vec2(0, 1));
    result += mat4(0.03219394, 0.023424108, 0.007978551, -0.005790484, -0.0030962522, 0.0841648, 0.021374695, -0.005666753, 0.014922804, 0.030269317, -0.022365507, -0.0054284334, -0.038594622, 0.077741735, -0.034776017, 0.011516032) * conv2d_3_0_texOff(vec2(1, 1));
    result += mat4(0.0017663402, 0.06361975, 0.025853455, 0.0028556336, 0.0492069, -0.102475286, -0.0015403549, -0.115894616, 0.071673825, -0.33291176, 0.30381078, 0.17122293, -0.05672035, 0.1578107, -0.12214353, 0.04449601) * conv2d_3_1_texOff(vec2(-1, -1));
    result += mat4(0.049995225, -0.20009609, -0.14471719, -0.011751366, 0.079526275, -0.17444833, -0.14980733, 0.08262118, -0.19644724, 1.036655, -0.34496894, 0.22817047, -0.16291502, -0.13359761, 0.18618259, -0.010306586) * conv2d_3_1_texOff(vec2(0, -1));
    result += mat4(0.017596262, 0.021355722, 0.042025425, 0.038564675, -0.03462341, 0.010849981, -0.049665008, -0.036742024, -0.0002891857, 0.8569993, 0.36457688, 0.043817826, -0.019651368, 0.035478003, 0.05750426, 0.016170558) * conv2d_3_1_texOff(vec2(1, -1));
    result += mat4(0.036064275, 0.05824281, -0.052460678, -0.42717558, 0.11979657, -0.018621828, 0.10383658, 0.16512819, -0.045238987, -0.07318943, 0.053642068, -0.21683966, -0.03841329, 0.025648637, -0.012133466, -0.059211913) * conv2d_3_1_texOff(vec2(-1, 0));
    result += mat4(-0.10787878, -0.23087262, -0.046658896, -0.014740209, -0.22406544, -0.1745159, -0.13263509, -0.093253136, 0.014580761, 0.13457295, 0.23249811, 0.08546832, -0.10259791, 0.02757303, 0.04645754, -0.04259577) * conv2d_3_1_texOff(vec2(0, 0));
    result += mat4(-0.022519916, -0.13789079, 0.057468746, -0.005406457, 0.030663079, 0.020166889, -0.015413978, 0.032845225, 0.123367496, 0.24675392, 0.006019362, 0.008253156, -0.040797878, 0.04180443, -0.14089884, 0.037172977) * conv2d_3_1_texOff(vec2(1, 0));
    result += mat4(-0.007479569, 0.0040500965, -0.0055267448, -0.10475741, -0.07024716, -0.13866442, 0.015509751, -0.021704236, 0.026488865, -0.050155547, 0.026498694, 0.10803753, 0.03834722, 0.014083306, 0.033266302, -0.08931849) * conv2d_3_1_texOff(vec2(-1, 1));
    result += mat4(-0.013222456, 0.008537506, -0.0013008822, 0.03752056, 0.03354649, 0.18220319, 0.0026278056, 0.04864769, 0.0331724, 0.057574503, 0.012354624, 0.07086085, -0.060708188, -0.033790454, 0.024953473, 0.031416606) * conv2d_3_1_texOff(vec2(0, 1));
    result += mat4(0.006414751, -0.011741182, 0.03821488, 0.0203593, -0.026525974, -0.12438281, 0.03523268, 0.0140126655, 0.010693111, 0.22179279, -0.009424687, 0.014727395, -0.05901876, 0.16863306, 0.013297482, 0.010880199) * conv2d_3_1_texOff(vec2(1, 1));
    result += mat4(-0.0053246757, 0.30698183, -0.06947891, -0.13179196, 0.02300128, 0.11970014, 0.09707829, -0.02529241, -0.033329196, 0.15179911, -0.024787908, 0.06277704, -0.036571592, -0.2624008, 0.01061543, 0.095034525) * conv2d_3_2_texOff(vec2(-1, -1));
    result += mat4(-0.08576513, 0.0908795, 0.29666093, -0.024351185, 0.012647993, -0.524495, -0.24577762, -0.043049887, 0.068175256, -0.19777428, 0.048614997, -0.042119022, -0.0361159, 0.16981636, 0.09746712, -0.008025099) * conv2d_3_2_texOff(vec2(0, -1));
    result += mat4(0.02356727, 0.020345114, -0.06810735, 0.0012649292, -0.12164601, -0.337489, -0.0759761, 0.025231002, -0.104714304, 0.07222966, -0.020745128, 0.018536637, 0.009514033, -3.3024702e-05, 0.0021942, 0.009906382) * conv2d_3_2_texOff(vec2(1, -1));
    result += mat4(-0.020285249, -0.006766886, -0.13643064, -0.09743658, -0.033794966, -0.09006814, 0.012039127, -0.26931947, -0.02036013, 0.052120548, -0.08449211, -0.24000354, 0.027088108, -0.24193507, 0.12341676, 0.17855242) * conv2d_3_2_texOff(vec2(-1, 0));
    result += mat4(0.047577545, -0.104099624, 0.11288596, -0.090173446, -0.25930348, -0.44417518, -0.1366215, -0.193125, -0.20867528, -0.11779409, -0.10070403, -0.15855572, -0.016720278, 0.37754843, -0.01112789, -0.009810333) * conv2d_3_2_texOff(vec2(0, 0));
    result += mat4(-0.008312646, -0.04075962, -0.07447221, -0.011347075, 0.14061889, -0.404735, -0.049241852, -0.007292783, 0.15123619, 0.0936851, -0.052345313, -0.022006713, -0.08572719, -0.1308639, -0.022097846, -0.016507126) * conv2d_3_2_texOff(vec2(1, 0));
    result += mat4(0.036602877, 0.20127988, -0.0838644, 0.0076647117, 0.011910587, 0.046964355, -0.020733304, 0.07557786, -0.012831542, 0.06678074, -0.028419958, 0.036561646, -0.07071084, -0.06860319, -0.0010021605, -0.02876561) * conv2d_3_2_texOff(vec2(-1, 1));
    result += mat4(-0.010768345, -0.05174224, 0.050022498, -0.02319787, -0.025749398, -0.025470886, 0.07043637, -0.03711511, 0.10429206, 0.007661538, 0.050383728, -0.012660342, 0.01979642, 0.00938142, -0.015745826, -0.11077673) * conv2d_3_2_texOff(vec2(0, 1));
    result += mat4(0.0073033087, 0.07863004, -0.02549132, 0.012665624, 0.020566138, 0.16099732, -0.011675152, 0.0338162, -0.007961319, 0.15605652, -0.035612583, 0.018916095, -0.01897776, -0.06857568, 0.011483128, -0.011673309) * conv2d_3_2_texOff(vec2(1, 1));
    result += mat4(-0.06532008, 0.02672442, 0.058100708, -0.014401107, 0.052269816, -0.074371845, 0.04156897, 0.08539853, -0.020398822, 0.08774901, -0.18428199, -0.07143217, -0.038626384, -0.10721765, -0.104026735, -0.122649595) * conv2d_3_3_texOff(vec2(-1, -1));
    result += mat4(-0.071476154, -0.0015601891, 0.0074135596, 0.0009596054, 0.029837368, -0.29404405, -0.04851033, 0.050476253, -0.010049829, -0.39606068, 0.2524883, 0.014276672, 0.09506599, 0.20509133, 0.2231245, 0.042187896) * conv2d_3_3_texOff(vec2(0, -1));
    result += mat4(0.08205925, -0.057617247, 0.061922804, -0.025801579, 0.010669897, -0.07568819, -0.04725725, -0.022711733, 0.054012086, -0.14747323, -0.056600936, -0.037474647, -0.078735396, 0.34666348, -0.08620147, 0.057207905) * conv2d_3_3_texOff(vec2(1, -1));
    result += mat4(-0.07981163, 0.3253931, -0.11816914, -0.113299884, -0.0058959555, -0.2644837, -0.0026539252, -0.029257093, 0.01412403, -0.053878408, 0.021400359, -0.005736242, -0.31420484, 0.20826733, -0.22827208, -0.27173644) * conv2d_3_3_texOff(vec2(-1, 0));
    result += mat4(0.06686795, -0.06752481, -0.5438079, 0.16239598, 0.016461326, -0.12971431, 0.02258668, 0.06475428, 0.14740963, -0.14509022, 0.15396568, 0.16094042, 0.19157322, -0.28390884, 0.2979828, -0.110016555) * conv2d_3_3_texOff(vec2(0, 0));
    result += mat4(-0.0850188, -0.28831398, 0.08173923, -0.0188269, 0.0043411897, 0.03679123, -0.0760861, 0.027203284, -0.15933245, -0.13167891, 0.115156114, 0.027408531, 0.073973484, 0.20136672, -0.16904733, 0.021787088) * conv2d_3_3_texOff(vec2(1, 0));
    result += mat4(-0.09035476, -0.12027801, -0.062225875, -0.17554164, -0.0017133591, 0.05991543, -0.13194841, -0.047357168, 0.054911036, 0.056126744, 0.015779765, -0.025703102, -0.23057269, -0.3666273, -0.15734671, -0.024494488) * conv2d_3_3_texOff(vec2(-1, 1));
    result += mat4(-0.015522413, 0.13115236, -0.0067398734, 0.031833984, 0.03683067, -0.2237451, 0.034176663, -0.01011775, -0.08869641, -0.15834151, -0.011819446, -0.013015267, -0.23244461, 0.042234205, 0.015328606, -0.21752214) * conv2d_3_3_texOff(vec2(0, 1));
    result += mat4(0.034928884, -0.15059946, 0.04598998, -0.01167726, -0.02115161, 0.012529946, -0.023648728, 0.017242273, 0.018203966, -0.09311603, -0.007900059, -0.047443874, -0.048747633, 0.20206301, -0.029640034, 0.0013364827) * conv2d_3_3_texOff(vec2(1, 1));
    return max(result, vec4(0.0));
}

//!DESC ArtCNN C4F16 (Conv2D-5)
//!HOOK LUMA
//!BIND conv2d_4_0
//!BIND conv2d_4_1
//!BIND conv2d_4_2
//!BIND conv2d_4_3
//!SAVE conv2d_5_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0046058428, 0.005212825, 0.012921961, -0.021657614);
    result += mat4(0.19389677, -0.27225208, -0.2882981, 0.051169064, -0.0066490714, 0.11661897, 0.09581431, -0.067389786, 0.04324981, -0.009343044, -0.1244613, 0.049292274, -0.14612213, -0.07448483, 0.16295147, -0.033708435) * conv2d_4_0_texOff(vec2(-1, -1));
    result += mat4(-0.5046244, -1.1395669, -0.22023806, -0.3187139, 0.22301668, 0.17515856, -0.004108559, 0.0025478054, 0.014157969, -0.08523709, -0.09110908, -0.011753981, -0.092901215, 0.06941843, 0.08041688, 0.040902436) * conv2d_4_0_texOff(vec2(0, -1));
    result += mat4(0.7319547, -0.34011197, -0.8205684, -0.28251597, 0.21645252, 0.092770964, -0.08088839, -0.091692425, -0.07401221, -0.099718235, -0.042494584, 0.01762102, 0.055501044, 0.05928257, 0.016098335, 0.00022300667) * conv2d_4_0_texOff(vec2(1, -1));
    result += mat4(0.0016161703, 0.09953873, 0.08970216, 0.1327271, -0.016401, 0.13582356, 0.03703193, -0.02019584, -0.10886389, -0.09340892, -0.08233981, -0.059727557, 0.01139906, 0.06710453, -0.1329292, 0.06650684) * conv2d_4_0_texOff(vec2(-1, 0));
    result += mat4(0.1558217, 0.14569177, 0.22807567, 0.3020685, 0.12979834, 0.13110432, 0.7708671, 0.17314744, 0.3219217, -0.796913, -0.051907737, -0.17559808, -0.5800078, 0.7855478, -0.16054949, 0.054042686) * conv2d_4_0_texOff(vec2(0, 0));
    result += mat4(0.16729072, -0.0033539594, -0.11221695, 0.061587077, 0.10267084, 0.42151323, -0.11985879, 0.0051882192, -0.22496945, -0.16471589, 0.060481522, 0.1298748, 0.27089906, 0.21022657, -0.036798015, -0.12839426) * conv2d_4_0_texOff(vec2(1, 0));
    result += mat4(-0.008069083, -0.018361261, 0.0058130627, -0.019507505, -0.004968405, 0.10468032, 0.070409805, -0.025619831, -0.018653382, -0.07758147, 0.157201, 0.003641471, -0.06347895, 0.014764349, -0.21847312, -0.018000789) * conv2d_4_0_texOff(vec2(-1, 1));
    result += mat4(0.12193894, -0.1508844, 0.21069832, 0.056517374, 0.1745019, 0.016116083, -0.17549814, -0.00992217, -0.024773803, -0.08727088, 0.0026184153, 0.024559254, -0.3847933, 0.1625314, -0.4773209, -0.010552129) * conv2d_4_0_texOff(vec2(0, 1));
    result += mat4(-0.05026804, 0.0108059235, -0.08473639, -0.024395963, -0.073317036, 0.10680924, 0.028244872, 0.012412284, 0.1307238, 0.0037085572, -0.087195, 0.02160026, -0.28075743, 0.09972282, -0.050476495, -0.010333448) * conv2d_4_0_texOff(vec2(1, 1));
    result += mat4(-0.0121236, 0.06673866, 0.034106728, -0.05502671, -0.03263476, 0.05077971, -0.09175334, 0.0865722, -0.065320686, -0.10994492, -0.19257952, -0.008085057, 0.088351995, 0.05000395, -0.08804564, 0.002297372) * conv2d_4_1_texOff(vec2(-1, -1));
    result += mat4(0.18148836, 0.08157221, -0.21563083, -0.03854613, -0.20382254, 0.44528115, 0.6632362, 0.10012859, -0.15784386, -0.20279016, 0.30607724, 0.010845128, 0.11480156, -0.017181754, -0.2520427, -0.013962291) * conv2d_4_1_texOff(vec2(0, -1));
    result += mat4(0.07617448, 0.12374886, 0.09877941, 0.05179499, 0.22586305, 0.13381207, 0.01547748, -0.07890073, -0.19837798, -0.17193808, -0.08492975, 0.06100193, -0.03853939, -0.047186095, 0.007225524, 0.0064335666) * conv2d_4_1_texOff(vec2(1, -1));
    result += mat4(0.00050251366, 0.05349968, 0.19070026, 0.009101704, -0.00823973, 0.05938012, -0.12813334, -0.009267065, 0.00886042, -0.010747575, -0.120411426, -0.0020400167, -0.07735248, -0.048074313, 0.045966174, -0.10188805) * conv2d_4_1_texOff(vec2(-1, 0));
    result += mat4(0.47637275, 0.30827975, 0.14313719, 0.07290924, 0.3918802, 0.14753833, 0.4506131, 0.04035203, 0.5078675, -0.2089705, 0.46678248, -0.08628992, 0.69803417, -0.32316223, 0.0062144995, 0.24215809) * conv2d_4_1_texOff(vec2(0, 0));
    result += mat4(0.012016319, 0.061414074, -0.049625512, -0.06147865, -0.09082405, 0.0009342906, 0.029740458, -0.12808788, 0.02906642, 0.032953132, 0.08009774, 0.023292352, -0.079993665, -0.1158889, 0.03731151, 0.006291906) * conv2d_4_1_texOff(vec2(1, 0));
    result += mat4(0.011069854, 0.052224573, 0.017319899, -0.046655577, 0.012141326, 0.0985947, -0.014344675, -0.01632606, 0.0060027456, 0.0080376, 0.028505161, 0.012246881, 0.039454617, -0.11356179, 0.30669174, -0.0327598) * conv2d_4_1_texOff(vec2(-1, 1));
    result += mat4(0.17390352, -0.04630631, 0.21522047, 0.092027485, 0.22104979, -0.003536516, 0.15659404, 0.046261743, 0.093689404, 0.15981363, 0.20411302, -0.018281814, -0.091964126, -0.31209698, -0.029673379, -0.04541488) * conv2d_4_1_texOff(vec2(0, 1));
    result += mat4(0.06697285, -0.0119530745, -0.05018244, -0.027919305, 0.033769708, -0.03651726, 0.0972312, -0.014531796, -0.070508555, -0.03142768, -0.032039266, 0.0053280042, 0.02754257, -0.0016127621, -0.11080957, -0.040205475) * conv2d_4_1_texOff(vec2(1, 1));
    result += mat4(-0.04459316, -0.020145401, -0.070191145, 0.05478726, 0.013271327, 0.120192125, -0.11946146, -0.048723545, -0.019995572, 0.049702097, 0.4341854, 0.016926156, 0.06543606, 0.0044756634, 0.02038207, -0.005961019) * conv2d_4_2_texOff(vec2(-1, -1));
    result += mat4(-0.010252045, -0.022353375, 0.008297757, -0.005176174, -0.03806909, -0.01120082, -0.052997075, -0.08485304, -0.24879071, 0.009661233, -0.08115842, 0.20606172, 0.09437411, -0.015051135, -0.09731951, 0.073190585) * conv2d_4_2_texOff(vec2(0, -1));
    result += mat4(-0.0950823, -0.0056368955, 0.04274139, 0.060248025, -0.062246792, 0.05463412, 0.068878524, 0.10778997, 0.0053441743, -0.045129903, -0.096994266, -0.030491488, 0.17240083, 0.059293024, -0.11109345, -0.051375125) * conv2d_4_2_texOff(vec2(1, -1));
    result += mat4(-0.062367186, -0.10251947, 0.035803735, -0.023216473, -0.03482453, -0.014733565, -0.022189397, 0.01718841, -0.6877828, 0.30470863, 0.14904284, -0.55432695, 0.23189475, -0.27477595, 0.12857756, -0.07082673) * conv2d_4_2_texOff(vec2(-1, 0));
    result += mat4(0.020106582, -0.22201188, 0.10985804, -0.030566327, -0.043806694, -0.010263682, 0.029081948, 0.01480458, -0.005761393, 0.11860039, -0.110451706, 0.24077345, 0.03869298, 0.26465046, -0.14790255, 0.043383174) * conv2d_4_2_texOff(vec2(0, 0));
    result += mat4(0.060761817, -0.017527325, 0.01143561, -0.03381863, 0.05698004, 0.027646573, -0.10107021, 0.011310894, -0.04749434, 0.009203107, 0.078599855, 0.022043923, 0.12643756, 0.26718026, 0.23576681, -0.049430773) * conv2d_4_2_texOff(vec2(1, 0));
    result += mat4(-0.06894599, 0.030372735, -0.095058136, 0.010405493, 0.00412649, -0.020780176, 0.10398297, 0.0959327, -0.8437872, 0.054067798, -0.56447184, -0.19882686, -0.045887846, -0.068280265, -0.054478545, 0.06178138) * conv2d_4_2_texOff(vec2(-1, 1));
    result += mat4(-0.18645425, -0.006724791, -0.2708013, -0.036270343, -0.07991544, 0.054539707, 0.054901365, -0.06866429, 0.05965903, -0.095842175, 0.014839498, 0.20018297, 0.23209353, 0.079986736, 0.19874366, 0.015036369) * conv2d_4_2_texOff(vec2(0, 1));
    result += mat4(-0.13901149, 0.10902376, -0.10668649, 0.0006584793, 0.100749545, 0.04151468, -0.023726981, -0.03544007, 0.06667295, -0.020391293, -0.051224902, 0.04423867, 0.40735385, -0.08745141, 0.1207007, 0.0074353246) * conv2d_4_2_texOff(vec2(1, 1));
    result += mat4(0.14925653, 0.10942493, -0.18713869, 0.020121653, 0.07544863, -0.10641829, -0.19798315, 0.11287987, 0.03200719, 0.12528892, -0.01733709, -0.038658936, 0.038368344, -0.041417774, -0.106817834, 0.05586089) * conv2d_4_3_texOff(vec2(-1, -1));
    result += mat4(-0.24815804, 0.050469387, 0.27696633, -0.009440993, -0.2557776, -0.19892988, 0.2756454, 0.058421057, 0.13255183, 0.24231423, -0.030450813, -0.034188997, -0.2272282, -0.17671272, 0.1626445, -0.029350769) * conv2d_4_3_texOff(vec2(0, -1));
    result += mat4(0.09582922, 0.10541782, 0.11326632, -0.012945515, -0.07312869, -0.23303384, -0.11569598, -0.063622475, -0.005206319, 0.14460406, 0.09438645, 0.03014926, -0.16861854, -0.08220482, 0.18029231, 0.023086865) * conv2d_4_3_texOff(vec2(1, -1));
    result += mat4(-0.11264253, 0.14729688, 0.21660301, -0.004237415, 0.23325214, -0.24381638, 0.11018029, -0.05075595, -0.23623419, 0.25395072, -0.06165826, -0.0061221244, -0.031547062, -0.0810339, 0.10768932, 0.03178501) * conv2d_4_3_texOff(vec2(-1, 0));
    result += mat4(0.4603194, -0.7932959, 0.15675978, -0.037893485, -0.3004102, -0.68054926, -0.4536296, -0.3313133, 0.43278825, 0.584298, 0.36294737, 0.2552247, -0.31576243, -0.30143702, -0.472689, 0.18369812) * conv2d_4_3_texOff(vec2(0, 0));
    result += mat4(-0.3314296, -0.0771972, -0.20025831, 0.07449619, -0.11189193, -0.050764713, 0.15880072, 0.07918999, 0.23864625, 0.11535901, -0.059230275, -0.037623476, -0.26347345, -0.77499944, -0.41018212, -0.20302838) * conv2d_4_3_texOff(vec2(1, 0));
    result += mat4(-0.08411099, -0.031019026, 0.15782383, -0.040728603, -0.11886809, -0.30250293, 0.23659365, 0.12095257, 0.17126809, 0.14316653, -0.2635601, -0.06740826, -0.027033098, -0.09652441, -0.046544086, 0.0032770399) * conv2d_4_3_texOff(vec2(-1, 1));
    result += mat4(0.124800056, -0.2669741, 0.17318267, 0.027937155, -0.31934997, -0.15632407, -0.31001234, -0.0040938607, 0.23215924, 0.108112164, 0.36297593, -0.050378047, 0.011474003, 0.019642692, 0.17266637, 0.028871005) * conv2d_4_3_texOff(vec2(0, 1));
    result += mat4(-0.15403704, 0.024767928, 0.030709596, -0.0033760846, 0.29057547, -0.08089044, 0.10644629, 0.08037557, -0.10780421, 0.07285366, 0.13657749, -0.021018857, -0.02233285, -0.063164905, -0.18219627, -0.08395923) * conv2d_4_3_texOff(vec2(1, 1));
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D-5)
//!HOOK LUMA
//!BIND conv2d_4_0
//!BIND conv2d_4_1
//!BIND conv2d_4_2
//!BIND conv2d_4_3
//!SAVE conv2d_5_1
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0011114611, 0.0038673887, -0.0005224372, 0.00015685732);
    result += mat4(0.39640883, 0.1604166, -0.018548254, 0.47036317, -0.11701649, 0.013824723, -0.037191533, -0.029296013, 0.05422616, 0.08891255, -0.03893731, 0.09320427, -0.0075011286, -0.15867539, 0.19763166, -0.099266075) * conv2d_4_0_texOff(vec2(-1, -1));
    result += mat4(-0.043447368, -0.28221342, -0.12871213, 2.0091877, -0.1924093, -0.050228506, -0.15984957, -0.021635447, 0.027441215, 0.012851808, -0.10008898, 0.052069057, 0.035205632, 0.04706964, 0.21787922, 0.052137747) * conv2d_4_0_texOff(vec2(0, -1));
    result += mat4(-0.92293936, -0.45945013, 0.83943176, 0.7315106, -0.19689988, -0.17791079, -0.21653867, 0.14213775, 0.07743269, -0.0067440327, 0.013130342, 0.029113768, -0.044152994, 0.0009757808, -0.010308463, -0.022070546) * conv2d_4_0_texOff(vec2(1, -1));
    result += mat4(0.12025234, 0.029835457, 0.09764192, 0.04260138, -0.20843725, 0.010845284, -0.089740954, -0.14082502, 0.098485105, -0.099805176, 0.16543896, -0.007438913, -0.094464816, 0.0132062305, -0.13963151, 0.06917212) * conv2d_4_0_texOff(vec2(-1, 0));
    result += mat4(0.21759711, 0.004735797, -0.28547624, -0.1247357, -0.3407772, 0.026643613, -0.014733567, 0.18682922, 0.48622054, 0.17722954, 0.025539394, -0.1801849, -0.37519056, -0.2224513, -0.059948396, 0.15389496) * conv2d_4_0_texOff(vec2(0, 0));
    result += mat4(0.114061505, -0.2775719, 0.14903861, 0.16544303, -0.53680956, -0.10283731, -0.06516943, 0.03935461, 0.019689482, -0.093879506, -0.20757464, 0.1053656, -0.010515173, 0.09225828, 0.3293743, 0.19285433) * conv2d_4_0_texOff(vec2(1, 0));
    result += mat4(-0.032575168, 0.042954963, 0.01543512, -0.0076845842, -0.073060706, -0.025824485, 0.037535258, -0.064655565, 0.025311591, 0.11112295, 0.098137565, 0.006335456, 0.011577739, -0.14999153, -0.10436524, -0.10841019) * conv2d_4_0_texOff(vec2(-1, 1));
    result += mat4(0.06850211, -0.01847829, 0.13557819, 0.18784161, -0.19997707, -0.123719655, -0.26020455, -0.1308247, 0.036241066, -0.21547662, 0.031609688, -0.07252322, -0.00915869, 0.011885016, -0.06832468, -0.29763076) * conv2d_4_0_texOff(vec2(0, 1));
    result += mat4(0.0054460294, 0.00016366104, 0.015167535, -0.11660705, -0.13401645, 0.046256945, 0.06987004, -0.083092585, -0.07953003, -0.043129597, 0.025720708, -0.0841534, 0.114404194, -0.015412602, -0.11773556, -0.15229551) * conv2d_4_0_texOff(vec2(1, 1));
    result += mat4(-0.07682066, 0.031393904, -0.09954423, -0.050310902, 0.19843513, 0.17195483, 0.05594714, -0.0017241768, 0.23414364, 0.07056054, -0.0070830532, -0.03047583, -0.05395951, 0.055159092, -0.1952889, 0.05822435) * conv2d_4_1_texOff(vec2(-1, -1));
    result += mat4(-0.08603872, -0.022274034, 0.052691337, -0.2624329, -0.067409046, -0.12071691, -0.2501093, 0.030475749, 0.17834793, 0.25183687, -0.3022957, -0.13442267, -0.034983378, 0.0061911396, 0.13307369, -0.050564278) * conv2d_4_1_texOff(vec2(0, -1));
    result += mat4(-0.14640597, -0.028788423, -0.08671821, -0.17104322, -0.03915151, 0.1661857, 0.30994233, -0.105096735, 0.17779788, 0.12911984, 0.13451669, -0.03788383, 0.02933811, 0.024869606, 0.09819545, -0.037525196) * conv2d_4_1_texOff(vec2(1, -1));
    result += mat4(-0.23086612, 0.072889715, 0.17193975, 0.12144614, 0.053878516, 0.0808835, -0.038890734, -0.062120676, 0.11873907, -0.04181901, 0.031711385, 0.041059215, -0.07352216, -0.1551154, 0.18779756, 0.0006897825) * conv2d_4_1_texOff(vec2(-1, 0));
    result += mat4(-0.45612088, -0.16501062, -0.06694142, 0.22924851, 0.03422126, 0.17393956, -0.32035923, 0.1369217, 0.13044347, 0.38150743, 0.4462501, 0.46364114, 3.2705964e-05, 0.32857245, 0.29168147, -0.26061118) * conv2d_4_1_texOff(vec2(0, 0));
    result += mat4(-0.17222376, -0.2687178, -0.15024178, -0.04756523, 0.033226807, 0.07303003, 0.23962349, 0.22916174, -0.051200937, 0.14334223, 0.117849626, 0.10713901, -0.13583659, -0.31175795, -0.36117485, 0.06586926) * conv2d_4_1_texOff(vec2(1, 0));
    result += mat4(-0.10960344, -0.016991504, -0.03253585, -0.01803023, -0.04212763, -0.003070873, -0.014774825, -0.062007226, 0.051523257, 0.0019569788, -0.0018109804, -0.015406127, 0.020675704, 0.13250527, 0.13950332, 0.12533231) * conv2d_4_1_texOff(vec2(-1, 1));
    result += mat4(-0.09766963, -0.022424206, 0.00036278195, 0.15453264, 0.059719924, 0.107007995, 0.01577213, -0.040380705, -0.0028466822, 0.046925608, -0.058475647, -0.08021065, -0.18278556, -0.33749336, 0.12899032, 0.10542245) * conv2d_4_1_texOff(vec2(0, 1));
    result += mat4(-0.057510205, -0.0680529, 0.03726144, 0.13160646, 0.022184618, 0.017054789, 0.058539525, 0.18420088, 0.0275572, 0.008825085, 0.0023858314, -0.0795888, -0.029388942, -0.027344778, -0.08230741, -0.32087848) * conv2d_4_1_texOff(vec2(1, 1));
    result += mat4(0.118878886, 0.09011945, 0.07534683, 0.013482446, 0.086338915, 0.10734087, 0.022168318, -0.05633644, -0.107286036, -0.26992935, -0.08521458, -0.67372936, -0.2061095, -0.13471176, -0.26200187, -0.056343216) * conv2d_4_2_texOff(vec2(-1, -1));
    result += mat4(0.102794625, 0.058351714, -0.09465631, 0.027053284, -0.084742635, 0.008540059, -0.021141963, -0.055628967, 0.059914164, 0.15191063, -0.071810596, 0.13242096, 0.01824429, -0.017515436, 0.2425463, -0.27798483) * conv2d_4_2_texOff(vec2(0, -1));
    result += mat4(0.046696525, 0.033349395, -0.03866225, -0.05662211, 0.102735415, -0.11587684, -0.037647463, 0.110694155, -0.0016731526, -0.022355525, 0.070109665, 0.15629092, -0.10723987, -0.017699908, 0.093507856, 0.119093604) * conv2d_4_2_texOff(vec2(1, -1));
    result += mat4(0.09625893, 0.007287908, 0.07406035, -0.036385946, 0.0047473204, 0.111687295, 0.006611469, -0.10992679, 0.13032511, -0.50374734, -0.08328716, -1.0770898, 0.08326173, -0.1021871, -0.030260464, 0.5657856) * conv2d_4_2_texOff(vec2(-1, 0));
    result += mat4(0.119658, -0.13478446, 0.06970789, -0.2717258, -0.11052728, -0.07097308, 0.010216505, -0.040050194, 0.013968, 0.3189454, -0.20097564, -0.24413225, 0.16743262, 0.24710712, -0.28075525, 1.1400236) * conv2d_4_2_texOff(vec2(0, 0));
    result += mat4(0.1138164, -0.00021803346, 0.008667409, 0.105987936, -0.06245829, -0.12482996, -0.10859521, 0.103108115, 0.013694051, 0.027792973, -0.06668166, -0.0044359267, -0.051680587, 0.16353033, -0.16088994, -0.15733641) * conv2d_4_2_texOff(vec2(1, 0));
    result += mat4(-0.009321868, 0.0146649955, 0.027546363, -0.06989611, 0.052979127, -0.01442452, -0.124766484, 0.011988924, -0.11435669, -0.29669708, -0.14183255, -1.5092758, 0.08696634, -0.06808778, 0.00023471624, -0.03544612) * conv2d_4_2_texOff(vec2(-1, 1));
    result += mat4(0.13749659, -0.022183452, -0.19872895, -0.24887523, 0.014172516, -0.09102993, 0.060767353, -0.087859735, -0.029894201, 0.15968496, 0.10182183, -0.04711137, -0.1134239, 0.1953176, -0.08229585, 0.5626922) * conv2d_4_2_texOff(vec2(0, 1));
    result += mat4(0.0034460868, -0.029077213, -0.06044691, -0.09942373, -0.06164951, -0.04544194, 0.006366872, -0.053108666, -0.03875131, 0.0063349865, 0.061941914, -0.12147465, -0.32060915, -0.1032727, 0.1740625, 0.3751007) * conv2d_4_2_texOff(vec2(1, 1));
    result += mat4(0.14109771, 0.3282752, -0.029266445, 0.15986797, 0.11794213, 0.02924194, 0.11607317, 0.16523695, -0.097699836, 0.052040394, -0.076466516, -0.023456309, 0.0465265, 0.010049317, 0.058866765, 0.03404191) * conv2d_4_3_texOff(vec2(-1, -1));
    result += mat4(0.041461486, -0.14022873, -0.3182195, -0.08060609, 0.18077353, 0.036311384, -0.392403, 0.031904407, 0.039807398, 0.10089023, 0.07104703, 0.0493624, 0.27432182, -0.043187845, 0.33940113, 0.13156298) * conv2d_4_3_texOff(vec2(0, -1));
    result += mat4(0.0155730285, 0.0056630187, -0.116622314, -0.14926921, 0.1424582, -0.08656676, -0.014005859, 0.14303184, 0.014974255, 0.11120006, -0.017669037, -0.08002915, 0.19712499, 0.12340735, 0.21207686, -0.08691049) * conv2d_4_3_texOff(vec2(1, -1));
    result += mat4(0.06911327, 0.11540081, 0.0063450723, -0.41313946, 0.44205692, 0.034101177, -0.35487852, -0.057533618, -0.31773725, -0.05869578, 0.364305, -0.11513399, 0.20833145, 0.113567404, 0.22643729, 0.10794549) * conv2d_4_3_texOff(vec2(-1, 0));
    result += mat4(-0.16420114, -0.17772049, 0.20299298, -0.96146286, 0.7134006, 0.27049655, 0.21545453, 0.07020976, -0.77649087, -0.16075286, -0.048828594, -0.5984206, 0.56194097, 0.16709545, -0.047654167, -0.6736176) * conv2d_4_3_texOff(vec2(0, 0));
    result += mat4(0.078912936, -0.09781227, -0.14695303, -0.12958658, 0.010782298, 0.057553593, -0.13703667, -0.13617685, -0.1750218, -0.010922046, 0.073276944, 0.055023476, 0.59961796, -0.408717, 0.11374051, 0.09685231) * conv2d_4_3_texOff(vec2(1, 0));
    result += mat4(-0.07903951, 0.13941607, 0.12942553, -0.10488867, 0.33908233, 0.0017822076, 0.22554594, -0.059773706, -0.21440332, -0.017083632, -0.21858291, 0.26524878, 0.023343144, 0.056390647, 0.047940783, 0.049762025) * conv2d_4_3_texOff(vec2(-1, 1));
    result += mat4(0.09448344, -0.073168, -0.024547528, -0.13241516, 0.19315998, -0.040555146, 0.0056549124, -0.057758577, -0.10503566, 0.17156446, 0.11847754, 0.45022973, 0.25674775, 0.040890872, 0.08936839, 0.17803407) * conv2d_4_3_texOff(vec2(0, 1));
    result += mat4(0.16619347, 0.20351814, -0.0142056495, -0.128936, -0.15587173, -0.009002632, 0.1332009, 0.09969636, 0.121941924, 0.105318554, -0.11569331, 0.022160158, 0.17116208, -0.24583699, -0.13386434, 0.0534919) * conv2d_4_3_texOff(vec2(1, 1));
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D-5)
//!HOOK LUMA
//!BIND conv2d_4_0
//!BIND conv2d_4_1
//!BIND conv2d_4_2
//!BIND conv2d_4_3
//!SAVE conv2d_5_2
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.005315173, 0.0068329074, 0.007167859, -0.0022182257);
    result += mat4(0.1819321, -0.10069715, -0.56305903, -0.031408414, -0.0010220526, 0.04410775, 0.023534155, -0.076077715, 0.016343221, -0.03915077, 0.060177393, 0.010204896, 0.03090649, 0.013399607, -0.17974426, 0.04952285) * conv2d_4_0_texOff(vec2(-1, -1));
    result += mat4(-0.6853877, 0.3509258, -1.889028, -0.7537202, -0.08943437, 0.010928991, 0.13570602, 0.085657045, 0.008678048, -0.0506846, -0.11012289, -0.04290924, 0.036576256, 0.08072861, 0.26064616, 0.07841367) * conv2d_4_0_texOff(vec2(0, -1));
    result += mat4(-0.7983655, -0.07582235, -0.81013745, -0.17003655, -0.178483, 0.0036447877, 0.35942432, 0.21794055, 0.09581998, 0.017877588, -0.07483371, -0.022427883, -0.057632413, -0.015660333, 0.053480994, 0.010001192) * conv2d_4_0_texOff(vec2(1, -1));
    result += mat4(0.10337186, 0.010249481, 0.017099844, 0.049394086, -0.057619963, -0.0063953227, 0.1928079, 0.12621345, 0.1183518, -0.05359774, -0.05365863, 0.028896667, -0.15354806, 0.016272211, -0.12500714, -0.05392304) * conv2d_4_0_texOff(vec2(-1, 0));
    result += mat4(0.011112799, -0.019715535, -0.06859227, -0.2722086, -0.2191223, -0.033132926, 0.16916408, 0.2879418, 0.4805711, -0.15429355, -0.25304192, 0.023876974, -0.6999365, 0.20885533, 0.025221128, 0.37925896) * conv2d_4_0_texOff(vec2(0, 0));
    result += mat4(-0.1818296, -0.014779359, -0.0081722485, 0.08720626, -0.24833989, -0.00966718, -0.37916672, -0.091450945, 0.054201644, 0.10518615, 0.05624916, -0.021449104, -0.11512616, -0.117606595, -0.06639914, 0.15290065) * conv2d_4_0_texOff(vec2(1, 0));
    result += mat4(-0.030962823, -0.0002851719, 0.04299268, 0.0027301516, -0.023909122, -0.0073004253, -0.023746766, -0.028603237, 0.01975406, 0.0074183145, 0.067388155, 0.09511019, -0.056096673, -0.07942487, -0.06599244, -0.05913857) * conv2d_4_0_texOff(vec2(-1, 1));
    result += mat4(0.09368116, 0.13738814, 0.005655028, -0.12111693, -0.18685599, -0.02409882, 0.09168004, -0.22705762, 0.13038078, 0.06706328, 0.12099261, 0.05291525, -0.1732984, -0.16314857, -0.23372824, -0.16478488) * conv2d_4_0_texOff(vec2(0, 1));
    result += mat4(-0.014798146, -0.049854595, -0.043482315, 0.07720533, -0.091951944, -0.0219097, 0.15792601, 0.005950095, -0.13656631, -0.027217032, -0.013535835, -0.027099103, 0.12426327, -0.047558777, 0.0145280305, 0.12486148) * conv2d_4_0_texOff(vec2(1, 1));
    result += mat4(-0.0397764, 0.013363183, 0.15334536, -0.07414761, 0.21588503, 0.069472805, 0.07559286, -0.00063712173, 0.18039605, -0.121958695, 0.07903284, 0.050454576, -0.08978905, -0.026396312, 0.1420245, -0.05388732) * conv2d_4_1_texOff(vec2(-1, -1));
    result += mat4(0.04810902, -0.09963507, 0.13604484, 0.055430148, -0.1667439, 0.252138, -0.12428751, 0.008064209, 0.103029475, -0.068082854, -0.12134497, -0.44988948, 0.034101363, -0.08167177, -0.22961035, -0.093827896) * conv2d_4_1_texOff(vec2(0, -1));
    result += mat4(-0.18063928, -0.03212599, 0.023047665, -0.062487286, -0.055016976, -0.019563297, 0.035497986, -0.09763464, 0.22336556, 0.09770599, 0.075357504, -0.08553967, 0.028924353, -0.009036933, -0.17879684, -0.09780838) * conv2d_4_1_texOff(vec2(1, -1));
    result += mat4(-0.043598723, 0.074995935, 0.10249763, 0.20742017, 0.13621221, 0.02011832, 0.039163906, 0.10367399, 0.055429846, 0.025251398, -0.00250794, -0.026109425, 0.015317543, 0.0034172588, 0.09105031, 0.10482383) * conv2d_4_1_texOff(vec2(-1, 0));
    result += mat4(0.16469331, -0.004312381, 0.12050329, -0.07711246, -0.049835697, 0.20589551, 0.10620115, -0.22307, -0.17793256, 0.12491768, -0.17090927, 0.02584684, 0.33751822, -0.11461893, -0.21403389, -0.39865944) * conv2d_4_1_texOff(vec2(0, 0));
    result += mat4(-0.19102523, -0.071873985, -0.047497097, -0.0110635795, 0.072642006, -0.008701674, -0.03073483, -0.077908516, 0.018743942, 0.0115044, -0.0039941417, 0.047056276, -0.14695308, -0.0011504737, -0.018462537, 0.09516455) * conv2d_4_1_texOff(vec2(1, 0));
    result += mat4(-0.048107676, -0.026420243, 0.051700465, -0.044607215, -0.03736821, -0.008403403, -0.02541539, -0.042960647, 0.030169304, 0.01761444, -0.024339525, 0.013791705, 0.04155985, 0.02221078, 0.10440732, 0.15130566) * conv2d_4_1_texOff(vec2(-1, 1));
    result += mat4(-0.017837455, 0.12144203, 0.11322036, -0.13330273, 0.02803301, 0.05698418, 0.091223046, 0.114012145, -0.019824836, -0.035768367, 0.017741183, -0.022839265, 0.06685652, 0.13666743, 0.10626553, -0.35538685) * conv2d_4_1_texOff(vec2(0, 1));
    result += mat4(-0.04245035, 0.00062688807, -0.101780295, 0.006774724, 0.04187574, 0.021524709, -0.04342309, 0.04481415, 0.01763527, 0.0066013397, 0.06749929, 0.007349219, -0.037265982, -0.01345228, 0.014733188, -0.030517904) * conv2d_4_1_texOff(vec2(1, 1));
    result += mat4(0.1041095, 0.008809134, 0.06763632, 0.023840217, -0.03500528, 0.002852506, 0.08582598, -0.011235882, -0.026544867, -0.13106325, 0.5031165, 0.31581768, -0.30895495, -0.018712353, 0.018321643, -0.11724277) * conv2d_4_2_texOff(vec2(-1, -1));
    result += mat4(0.11825586, -0.042725813, 0.0127466535, 0.01743529, -0.121880725, -0.069204584, 0.094399944, 0.09066489, 0.05982016, 0.09438551, 0.21537295, -0.15648238, -0.014048026, -0.003629559, -0.31901923, -0.17146479) * conv2d_4_2_texOff(vec2(0, -1));
    result += mat4(0.06392357, 0.028090622, 0.06422469, -0.042204898, -0.034293033, -0.10245152, 0.086883776, 0.11984436, 0.00022682724, -0.0068074153, -0.08130857, 0.036693417, -0.13870034, -0.037033178, -0.13801923, -8.907394e-05) * conv2d_4_2_texOff(vec2(1, -1));
    result += mat4(0.048624326, -0.019816993, -0.025073681, 0.06525542, 0.11130433, -0.041820627, -0.06333492, -0.060643375, 0.08390979, -0.36927992, 0.47846526, -0.11101287, -0.0027453324, -0.048300445, -0.17147173, 0.14212558) * conv2d_4_2_texOff(vec2(-1, 0));
    result += mat4(-0.11884089, 0.14253803, 0.13881797, -0.1512116, 0.073131405, 0.0372121, 0.12890346, 0.11168775, -0.11295762, -0.07462291, -0.37557405, 0.4378717, 0.73582184, 0.21705467, -0.07539996, 0.07238097) * conv2d_4_2_texOff(vec2(0, 0));
    result += mat4(-0.02668055, -0.018449884, 0.060646683, 0.20572701, -0.04308622, 0.108674966, -0.12060884, -0.1110968, 0.05428632, 0.021613482, -0.045123346, 0.026549077, 0.024624052, -0.020946233, -0.05628851, 0.07296458) * conv2d_4_2_texOff(vec2(1, 0));
    result += mat4(0.010177216, -0.025615431, -0.03760639, -0.0046753227, 0.033224136, -0.0791633, 0.0036944617, 0.03709486, -0.15780598, -0.39109758, 0.24438849, 0.2257188, -0.029551236, -0.033879776, -0.105515204, 0.0033823294) * conv2d_4_2_texOff(vec2(-1, 1));
    result += mat4(0.06725815, -0.054121602, -0.017513681, 0.20077823, -0.08054081, 0.1167204, -0.05521204, 0.0588108, -0.1992373, -0.035607886, 0.09266664, -0.40364465, 0.0009951696, 0.01597396, 0.042395424, 0.10316355) * conv2d_4_2_texOff(vec2(0, 1));
    result += mat4(0.032572635, -0.023501327, -0.004521173, 0.012799089, 0.11303314, -0.025744988, 0.055695202, -0.0772635, -0.056142066, -0.0045359693, 0.07583708, -0.047903445, -0.21976635, 0.06503833, -0.027291398, -0.34382978) * conv2d_4_2_texOff(vec2(1, 1));
    result += mat4(0.20864888, 0.023359869, 0.24899648, 0.0093005225, 0.017775621, -0.03836717, -0.12553127, 0.11814874, 0.005999996, 0.034393538, 0.07011576, -0.0813388, 0.005207782, -0.029377893, 0.038768012, 0.07676662) * conv2d_4_3_texOff(vec2(-1, -1));
    result += mat4(0.04669245, 0.11919337, -0.052476272, 0.077117585, -0.024063464, 0.067579955, -0.057316836, -0.15264103, 0.17680405, -0.039894905, 0.078640506, 0.18916948, 0.09564513, 0.07334921, -0.1913392, 0.16994382) * conv2d_4_3_texOff(vec2(0, -1));
    result += mat4(-0.0065509817, -0.0147284325, 0.28914604, 0.123860225, 0.14209397, 0.031994127, -0.1479914, 0.102770954, 0.027218182, 0.01326639, 0.20701481, -0.019160658, 0.16616306, -0.008583126, -0.22781608, -0.1521387) * conv2d_4_3_texOff(vec2(1, -1));
    result += mat4(0.06208931, -0.05245038, 0.26089093, -0.115328506, 0.010231228, -0.16057816, 0.043376707, -0.24909185, 0.05958783, 0.10846497, -0.13864477, -0.015445353, 0.10193929, -0.022797128, -0.18751355, -0.112518035) * conv2d_4_3_texOff(vec2(-1, 0));
    result += mat4(-0.39747435, -0.15848057, 0.38939852, -0.60420835, 0.4085152, 0.1947236, 0.75150216, 0.19412702, -0.4620192, -0.20466527, -0.44688827, -0.33231884, -0.10403903, 0.12399351, 0.14525194, -0.34896287) * conv2d_4_3_texOff(vec2(0, 0));
    result += mat4(0.11838359, 0.026589971, 0.048098754, -0.18979469, 0.19110386, 0.15475678, 0.26738, -0.29855773, -0.14984666, -0.09327831, -0.27281287, 0.09201877, 0.08395858, -0.0627008, 0.2027869, 0.18337525) * conv2d_4_3_texOff(vec2(1, 0));
    result += mat4(-0.015467469, 0.016654927, 0.111788936, 0.06669349, 0.09452079, -0.007115365, -0.121632814, 0.26020503, 0.027290927, 0.06958785, 0.11523617, -0.1523752, 0.039963838, 0.028703734, 0.037412114, 0.061600797) * conv2d_4_3_texOff(vec2(-1, 1));
    result += mat4(0.14411928, 0.116167724, 0.15479048, -0.11285714, 0.0660568, -0.13472256, -0.17743146, 0.23337655, -0.009592609, 0.07058539, -0.056988627, -0.15537742, 0.2678336, 0.14936669, -0.17730036, 0.08627947) * conv2d_4_3_texOff(vec2(0, 1));
    result += mat4(0.12774135, -0.0135159455, 0.008701118, 0.1716933, -0.14423874, 0.051691554, 0.09315147, -0.20945667, 0.10792683, -0.010766234, 0.0030609698, 0.10362881, 0.16425985, 0.015018802, -0.2064676, 0.06424018) * conv2d_4_3_texOff(vec2(1, 1));
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D-5)
//!HOOK LUMA
//!BIND conv2d_4_0
//!BIND conv2d_4_1
//!BIND conv2d_4_2
//!BIND conv2d_4_3
//!SAVE conv2d_5_3
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(-0.0065392265, 0.005505473, 0.038484864, -0.023193495);
    result += mat4(-0.004498335, 0.7382404, -0.23442575, -0.16252717, -0.026009846, 0.030434566, -0.019475065, -0.06431268, 0.03640449, -0.0040360987, -0.019910527, 0.034736615, -0.0031087424, -0.059120674, 0.013791684, 0.07218719) * conv2d_4_0_texOff(vec2(-1, -1));
    result += mat4(-0.14135005, 0.9959563, -0.07486524, -0.28778628, 0.22581334, 0.18538788, 0.015065921, -0.053519074, 0.22171287, -0.055427834, -0.033601474, -0.01870319, -0.4460602, 0.011371301, -0.030472377, 0.073513664) * conv2d_4_0_texOff(vec2(0, -1));
    result += mat4(-0.06576149, 0.8906462, 0.25279918, -0.17556128, -0.047801867, 0.2259101, -0.01251869, -0.092829406, 0.11101776, 0.016275465, -0.055292428, 0.01025174, -0.0492993, -0.00035494883, 0.028828753, -0.0046440396) * conv2d_4_0_texOff(vec2(1, -1));
    result += mat4(-0.06606361, -0.01837148, -0.061049685, 0.08262097, 0.0716313, 0.22714345, -0.015877271, -0.041385885, 0.041346684, -0.23551546, -0.00023523516, 0.032250866, -0.044792954, 0.15078856, 0.03858805, 0.08497739) * conv2d_4_0_texOff(vec2(-1, 0));
    result += mat4(0.14461994, -0.1292499, -0.29278296, -0.101024054, -0.13546948, 0.6519248, 0.0064214906, -0.022855721, 0.55985254, 0.1017415, -0.05776304, 0.19156395, -0.67645437, -0.08790101, 0.13466574, -0.09291871) * conv2d_4_0_texOff(vec2(0, 0));
    result += mat4(-0.14176573, 0.04247601, 0.03601427, 0.05184529, 0.08912003, 0.39625162, 0.021573871, -0.08251388, 0.11452551, 0.17396334, -0.09813042, 0.22368798, -0.33811107, -0.18624362, 0.16351652, -0.18633647) * conv2d_4_0_texOff(vec2(1, 0));
    result += mat4(-0.023228921, 0.015240777, 0.025224067, -0.0013570306, 0.0024748559, 0.1474697, 0.0020307095, -0.029064147, 0.043071818, 0.06558123, 0.010087709, 0.037556857, 0.0050289035, 0.019036705, -0.0029892956, -0.046553254) * conv2d_4_0_texOff(vec2(-1, 1));
    result += mat4(0.01785854, -0.0823758, -0.042477038, 0.058690716, -0.12990497, 0.23681645, 0.0335883, 0.034112733, 0.31397334, -0.23970205, -0.06736681, 0.055550084, -0.098263465, 0.19022475, 0.07386713, -0.14189075) * conv2d_4_0_texOff(vec2(0, 1));
    result += mat4(-0.037102748, -0.015309524, 0.013480297, -0.080538, 0.062314484, 0.11511907, 0.005406217, 0.010978191, 0.054147407, -0.04782157, 0.0350167, 0.028420083, 0.0006020371, -0.01542334, -0.061944753, -0.12089187) * conv2d_4_0_texOff(vec2(1, 1));
    result += mat4(-0.02389505, -0.09774415, 0.01865464, -0.0404036, -0.12988602, 0.0041870335, -0.07635182, -0.014002439, -0.050262745, -0.08412568, -0.0012902165, 0.058651965, 0.040363505, -0.010439004, 0.046584167, -0.030844558) * conv2d_4_1_texOff(vec2(-1, -1));
    result += mat4(0.27201438, -0.051534697, 0.0044010533, -0.06268029, -0.5597928, 0.40176544, 0.06774989, 0.071904086, -0.46742377, 0.19395615, -0.05584675, 0.13491926, 0.3680567, -0.08017979, 0.00958034, -0.085048616) * conv2d_4_1_texOff(vec2(0, -1));
    result += mat4(-1.9126996e-05, 0.0032694484, 0.027378296, 0.02423276, -0.3841696, -0.2068046, 0.055755295, -0.07783296, -0.12706462, -0.0627655, -0.106189005, 0.12976898, 0.060044404, -0.075718306, -0.008698159, -0.0037293625) * conv2d_4_1_texOff(vec2(1, -1));
    result += mat4(0.20093523, 0.102455445, 0.03862854, 0.0015625904, -0.14757894, -0.0007734277, -0.015811099, 0.03214036, -0.16129225, -0.30809388, -0.01148391, 0.031855796, 0.14568266, -0.2930857, 0.059234947, -0.047282416) * conv2d_4_1_texOff(vec2(-1, 0));
    result += mat4(0.85413104, -0.43009627, -0.09496212, -0.09936201, -0.78981036, 0.08809805, -0.11402425, -0.05807362, -0.39567554, -0.1358343, 0.19961269, 0.23090747, 0.7852341, -0.21848042, 0.10988736, 0.11791884) * conv2d_4_1_texOff(vec2(0, 0));
    result += mat4(0.46641496, 0.2176781, 0.053700782, -0.09768442, -0.024710014, 0.10322807, 0.032842994, -0.15724933, -0.18454032, -0.02390276, -0.021784574, 0.015929505, 0.44618633, 0.3092629, 0.11343408, 0.06997572) * conv2d_4_1_texOff(vec2(1, 0));
    result += mat4(0.021179881, 0.03247151, 0.026292978, 0.0051735314, -0.08635175, 0.046521984, 0.008453887, -0.023512052, -0.05742048, -0.010242954, -0.019971563, -0.019001395, 0.058213618, 0.0894563, 0.028324258, 0.017036825) * conv2d_4_1_texOff(vec2(-1, 1));
    result += mat4(0.16187875, 0.059428733, -0.011575559, 0.079413526, -0.31291133, 0.03721217, -0.061725166, -0.0004606492, -0.2154462, 0.23912174, -0.026152378, -0.07183964, 0.72291225, -0.08578942, 0.07202447, 0.11918941) * conv2d_4_1_texOff(vec2(0, 1));
    result += mat4(0.037263725, 0.08655617, 0.025633156, -0.037392396, -0.036254805, 0.097237885, 0.000736203, -0.0074897436, -0.02281841, -0.02823047, -0.013682937, 0.0042696786, 0.063893884, -0.16560422, 0.018981777, -0.03075242) * conv2d_4_1_texOff(vec2(1, 1));
    result += mat4(-0.030512515, -0.14062811, -0.00028358566, 0.05434178, 0.10487504, -0.10655921, -0.022454755, -0.11245248, -0.22988679, -0.013957052, 0.033242017, 0.30757704, 0.15296516, -0.004991719, 0.07405563, -0.041401833) * conv2d_4_2_texOff(vec2(-1, -1));
    result += mat4(0.006912667, 0.046435703, -0.024738714, 0.02576836, 0.11660831, -0.112938136, -0.0823693, 0.056789715, 0.012508529, 0.054217007, -0.09756882, 0.1846172, 0.30575746, -0.24835579, 0.028845549, -0.10909295) * conv2d_4_2_texOff(vec2(0, -1));
    result += mat4(0.0065615964, -0.01006514, -0.031088598, 0.06975595, -0.031854518, -0.0678821, 0.13133197, 0.0659807, 0.025306372, 0.04854298, 0.018680708, -0.022799045, -0.0056311805, 0.023007361, 0.110254556, -0.05062043) * conv2d_4_2_texOff(vec2(1, -1));
    result += mat4(-0.0586441, 0.004390161, -0.00094305887, 0.043951567, -0.105222724, -0.0069213253, -0.046724018, 0.09720702, -0.7986804, -0.6915094, 0.15964006, 0.41028076, 0.045694288, 0.13104492, 0.0019013828, -0.080436245) * conv2d_4_2_texOff(vec2(-1, 0));
    result += mat4(-0.22457233, -0.06028292, 0.015360867, 0.10783317, -0.11009472, 0.02309999, 0.06519778, 0.05550515, 0.16984332, -0.00753768, -0.25339532, 0.16639428, 0.32667893, 0.52505296, -0.29542357, -0.029623816) * conv2d_4_2_texOff(vec2(0, 0));
    result += mat4(-0.14976867, -0.103489116, 0.11772881, 0.029823834, 0.124481365, 0.032951467, -0.0140607115, 0.052572567, -0.008575431, -0.019206066, -0.034908418, 0.016314821, 0.044483814, -0.032880496, -0.10741484, -0.14184819) * conv2d_4_2_texOff(vec2(1, 0));
    result += mat4(0.036616057, 0.031012429, -0.007736401, 0.025544597, 0.030781105, -0.05044406, -0.074159086, -0.022869738, 0.11088957, 0.4671611, -0.0433918, -0.17891024, 0.059569646, 0.13219304, -0.027213413, 0.004930265) * conv2d_4_2_texOff(vec2(-1, 1));
    result += mat4(0.0110268835, -0.16787328, -0.0367127, -0.032555077, -0.044285633, -0.11459858, -0.0996694, -0.07973965, -0.087829545, -0.087584995, 0.047419924, 0.37592712, -0.22941533, -0.23604631, 0.030034043, 0.11473111) * conv2d_4_2_texOff(vec2(0, 1));
    result += mat4(-0.013475902, 0.011221588, -0.032619096, -0.023867419, -0.05961677, -0.100874946, -0.08419209, 0.13437943, -0.04917975, -0.016557503, -0.005626538, 0.05099933, 0.119277515, 0.40966216, 0.12232688, 0.15552276) * conv2d_4_2_texOff(vec2(1, 1));
    result += mat4(-0.17383687, 0.056015685, -0.13457276, -0.094173595, 0.08541814, 0.0802234, -6.863306e-05, 0.06377264, 0.00837476, 0.006046353, -0.0007712417, -0.0714822, -0.0060935486, -0.048998035, -0.012608388, 0.06324709) * conv2d_4_3_texOff(vec2(-1, -1));
    result += mat4(0.2681609, -0.045353588, 0.0019435219, 0.049735688, -0.0086974, -0.16535933, 0.027251042, 0.031339735, -0.0873862, 0.11553186, -0.033854503, -0.024738472, -0.35593885, -0.1095627, -0.09063419, -0.01407064) * conv2d_4_3_texOff(vec2(0, -1));
    result += mat4(-0.16411924, -0.058848083, 0.008341498, -0.027252585, 0.16069295, 0.052778646, 0.014279131, -0.004711519, -0.14813447, -0.085974984, -0.074782446, -0.012456033, -0.17258914, -0.19018906, 0.010064231, 0.030049432) * conv2d_4_3_texOff(vec2(1, -1));
    result += mat4(-0.26517156, -0.0023467026, -0.017345991, -0.015541716, -0.36826465, 0.12569544, -0.09943614, -0.099922866, 0.36723468, -0.15493457, 0.032652047, 0.01431749, -0.058520526, -0.05622772, 0.020992534, 0.09949147) * conv2d_4_3_texOff(vec2(-1, 0));
    result += mat4(-0.011474144, -0.39699376, 0.08601021, 0.030674784, -0.49576348, 0.86384445, -0.24836868, 0.1845064, 0.4399953, -0.6143563, 0.24876258, -0.09418015, 0.2689243, -0.17353937, 0.09236233, 0.0019230074) * conv2d_4_3_texOff(vec2(0, 0));
    result += mat4(0.20494951, 0.042979673, 0.05320085, 0.103428, -0.11671929, 0.043464035, -0.21789098, 0.12439032, 0.14611116, 0.09671864, 0.077389866, -0.107675254, 0.03900112, -0.2192547, 0.14579615, -0.102687955) * conv2d_4_3_texOff(vec2(1, 0));
    result += mat4(0.054881938, 0.15462708, 0.033736564, 0.007717613, 0.12884334, 0.2593043, -0.0820078, 0.015391515, -0.081882976, -0.5672288, 0.04597541, 0.037898924, 0.06655861, -0.13261534, 0.014377042, 0.027393572) * conv2d_4_3_texOff(vec2(-1, 1));
    result += mat4(-0.011002876, 0.017118147, -0.09743599, 0.13069719, -0.00014427115, -0.037537202, 0.024229925, -0.005541604, 0.11016941, -0.01222874, 0.058772508, 0.022410862, 0.008864335, -0.10432079, -0.07631634, -0.11032984) * conv2d_4_3_texOff(vec2(0, 1));
    result += mat4(-0.1325417, -0.26567414, -0.04465557, 0.007787243, 0.0036025965, 0.16317958, 0.02426103, 0.15862551, -0.0657389, -0.18749335, -0.030442923, -0.06585903, -0.02071046, -0.075505026, -0.031514905, -0.16328533) * conv2d_4_3_texOff(vec2(1, 1));
    return result;
}

//!DESC ArtCNN C4F16 (Conv2D-6)
//!HOOK LUMA
//!BIND conv2d_0
//!BIND conv2d_5_0
//!BIND conv2d_1
//!BIND conv2d_5_1
//!BIND conv2d_2
//!BIND conv2d_5_2
//!BIND conv2d_3
//!BIND conv2d_5_3
//!SAVE conv2d_6_0
//!WIDTH LUMA.w
//!HEIGHT LUMA.h
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.10407887, 0.097488195, 0.10222243, 0.093804784);
    result += mat4(-0.06835281, -0.002063394, -0.022099333, -0.026033442, -0.050314296, -0.016407972, -0.045784205, -0.027180335, 0.01664453, 0.027706053, 0.00037955985, 0.014919642, 0.16804579, 0.10516603, 0.06317556, 0.09553988) * (conv2d_5_0_texOff(vec2(-1, -1)) + conv2d_0_texOff(vec2(-1, -1)));
    result += mat4(-0.058651123, -0.10322991, 0.033108298, 0.049048815, 0.037896834, -0.030353548, -0.07552219, 0.0008279127, 0.014969072, -0.11944471, 0.08322254, 0.032955587, -0.0011137993, 0.15025517, 0.044875998, -0.0154070575) * (conv2d_5_0_texOff(vec2(0, -1)) + conv2d_0_texOff(vec2(0, -1)));
    result += mat4(0.014740907, -0.03344216, -0.005187303, -0.015973497, -0.022344043, 0.0036320067, -0.024056677, -0.043564856, -0.022558894, 0.0072227363, -0.0053798654, 0.033077013, 0.09951096, 0.032568347, 0.06065021, 0.017621083) * (conv2d_5_0_texOff(vec2(1, -1)) + conv2d_0_texOff(vec2(1, -1)));
    result += mat4(0.116533905, -0.04702717, -0.021498246, 0.028888393, -0.015240517, -0.09661296, 0.11334122, -0.06900668, -0.0006149282, 0.019744378, 0.0648034, -0.0045407997, 0.1891915, 0.111665405, 0.18197547, 0.12893237) * (conv2d_5_0_texOff(vec2(-1, 0)) + conv2d_0_texOff(vec2(-1, 0)));
    result += mat4(0.078334026, 0.19647937, -0.09797047, -0.14151739, -0.15460385, 0.18850033, -0.113417074, 0.28649488, -0.040615097, 0.053106878, -0.030238735, -0.10792565, 0.22462718, 0.22183172, 0.16417204, 0.27850342) * (conv2d_5_0_texOff(vec2(0, 0)) + conv2d_0_texOff(vec2(0, 0)));
    result += mat4(-0.015012697, 0.0653298, 0.023423247, 0.01139948, 0.05776562, -0.054161124, 0.036692493, -0.08657101, -0.02274633, 0.0038382143, -0.037507214, 0.056437906, 0.16947132, 0.21419731, 0.16919203, 0.25299102) * (conv2d_5_0_texOff(vec2(1, 0)) + conv2d_0_texOff(vec2(1, 0)));
    result += mat4(-0.017424038, -0.00915165, 0.017914575, 0.0034419717, -0.023223912, 0.0003801507, -0.04178879, 0.008838932, 0.027135517, -0.00094580697, 0.024522636, -0.010182268, 0.11034025, 0.0044447402, 0.22051464, -0.01967377) * (conv2d_5_0_texOff(vec2(-1, 1)) + conv2d_0_texOff(vec2(-1, 1)));
    result += mat4(-0.036809247, -0.051307622, 0.060724467, 0.049771257, 0.09627344, 0.04272271, 0.0824909, -0.059083477, -0.008901776, 0.017800098, -0.10009962, 0.062438685, 0.017689763, 0.060293496, 0.056304358, 0.20307289) * (conv2d_5_0_texOff(vec2(0, 1)) + conv2d_0_texOff(vec2(0, 1)));
    result += mat4(-0.008794147, -0.01312082, 0.00038502488, 0.041364476, 0.028236333, 0.0012214257, 0.05478907, 0.01779697, 0.0075119073, 0.0043832855, -0.006697812, -0.059315406, 0.0525951, 0.1467837, 0.07268275, 0.11348895) * (conv2d_5_0_texOff(vec2(1, 1)) + conv2d_0_texOff(vec2(1, 1)));
    result += mat4(-0.119056694, -0.022543164, -0.07450419, -0.06358397, -0.013935535, -0.08291655, 0.051571853, -0.0011709471, -0.015281836, 0.03828021, -0.0017588611, -0.0043239896, 0.032310136, 0.041175902, -0.01145863, 0.013321721) * (conv2d_5_1_texOff(vec2(-1, -1)) + conv2d_1_texOff(vec2(-1, -1)));
    result += mat4(0.051123388, -0.11470685, -0.14948519, 0.011535103, 0.016201288, 0.030134168, 0.13189004, -0.008686041, 0.024683451, -0.0671489, 0.002620998, 0.014376221, 0.011347381, -0.08293654, 0.038315274, 0.01895791) * (conv2d_5_1_texOff(vec2(0, -1)) + conv2d_1_texOff(vec2(0, -1)));
    result += mat4(-0.05877883, 0.05146613, -0.008809841, -0.00023467084, -0.057769608, 0.04823752, -0.008489099, 0.079461046, -0.047325697, 0.04071089, -0.0055320053, 0.029224226, 0.027386462, -0.03374859, 0.008449957, -0.008419715) * (conv2d_5_1_texOff(vec2(1, -1)) + conv2d_1_texOff(vec2(1, -1)));
    result += mat4(-0.08299477, -0.11658955, 0.016633246, -0.07978632, -0.016218217, -0.040943146, -0.03989717, -0.1088446, 0.05970957, 0.002996039, -0.0683301, 0.024432095, -0.06820922, 0.001980743, 0.028680932, 0.013430178) * (conv2d_5_1_texOff(vec2(-1, 0)) + conv2d_1_texOff(vec2(-1, 0)));
    result += mat4(0.18101421, 0.08282674, 0.2537264, 0.09734346, 0.07522589, -0.02970063, -0.09767425, 0.025460964, -0.035719384, 0.05559792, -0.0064279013, 0.012116881, 0.08098515, 0.0031306474, -0.062321458, 0.11275372) * (conv2d_5_1_texOff(vec2(0, 0)) + conv2d_1_texOff(vec2(0, 0)));
    result += mat4(0.044320706, 0.08824085, 0.021322772, 0.04545965, 0.01488218, 0.029095644, -0.02583268, -0.062204227, 0.0055758785, -0.04118161, 0.013441426, 0.042478185, 0.0025955855, 0.009216976, 0.023733752, -0.0064839222) * (conv2d_5_1_texOff(vec2(1, 0)) + conv2d_1_texOff(vec2(1, 0)));
    result += mat4(-0.057003073, -0.004948335, -0.09097062, 0.028371694, 0.0032006286, -0.010899842, -0.025544282, -0.02191108, -0.002089457, -0.021223156, 0.017774016, 0.0036114382, -0.005586188, 0.00097210985, -0.023755005, -0.0026099575) * (conv2d_5_1_texOff(vec2(-1, 1)) + conv2d_1_texOff(vec2(-1, 1)));
    result += mat4(0.024738748, 0.08594153, 0.044601705, -0.06618936, -0.023089156, -0.055568747, 0.12039967, 0.024573393, 0.0043138857, -0.007953558, 0.01810615, -0.05492442, -0.01816249, 0.00072908093, -0.0056789815, -0.09458923) * (conv2d_5_1_texOff(vec2(0, 1)) + conv2d_1_texOff(vec2(0, 1)));
    result += mat4(0.021939186, -0.052361235, 0.024886966, 0.033345256, -0.010785021, -0.016734328, -0.005458673, 0.07150075, 0.02636878, -0.01776455, 0.027917301, -0.065227784, -0.0111764595, -0.01318905, -0.012367057, -0.0014842706) * (conv2d_5_1_texOff(vec2(1, 1)) + conv2d_1_texOff(vec2(1, 1)));
    result += mat4(0.074804254, 0.06033131, 0.016498791, 0.041731995, -0.106456414, -0.08368142, -0.044149056, -0.07546344, 0.010242925, 0.05938359, -0.01986036, -0.0011787905, 0.026373222, -0.0596952, -1.2733392e-05, 0.0039422764) * (conv2d_5_2_texOff(vec2(-1, -1)) + conv2d_2_texOff(vec2(-1, -1)));
    result += mat4(-0.08063825, 0.03961155, 0.029571343, 0.006985256, -0.047977608, 0.018148772, 0.061661065, 0.030361924, 0.048335932, -0.06769777, 0.019014768, 0.023159457, -0.05829801, 0.089001045, 0.036387086, -0.05159357) * (conv2d_5_2_texOff(vec2(0, -1)) + conv2d_2_texOff(vec2(0, -1)));
    result += mat4(0.057754766, -0.059210554, -0.0052746534, -0.043959897, 0.029552294, 0.08530348, 0.03688788, 0.032168314, -0.0094469385, 0.010864346, 0.01230645, 0.022310263, -0.028680464, 0.023207344, -0.011531268, 0.027849229) * (conv2d_5_2_texOff(vec2(1, -1)) + conv2d_2_texOff(vec2(1, -1)));
    result += mat4(0.07223524, 0.13245484, 0.07575535, 0.14125241, -0.1715663, 0.014789027, -0.19799535, -0.004649109, -0.03699584, 0.018164005, -0.027667418, 0.072988145, 0.05391259, -0.041023277, 0.041897837, -0.08607979) * (conv2d_5_2_texOff(vec2(-1, 0)) + conv2d_2_texOff(vec2(-1, 0)));
    result += mat4(-0.05315216, -0.25991043, -0.37482148, -0.32810336, -0.29032516, -0.30709293, -0.21782005, -0.20594645, 0.021311514, -0.025801908, -0.043757193, -0.07257415, -0.0010787555, -0.045824338, -0.021387875, 0.046834607) * (conv2d_5_2_texOff(vec2(0, 0)) + conv2d_2_texOff(vec2(0, 0)));
    result += mat4(-0.11915308, 0.009884257, -0.07266224, -0.04405168, 0.41715345, 0.10101372, 0.39315835, 0.14680335, -0.020571468, -0.020652635, 0.003565338, 0.020705333, -0.01608967, -0.0052673128, 0.0129209785, 0.060481094) * (conv2d_5_2_texOff(vec2(1, 0)) + conv2d_2_texOff(vec2(1, 0)));
    result += mat4(0.048600942, 0.016006557, 0.14600487, 0.014943065, -0.07351269, 0.026039096, -0.14686914, 0.031768322, -0.021506123, -0.0082435515, -0.0040315725, 0.017048223, -0.011135416, 0.016046643, -0.022291226, -0.005355941) * (conv2d_5_2_texOff(vec2(-1, 1)) + conv2d_2_texOff(vec2(-1, 1)));
    result += mat4(0.03020737, -0.030928615, 0.15132327, 0.054301504, 0.14437142, 0.048576567, -0.04388744, -0.094516754, 0.0032813493, 0.06886138, 0.05706457, -0.10108691, 0.044117074, -0.011357271, -0.042508494, -0.031500865) * (conv2d_5_2_texOff(vec2(0, 1)) + conv2d_2_texOff(vec2(0, 1)));
    result += mat4(0.0013166928, 0.05283264, 0.014012323, 0.02144442, 0.07815758, 0.09807069, 0.13815966, 0.12761182, -0.008528952, -0.014925581, -0.00018464374, 0.021329591, -0.0041841166, 0.03558159, 0.0067771603, 0.031306233) * (conv2d_5_2_texOff(vec2(1, 1)) + conv2d_2_texOff(vec2(1, 1)));
    result += mat4(-0.036467843, 0.010628504, -0.040554672, -0.023031462, -0.011656816, 0.006664601, 0.000715375, -0.010816698, 0.015964195, 0.0095756985, 0.03210252, 0.013730381, -0.1255846, -0.084750146, -0.023893569, -0.0702104) * (conv2d_5_3_texOff(vec2(-1, -1)) + conv2d_3_texOff(vec2(-1, -1)));
    result += mat4(0.019619642, -0.07239796, 0.035521567, 0.01588479, 0.016895607, 0.008017878, -0.036764413, -0.0042051054, -0.039567553, -0.08192329, -0.06659581, -0.04689488, -0.03690489, -0.09902329, 0.019497482, 0.034434214) * (conv2d_5_3_texOff(vec2(0, -1)) + conv2d_3_texOff(vec2(0, -1)));
    result += mat4(-0.041379284, 0.028434373, -0.0035548816, 0.03592885, -0.058836915, 0.050493628, -0.019974556, 0.024676299, 0.017982803, 0.057563495, 0.031644262, 0.038482025, -0.062204078, -0.086202905, -0.061478227, -0.046549007) * (conv2d_5_3_texOff(vec2(1, -1)) + conv2d_3_texOff(vec2(1, -1)));
    result += mat4(-0.04963836, -0.06786509, 0.053083368, -0.016658006, -0.024077818, 0.015105817, -0.022783222, 0.056628447, 0.054782975, -0.005399698, 0.06518826, 0.0675087, -0.074367136, 0.008979149, -0.087080844, 0.030584648) * (conv2d_5_3_texOff(vec2(-1, 0)) + conv2d_3_texOff(vec2(-1, 0)));
    result += mat4(0.16213058, 0.23299363, -0.17941494, -0.06208164, 0.10239591, -0.1624446, 0.09645079, -0.07228728, -0.6013088, -0.4676209, -0.4437887, -0.40659645, 0.44956166, 0.37416172, 0.43596986, 0.30689433) * (conv2d_5_3_texOff(vec2(0, 0)) + conv2d_3_texOff(vec2(0, 0)));
    result += mat4(0.016807944, -0.012888657, 0.04107212, -0.009010495, -0.042227447, 0.09315279, -0.077015266, 0.032527108, 0.0949948, 0.024671922, 0.04591782, 0.05770263, -0.15444109, -0.1973537, -0.14419502, -0.22791274) * (conv2d_5_3_texOff(vec2(1, 0)) + conv2d_3_texOff(vec2(1, 0)));
    result += mat4(-0.011289618, -0.006634459, -0.03459251, -0.0040621534, -0.02159817, 0.01215381, -0.014932253, 0.014672571, 0.07710989, 0.047235463, 0.2077591, 0.05189555, -0.05911496, 0.025979709, -0.08420764, 0.033720285) * (conv2d_5_3_texOff(vec2(-1, 1)) + conv2d_3_texOff(vec2(-1, 1)));
    result += mat4(-0.016286368, -0.032828875, 0.06081085, 0.013333209, 0.032717485, -0.009975731, 0.06256336, -0.07011423, 0.18836606, 0.19341387, 0.041098244, 0.17084116, 0.1576518, 0.051604636, 0.08421867, -0.038016967) * (conv2d_5_3_texOff(vec2(0, 1)) + conv2d_3_texOff(vec2(0, 1)));
    result += mat4(0.0031298443, -0.019852508, 0.0062795323, 0.0041221846, -0.004355593, -0.0068010245, -0.0009176121, 0.04547178, 0.078382626, 0.16177154, 0.114449784, 0.14651902, -0.028394928, -0.027341096, -0.037729453, -0.05235737) * (conv2d_5_3_texOff(vec2(1, 1)) + conv2d_3_texOff(vec2(1, 1)));
    return result;
}

//!DESC ArtCNN C4F16 (Depth-To-Space)
//!HOOK LUMA
//!BIND conv2d_6_0
//!WIDTH LUMA.w 2.0 *
//!HEIGHT LUMA.h 2.0 *
//!COMPONENTS 4
//!WHEN OUTPUT.w LUMA.w / 1.3 > OUTPUT.h LUMA.h / 1.3 > *

vec4 hook() {
    vec4 result = vec4(0.0, 0.0, 0.0, 1.0);
    vec2 f0 = fract(conv2d_6_0_pos * conv2d_6_0_size);
    ivec2 i0 = ivec2(f0 * vec2(2.0));
    result.x = conv2d_6_0_tex((vec2(0.5) - f0) * conv2d_6_0_pt + conv2d_6_0_pos)[i0.y * 2 + i0.x];
    return clamp(result, 0.0, 1.0);
}

